/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.reports.web.client.internal.ReportClient");

dojo.require("com.ibm.team.process.web.client.projectarea");
dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");

(function() { //module container

var getCurrentPA            = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
var ServiceRequest 			= com.ibm.team.repository.web.transport.ServiceRequest;
var TeamServerClient 		= com.ibm.team.repository.web.transport.TeamServerClient;

com.ibm.rqm.reports.web.client.internal.ReportClient = {


	REPORT_SERVICE_URI: "com.ibm.rqm.reports.common.service.rest.IReportRestService",

    ATTACHMENT_TYPE_HEADER: "header",
	ATTACHMENT_TYPE_FOOTER: "footer",

	_invokeService: function(responseHandler, method, args) {
		var serviceRequest= new ServiceRequest(this.REPORT_SERVICE_URI, method, args);
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	},

    getAttachment: function(serviceResponseHandler, args) {
        if (!args.processArea) {
			args.processArea = getCurrentPA().itemId;
		}
        this._invokeService(serviceResponseHandler, "getAttachment", args);
    },
	
	getHeaderAttachment: function(serviceResponseHandler) {
		var args = {
			processArea: getCurrentPA().itemId,
			attachmentType: this.ATTACHMENT_TYPE_HEADER
		}
		this._invokeService(serviceResponseHandler, "getAttachment", args);
	},
	
    getFooterAttachment: function(serviceResponseHandler) {
        var args = {
            processArea: getCurrentPA().itemId,
            attachmentType: this.ATTACHMENT_TYPE_FOOTER
        }
        this._invokeService(serviceResponseHandler, "getAttachment", args);
    },	

    setAttachment: function(serviceResponseHandler, type, itemId) {
        var args = {
            processArea: getCurrentPA().itemId,
			attachmentType: type,
			attachmentItemId: itemId
        }
        this._invokeService(serviceResponseHandler, "postSetAttachment", args);
    },
    
    setHeaderAttachment: function(serviceResponseHandler, itemId) {
        var args = {
            processArea: getCurrentPA().itemId,
            attachmentType: this.ATTACHMENT_TYPE_HEADER,
			attachmentItemId: itemId
        }
        this._invokeService(serviceResponseHandler, "postSetAttachment", args);
    },
    
    setFooterAttachment: function(serviceResponseHandler, itemId) {
        var args = {
            processArea: getCurrentPA().itemId,
            attachmentType: this.ATTACHMENT_TYPE_FOOTER,
			attachmentItemId: itemId
        }
        this._invokeService(serviceResponseHandler, "postSetAttachment", args);
    },
		
    resetAttachment: function(serviceResponseHandler, args) {
        if (!args.processArea) {
            args.processArea = getCurrentPA().itemId;
        }
        this._invokeService(serviceResponseHandler, "postResetAttachment", args);
    },
    
    resetHeaderAttachment: function(serviceResponseHandler) {
        var args = {
            processArea: getCurrentPA().itemId,
            attachmentType: this.ATTACHMENT_TYPE_HEADER
        }
        this._invokeService(serviceResponseHandler, "postResetAttachment", args);
    },
    
    resetFooterAttachment: function(serviceResponseHandler) {
        var args = {
            processArea: getCurrentPA().itemId,
            attachmentType: this.ATTACHMENT_TYPE_FOOTER
        }
        this._invokeService(serviceResponseHandler, "postResetAttachment", args);
    }
};

})();
