/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.client.internal.UserClient");

dojo.require("com.ibm.team.process.web.client.projectarea");
dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");

(function() { //module container

var ServiceRequest 			= com.ibm.team.repository.web.transport.ServiceRequest;
var getCurrentPA            = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
var TeamServerClient 		= com.ibm.team.repository.web.transport.TeamServerClient;

com.ibm.rqm.planning.web.client.internal.UserClient = {
    
	PROCESS_SERVICE_URI: "com.ibm.rqm.planning.common.service.rest.IQMContributorRestService",
	
	_invokeService: function(responseHandler, method, args) {
		if (args && !args.processAreaUUID) {
			args.processAreaUUID = getCurrentPA().itemId;
		}
		var serviceRequest= new ServiceRequest(this.PROCESS_SERVICE_URI, method, args);
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	},
	
    getContributors: function(responseHandler)
    {
		var args = {};
		return this._invokeService(responseHandler, "getContributors", args);
	},
	
	getMembers: function(responseHandler)
    {
		var args = {};
		return this._invokeService(responseHandler, "getMembers", args);
	}	
};

})();
