/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
/*
 *   This class is specific to contributorLists.
 */
//xojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.provide("com.ibm.rational.test.lm.web.client.internal.contributorList");
dojo.declare("com.ibm.rational.test.lm.web.client.internal.contributorList", null, 
        
        
    {
        constructor: function(){
            this.setServiceInterface('com.ibm.rational.test.lm.common.IContributorListRestService');
        },
        
        setServiceInterface: function(serviceInterface){
            this.serviceInterface = serviceInterface;
        },
        
        _invokeService : function (responseHandler, method, args) {
            var myServiceRequest=
                new com.ibm.team.repository.web.transport.ServiceRequest(
                    this.serviceInterface,
                    method, 
                    args);
                            
            com.ibm.team.repository.web.transport.TeamServerClient.invokeService(
                myServiceRequest, responseHandler );
        
        },
        
        //
        // Get the preferences for a user
        // Parameters: responseHandler
        //             projectAreaId - UUID of the project
        getContributorListForUser: function( responseHandler, projectAreaId, listName ){
            var attributes = { "projectAreaItemId": projectAreaId,
			                   "listName": listName };
            return this._invokeService(responseHandler, "getContributorList", attributes);
        },
        
        //
        // Save the ContributorList for a user
        // Parameters: responseHandler
        //             optionId - id of the option to update, null if this is a new option
        //             projectAreaId - UUID of the project
        //             contributorIds - an array of contributor ids the will make up the list.
        saveContributorListForUser: function( responseHandler, projectAreaId, listName, contributorIds ){
            if(projectAreaId == null){
                throw new Error("Must provide a projectAreaId.");
            }
            var attributes = {
				"projectAreaItemId": projectAreaId,
				"listName": listName
			};
            if(contributorIds != null) {
				attributes.contributorIds = contributorIds;
		    }
            return this._invokeService(responseHandler, "postContributorList", attributes);
        }
        
    }
);
