/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.page.TestPageView");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");

dojo.require("net.jazz.ajax.ui.PlatformUI");

dojo.require("com.ibm.rqm.planning.web.ui.internal.page.TestPageController");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.SortableFilterableTable");

(function()
{
	var PlatformUI					= net.jazz.ajax.ui.PlatformUI;
	var ActionRegistry				= null; // initialize later
//	var SortableFilterableTable		= com.ibm.rqm.planning.web.ui.internal.view.common.SortableFilterableTable;

	function getWorkbench()
	{
		return net.jazz.ajax.ui.PlatformUI.getWorkbench();
	}
	
	dojo.declare( "com.ibm.rqm.planning.web.ui.internal.page.TestPageView",
				  [dijit._Widget, dijit._Templated],
	{
		templateString: "<div class=\"com-ibm-rqm-test-test-page\"></div>",
		
		/*
		 * Required by Jazz web framework to make hyperlinking and back/forward
		 * work.
		 */
		getController: function()
		{
			return (this.controller);
		},
		
		/*
		 * Called by Dojo during widget creation lifecycle.
		 */
		postCreate: function()
		{
		 	this.controller = new com.ibm.rqm.planning.web.ui.internal.page.TestPageController(this);

			// lazily initialize the ActionRegistry alias
			ActionRegistry = PlatformUI.getWorkbench().getActionRegistry();
			
			// register actions
//			ActionRegistry.registerAction("com.ibm.rqm.planning.web.defaultView", this, "showPage");
			ActionRegistry.registerAction("com.ibm.rqm.planning.web.defaultView", this.controller, "defaultView");

//			var validActions = ["search", "simpleQuery", "runSavedQuery", "runNewQuery", "newQuery", "editQuery", "newWorkItem", "viewWorkItem" ];
//			var self = this;
//			dojo.forEach(validActions,
//				function(x) {
//					ActionRegistry.registerAction("com.ibm.rqm.planning.web." + x, self.controller, x); 
//				}
//			);
		},
		
		showPage: function(args)
		{
			var title = "Hello world!";
			getWorkbench().setTitle(title);
			
			dojox.data.dom.removeChildren(this.domNode);
			var anchor = document.createElement("a");
			
			anchor.href = "https://" + document.location.hostname + ":9443" + document.location.pathname;
			anchor.appendChild(document.createTextNode(title));
			
			dojo.connect(anchor, "onclick", null, function(e)
			{
				e.preventDefault();
				window.location.href = "https://" + window.location.hostname + ":9443" + window.location.pathname + window.location.search + window.location.hash;
			});

			this.domNode.appendChild(anchor);
			
			var listArgs = { 
				parentController: this.controller, 
				maxRows: 20,
				rangeStart: 1,
				isFilterable: true, 
				showQuery: true, 
				queryTitle: this._currentView, 
				runQueryHref: "#", 
				isQueryEditable: false, 
//				editQueryHref: "#",
				showFooter: true,
				sortColumn: 0, // score
				sortDirection: SortableFilterableTable.SORT_DSC,
				isDeleteColumn: true,
//				isMultiselect: true,
				isRowSelectable: true };

			var sfTable = new com.ibm.rqm.planning.web.ui.internal.view.common.SortableFilterableTable();
			sfTable.initialize(listArgs);

			sfTable.addColumn( {title: "Score (%)", isSortable: true, includeInFilter: false, width: "11%" });				
			sfTable.addColumn( {title: "Name", isSortable: false, includeInFilter: true, width: "44%"  });				
			sfTable.addColumn( {title: "Type", isSortable: true, includeInFilter: false, width: "15%"  });				
			sfTable.addColumn( {title: "Details", isSortable: false, includeInFilter: true, width: "30%"  });

			var results = ["craig", "sachin", "mike", "dave", "john"];

			if (results != null)
			{
				for (var i=0; i < results.length; i++)
				{
					sfTable.addRow( {href: "", 
//								  removeParms: {obj: this, parm: results[i].name},
//								  removeMethod: this.removeArtifact, 
								  elements: [
					                         {type: SortableFilterableTable.TYPE_NUM, data: i, image: "", tooltip: "", isLink: false, href: null}, 
									         {type: SortableFilterableTable.TYPE_STRING, data: ("row" + i), image: null, tooltip: "", isLink: true, href: ""}, 
								  			 {type: SortableFilterableTable.TYPE_STRING, data: "type", image: "", tooltip: "", isLink: false}, 
											 {type: SortableFilterableTable.TYPE_STRING, data: results[i], image: "", tooltip: "", isLink: false}
											]});
				}				
			}

			this.domNode.appendChild(sfTable.domNode);
			sfTable.displayTable();
		}
		
	}	// dojo.declare
	);
}
)();
