/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.page.analysis.AnalysisPageView");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("net.jazz.ajax.ui.PlatformUI");

dojo.require("com.ibm.rqm.planning.web.ui.internal.page.analysis.AnalysisPageController");

(function() {
	
	var PlatformUI			= net.jazz.ajax.ui.PlatformUI;
	var ActionRegistry		= null;
	
	dojo.declare("com.ibm.rqm.planning.web.ui.internal.page.analysis.AnalysisPageView",
		[dijit._Widget, dijit._Templated],    
	{      
		controller: null,      
		templatePath: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/page/templates/analysis/AnalysisPageView.html"),
		_actions: ["showAnalysis"],	
		
		// initialization      
		postCreate: function() {	
			this.controller = new com.ibm.rqm.planning.web.ui.internal.page.analysis.AnalysisPageController(this);  
			
			// lazily initialize the ActionRegistry alias
			ActionRegistry = PlatformUI.getWorkbench().getActionRegistry();

			// register actions			
			for (var i = 0; i < this._actions.length; i++) {
				var actionName = this._actions[i];
		        ActionRegistry.registerAction("com.ibm.rqm.analysis." + actionName, this.controller, actionName);
			}			
		}
	});
})();
