/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.page.construction.ConstructionPageView");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.team.repository.web.client.session.Session");

// Require the controller widget
dojo.require("com.ibm.rqm.planning.web.ui.internal.page.construction.ConstructionPageController");

// Require the repository widget needed to show the two column layout
dojo.require("net.jazz.ajax.ui.PlatformUI");

// Require the local widgets
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");

dojo.require("com.ibm.rqm.planning.web.client.internal.construction.TestCaseClient");

dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.QueryNavigator");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.RecentItemsNavigator");

dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.TestPlanTableView");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.TestCaseTableView");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.TestScriptTableView");

dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.SideActionPanel");
//xojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.ImportScriptWizardPage");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.planning.SearchNavWidget");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.planning.HelpNavWidget");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ListNavigator");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.NavSectionGroup");

//MSB: hack - these are circular dependencies and need to be removed !
//xojo.require("com.ibm.rqm.execution.web.ui.internal.view.execution.EWIList");
//xojo.require("com.ibm.rqm.execution.web.ui.internal.view.execution.CreateExecutionWorkItem");

dojo.require("com.ibm.rqm.planning.web.ui.internal.view.planning.TestPlanEditor");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.TestCaseEditor");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.TestGroupEditor");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.TestScriptEditor");

(function() {

var ServiceResponseHandler		= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var PlatformUI				    = net.jazz.ajax.ui.PlatformUI;
var ActionRegistry			    = null; // initialize later
var getAuthenticatedContributor	= com.ibm.team.repository.web.client.session.getAuthenticatedContributor;

var TestScriptClient		    = com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient;

var Constants     			    = com.ibm.rqm.planning.web.client.internal.Constants;
var Utility				        = com.ibm.rqm.planning.web.ui.internal.util.Utility;
var ImageCache				    = com.ibm.rqm.planning.web.ui.internal.view.common.ImageCache;

var TestPlanTableView            = com.ibm.rqm.planning.web.ui.internal.view.table.TestPlanTableView;
var TestCaseTableView            = com.ibm.rqm.planning.web.ui.internal.view.table.TestCaseTableView;
var TestScriptTableView          = com.ibm.rqm.planning.web.ui.internal.view.table.TestScriptTableView;

// This page view is not longer used, so don't abstract String to messages.js
var STR_CREATE_TITLE       = "Create";
var STR_CREATE_TEST_PLAN   = "New Test Plan";
var STR_CREATE_TEST_GROUP  = "New Test Case Group";
var STR_CREATE_TEST_CASE   = "New Test Case";
var STR_CREATE_TEST_SCRIPT = "New Test Script"
var STR_CREATE_EWI         = "New Test Execution Record";		// CML: term
var STR_IMPORT_SCRIPTS     = "Import Scripts";
var STR_IMPORT_SCRIPTS_TITLE	="Import Rational Functional Tester Scripts"
var STR_EWI_TITLE   = "Test Execution Record Views";			// CML: term
var STR_EWI_MY_EWIS = "My Test Execution Records";				// CML: term

var STR_PLAN_TITLE    = "Test Plan Views";
var STR_PLAN_MY_PLANS = "My Test Plans";

var STR_CASE_TITLE    = "Test Case Views";
var STR_CASE_MY_CASES = "My Test Cases";
var STR_CASE_DUMMY    = "Unassigned Test Cases";

var STR_SCRIPT_TITLE     = "Test Scripts View";
var STR_SCRIPT_MY_SCRIPTS = "My Test Scripts";

var STR_GROUP_TITLE     = "Test Case Group View";
var STR_GROUP_MY_GROUPS = "My Test Case Groups";

var NO_SECTION         = 0;
var CREATE_SECTION     = 1;
var TEST_PLAN_SECTION  = 2;
var EWI_SECTION        = 3;
var TEST_CASE_SECTION  = 4;
var TEST_GROUP_SECTION = 5;
var TEST_SCRIPT_SECTION = 6;

dojo.declare(
	"com.ibm.rqm.planning.web.ui.internal.page.construction.ConstructionPageView",
	[dijit._Widget, dijit._Templated],
	{		
		templatePath: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/page/templates/construction/ConstructionPageView.html"),
			 	
		constructor: function(constructionView) {
			this._scripts = [];
			this._currentQuery = null;
		},				

		_actions: [ "defaultAction", 
				"viewTestPlans", "viewTestPlan", "copyTestPlan",
				"newEwi", "viewEwi", "viewEwis", 
				"newTestGroup", "viewTestGroup", "copyTestGroup", "viewTestGroups", 
				"newTestCase", "viewTestCase", "copyTestCase", "viewTestCases",
         	"newTestScript", "viewTestScript", "viewTestScripts", "importScripts" ],
					 		
		// initialization
		postCreate: function() {
			//alert("ConstructionPageView: postCreate");
			this.controller = new com.ibm.rqm.planning.web.ui.internal.page.construction.ConstructionPageController(this);
			this._mainView = new com.ibm.rqm.planning.web.ui.internal.view.common.SideActionPanel();
//			this._mainView = new net.jazz.ajax.ui.SideNavigationLayout();
			this._pageContainer.appendChild(this._mainView.domNode);

			this.parentController = this._mainView.controller;
		 	this.controller.parentController = this._mainView.controller;
		 	this.controller.prototype = this._mainView.controller;
	
			this._initializeNavigation( { parentController: this.controller } );			
			
			//lazily initialize the ActionRegistry alias
			ActionRegistry = PlatformUI.getWorkbench().getActionRegistry();
						
			// register actions			
			for (var i = 0; i < this._actions.length; i++) {
				var actionName = this._actions[i];
		        ActionRegistry.registerAction("com.ibm.rqm.planning.construction." + actionName, this.controller, actionName);
			}

		},			
							
		_initializeNavigation: function(args) {
			// add in search widget 
			this._searchNavWidget = new com.ibm.rqm.planning.web.ui.internal.view.planning.SearchNavWidget(args);
			this._mainView.addNavigationSection(this._searchNavWidget.domNode, "");
			
			// add in the help widget
			args.cshelpid = "rqm_construction_panel.html";
			this._helpNavWidget = new com.ibm.rqm.planning.web.ui.internal.view.planning.HelpNavWidget(args);
			this._mainView.addNavigationSection(this._helpNavWidget.domNode, "");

			this._navWidgetList = [];

			args.bold = true;
			this._createNavWidget = new com.ibm.rqm.planning.web.ui.internal.view.common.ListNavigator(args);

			this._createNavWidget.addEntry({ name: STR_CREATE_TEST_GROUP, href: Utility.getNewTestGroupURI(STR_CREATE_TEST_GROUP, Utility.CONSTRUCTION_PERSPECTIVE), isUnique: true});
			this._createNavWidget.addEntry({ name: STR_CREATE_TEST_CASE, href: Utility.getNewTestCaseURI(STR_CREATE_TEST_CASE), isUnique: true});
			this._createNavWidget.addEntry({ name: STR_CREATE_TEST_SCRIPT, href: Utility.getNewTestScriptURI(STR_CREATE_TEST_SCRIPT), isUnique: true});
			this._createNavWidget.addEntry({ name: STR_CREATE_EWI, href: Utility.getNewEwiURI(STR_CREATE_EWI), isUnique: true});
			this._createNavWidget.addEntry({ name: STR_IMPORT_SCRIPTS, href: Utility.getImportScriptURI(STR_IMPORT_SCRIPTS_TITLE, Utility.CONSTRUCTION_PERSPECTIVE), isUnique: true});

			var sectionArray = [];
			sectionArray.push(this._createNavWidget);
			this._createNavSection = new com.ibm.rqm.planning.web.ui.internal.view.common.NavSectionGroup({label: STR_CREATE_TITLE, sectionWidgets: sectionArray, open: true});
			
			this._mainView.addNavigationSection(this._createNavSection.domNode, "");
			this._navWidgetList.push(this._createNavWidget);

			args.bold = false;
			this._plansNavWidget = new com.ibm.rqm.planning.web.ui.internal.view.common.ListNavigator(args);
			this._plansNavWidget.addEntry({ name: STR_PLAN_MY_PLANS, href: Utility.getTestPlansURI(STR_PLAN_MY_PLANS, Utility.CONSTRUCTION_PERSPECTIVE)});
			sectionArray = [];
			sectionArray.push(this._plansNavWidget);
			this._plansNavSection = new com.ibm.rqm.planning.web.ui.internal.view.common.NavSectionGroup({label: STR_PLAN_TITLE, sectionWidgets: sectionArray, open: true});

			this._mainView.addNavigationSection(this._plansNavSection.domNode, "");
			this._navWidgetList.push(this._plansNavWidget);
			
			args.bold = false;
			this._groupsNavWidget = new com.ibm.rqm.planning.web.ui.internal.view.common.ListNavigator(args);
			this._groupsNavWidget.addEntry({ name: STR_GROUP_MY_GROUPS, href: Utility.getTestGroupsURI(STR_GROUP_MY_GROUPS, Utility.CONSTRUCTION_PERSPECTIVE)});

			sectionArray = [];
			sectionArray.push(this._groupsNavWidget);
			this._groupsNavSection = new com.ibm.rqm.planning.web.ui.internal.view.common.NavSectionGroup({label: STR_GROUP_TITLE, sectionWidgets: sectionArray, open: true});

			this._mainView.addNavigationSection(this._groupsNavSection.domNode, "");
			this._navWidgetList.push(this._groupsNavWidget);

			args.bold = false;
			this._casesNavWidget = new com.ibm.rqm.planning.web.ui.internal.view.common.ListNavigator(args);
			this._casesNavWidget.addEntry({ name: STR_CASE_MY_CASES, href: Utility.getTestCasesURI(STR_CASE_MY_CASES)});
			this._casesNavWidget.addEntry({ name: STR_CASE_DUMMY, href: Utility.getTestCasesURI(STR_CASE_DUMMY)});		

			sectionArray = [];
			sectionArray.push(this._casesNavWidget);
			this._casesNavSection = new com.ibm.rqm.planning.web.ui.internal.view.common.NavSectionGroup({label: STR_CASE_TITLE, sectionWidgets: sectionArray, open: true});

			this._mainView.addNavigationSection(this._casesNavSection.domNode, "");
			this._navWidgetList.push(this._casesNavWidget);

			args.bold = false;
			this._scriptsNavWidget = new com.ibm.rqm.planning.web.ui.internal.view.common.ListNavigator(args);
			this._scriptsNavWidget.addEntry({ name: STR_SCRIPT_MY_SCRIPTS, href: Utility.getTestScriptsURI(STR_SCRIPT_MY_SCRIPTS)});

			sectionArray = [];
			sectionArray.push(this._scriptsNavWidget);
			this._scriptsNavSection = new com.ibm.rqm.planning.web.ui.internal.view.common.NavSectionGroup({label: STR_SCRIPT_TITLE, sectionWidgets: sectionArray, open: true});

			this._mainView.addNavigationSection(this._scriptsNavSection.domNode, "");
			this._navWidgetList.push(this._scriptsNavWidget);

			args.bold = false;
			this._ewiNavWidget = new com.ibm.rqm.planning.web.ui.internal.view.common.ListNavigator(args);
			this._ewiNavWidget.addEntry({ name: STR_EWI_MY_EWIS, href: Utility.getEwisURI(STR_EWI_MY_EWIS)});

			sectionArray = [];
			sectionArray.push(this._ewiNavWidget);
			this._ewiNavSection = new com.ibm.rqm.planning.web.ui.internal.view.common.NavSectionGroup({label: STR_EWI_TITLE, sectionWidgets: sectionArray, open: true});

			this._mainView.addNavigationSection(this._ewiNavSection.domNode, "");
			this._navWidgetList.push(this._ewiNavWidget);
		},
		
		_deselectPrevious: function(widget)
		{
			for(var i=0;i<this._navWidgetList.length;i++)
			{
				if(!(this._navWidgetList[i] === widget))
				{
					this._navWidgetList[i].selectEntry("");
				}
			}	
		},

			/* 
			 * TEST CASE ACTIONS
			 */	
//			showTestCase: function(name)
//			{
//				this._deselectPrevious(this._casesNavWidget);
//				this._casesNavWidget.selectEntry(name);
//				
//			},
				
			showTestPlan: function(plan)
			{
//				dojox.data.dom.removeChildren(this._planBody);
				this._deselectPrevious(this._plansNavWidget);

				this.editor = new com.ibm.rqm.planning.web.ui.internal.view.planning.TestPlanEditor();
				this._mainView.setMainContent(this.editor.domNode);	
				this.editor.initialize({ parentController: this.controller, plan: plan });
			},
			
			copyTestPlan: function(plan)
			{
				this._deselectPrevious(this._plansNavWidget);

				this.editor = new com.ibm.rqm.planning.web.ui.internal.view.planning.TestPlanEditor();
				this._mainView.setMainContent(this.editor.domNode);	
				this.editor.initialize({ parentController: this.controller, plan: plan, isCopy: true });
			},

         showTestPlanList: function(plans, name) 
         {
            this._currentView = name;
            this._planTableViewer = new TestPlanTableView({plans: plans, queryName: this._currentView});
            this._mainView.setMainContent(this._planTableViewer.domNode);
         }, 
			
         showTestCaseList: function(cases, name)
         {
            this._currentView = name;
            this._caseTableViewer = new TestCaseTableView({testCases: cases, queryName: this._currentView});
            this._mainView.setMainContent(this._caseTableViewer.domNode);            
         }, 
			
         /*
			showTestPlanList: function(plans, name) 
			{
				this._deselectPrevious(this._plansNavWidget);
				this._plansNavWidget.selectEntry(name);
				this._currentViewSelection = name;
				this._currentViewSection = TEST_PLAN_SECTION;

//				dojox.data.dom.removeChildren(this._planBody);
				this._plans = plans;
				this._currentView = name;
				var listArgs = { 
					parentController: this.controller, 
					maxRows: 20,
					rangeStart: 1,
					isFilterable: true, 
					showQuery: true, 
					queryTitle: this._currentView, 
					runQueryHref: "#", 
					isQueryEditable: false, 
					editQueryHref: "#",
					showFooter: true,
					sortColumn: 4, // last modified
					sortDirection: SortableFilterableTable.SORT_ASC,
					isDeleteColumn: true,
//					isMultiselect: true,
					isRowSelectable: true };
																				 
				this._planTable = new com.ibm.rqm.planning.web.ui.internal.view.common.SortableFilterableTable();
				this._planTable.initialize(listArgs);

				this._planTable.addColumn( {title: "Type", isSortable: false, includeInFilter: false, width: "8%" });				
				this._planTable.addColumn( {title: "Id", isSortable: true, includeInFilter: true, width: "5%"  });				
				this._planTable.addColumn( {title: "Name", isSortable: false, includeInFilter: true, width: "47%"  });				
				this._planTable.addColumn( {title: "State", isSortable: true, includeInFilter: false, width: "15%"  });
				this._planTable.addColumn( {title: "Last Modified", isSortable: true, includeInFilter: false, width: "25%"  });				
				
				if (this._plans != null)
				{
					for (var i=0; i < this._plans.length; i++)
					{
						var id = new Number(this._plans[i].id).valueOf();
						
						this._planTable.addRow( {href: Utility.getTestPlanURI({id: this._plans[i].id}, Utility.CONSTRUCTION_PERSPECTIVE), 
									  removeParms: {obj: this, parm: id},
									  removeMethod: this.removeTestPlan, 
									  elements: [
									  			 {type: SortableFilterableTable.TYPE_ICON, data: "", image: ImageCache.TEST_PLAN, tooltip: "Test Plan", isLink: false}, 
		  					                     {type: SortableFilterableTable.TYPE_NUM, data: id, image: "", tooltip: "", isLink: true, href: Utility.getTestPlanURI({id: this._plans[i].id})}, 
										         {type: SortableFilterableTable.TYPE_STRING, data: this._plans[i].name, image: "", tooltip: "", isLink: true, href: Utility.getTestPlanURI({id: this._plans[i].id})}, 
												 {type: SortableFilterableTable.TYPE_STRING, data: this._plans[i].state, image: "", tooltip: "", isLink: false},
												 {type: SortableFilterableTable.TYPE_DATE, data: this._plans[i].modified, image: "", tooltip: "", isLink: false} 
												]});
					}				
				}

//				this._planBody.appendChild(this._planTable.domNode);
				this._mainView.setMainContent( this._planTable.domNode );
				this._planTable.displayTable();
			},		

			showTestCaseList: function(cases, name)
			{
				this._deselectPrevious(this._casesNavWidget);
				this._casesNavWidget.selectEntry(name);
				this._currentViewSelection = name;
				this._currentViewSection = TEST_CASE_SECTION;
				
//				this._bodyWidget.showTestCaseList(cases, name);
//				dojox.data.dom.removeChildren(this._planBody);
				this._currentView = name;
				var listArgs = { 
					parentController: this.controller, 
					maxRows: 10,
					rangeStart: 1,
					isFilterable: true, 
					showQuery: true, 
					queryTitle: this._currentView, 
					runQueryHref: "#", 
					isQueryEditable: false, 
					editQueryHref: "#",
					showFooter: true,
					sortColumn: 5, // last modified
					sortDirection: SortableFilterableTable.SORT_ASC,
//					isMultiselect: true,
					isDeleteColumn: true,
					isRowSelectable: true };
																				 
				this._caseTable = new com.ibm.rqm.planning.web.ui.internal.view.common.SortableFilterableTable();
				this._caseTable.initialize(listArgs);
				
//				this._caseTable.addColumn( {title: "Select", isSortable: false, includeInFilter: false, width: "8%" });				
				this._caseTable.addColumn( {title: "Type", isSortable: false, includeInFilter: false, width: "8%" });				
				this._caseTable.addColumn( {title: "Id", isSortable: true, includeInFilter: true, width: "5%"  });				
				this._caseTable.addColumn( {title: "Name", isSortable: false, includeInFilter: true, width: "52%"  });				
				this._caseTable.addColumn( {title: "Status", isSortable: true, includeInFilter: false, width: "10%"  });
				this._caseTable.addColumn( {title: "Weight", isSortable: true, includeInFilter: false, width: "10%"  });
				this._caseTable.addColumn( {title: "Last Modified", isSortable: true, includeInFilter: false, width: "15%"  });				
				
				if (cases != null)
				{
					for (var i=0; i<cases.length; i++)
					{
						var id = new Number(cases[i].id).valueOf();
//						var select = [{id: 1, displayName: "One"}, {id: 2, displayName: "Two"}];
						var elementHref = Utility.getTestCaseURI(cases[i].id);
						this._caseTable.addRow( {href: elementHref, 
									  removeParms: {obj: this, parm: id},
									  removeMethod: this.removeTestCase, 						
									  elements: [
//									  			 {type: SortableFilterableTable.TYPE_SELECT, data: select, image: "", tooltip: "", isLink: false},
									  			 {type: SortableFilterableTable.TYPE_ICON, data: "", image: ImageCache.TEST_CASE, tooltip: "Test Case", isLink: false}, 
						                   {type: SortableFilterableTable.TYPE_NUM, data: id, image: "", tooltip: "", isLink: true, href: elementHref}, 
										       {type: SortableFilterableTable.TYPE_STRING, data: cases[i].name, image: "", tooltip: "", isLink: true, href: elementHref}, 
												 {type: SortableFilterableTable.TYPE_STRING, data: cases[i].state, image: "", tooltip: "", isLink: false},
												 {type: SortableFilterableTable.TYPE_NUM, data: cases[i].weight, image: "", tooltip: "", isLink: false},
												 {type: SortableFilterableTable.TYPE_DATE, data: cases[i].modified, image: "", tooltip: "", isLink: false} 
												]});
					}				
				}
				
				c this._caseTable.domNode );
				this._caseTable.displayTable();
			},
			*/
				
			showNewTestCase: function(name)
			{
				this._deselectPrevious(this._createNavWidget);
				this._createNavWidget.selectEntry(name);
				
//				this._bodyWidget.newTestCase();				
				this.editor = new com.ibm.rqm.planning.web.ui.internal.view.construction.TestCaseEditor();
				this._mainView.setMainContent(this.editor.domNode);
				this.editor.initialize({ parentController: this.controller });
					
			},
				
			showTestCase: function(testCase)
			{
				this._deselectPrevious(this._groupsNavWidget);
//				this._bodyWidget.showTestCase(testCase);				
				this.editor = new com.ibm.rqm.planning.web.ui.internal.view.construction.TestCaseEditor();				
				this._mainView.setMainContent(this.editor.domNode);
				this.editor.initialize({ parentController: this.controller, testCase: testCase});
			},			

			copyTestCase: function(testCase)
			{
				this._deselectPrevious(this._groupsNavWidget);
//				this._bodyWidget.copyTestCase(testCase);				
				this.editor = new com.ibm.rqm.planning.web.ui.internal.view.construction.TestCaseEditor();				
				this._mainView.setMainContent(this.editor.domNode);
				this.editor.initialize({ parentController: this.controller, testCase: testCase, isCopy: true});
			},
						
			/* 
			 * TEST GROUP ACTIONS
			 */				 
			showTestGroup: function(testGroup)
			{
				this._deselectPrevious(this._groupsNavWidget);
//				this._bodyWidget.showTestGroup(testGroup);				
				this.editor = new com.ibm.rqm.planning.web.ui.internal.view.construction.TestGroupEditor();
				this._mainView.setMainContent(this.editor.domNode);	
				this.editor.initialize({ parentController: this.controller, testGroup: testGroup});
			},
				
			copyTestGroup: function(testGroup)
			{
				this._deselectPrevious(this._groupsNavWidget);
//				this._bodyWidget.copyTestGroup(testGroup);
				this.editor = new com.ibm.rqm.planning.web.ui.internal.view.construction.TestGroupEditor();
				this._mainView.setMainContent(this.editor.domNode);	
				this.editor.initialize({ parentController: this.controller, testGroup: testGroup, isCopy: true});
			},
			/*
			showTestGroupList: function(groups, name)
			{
				name = STR_GROUP_MY_GROUPS;
				this._deselectPrevious(this._groupsNavWidget);
				this._groupsNavWidget.selectEntry(name);
				this._currentViewSelection = name;
				this._currentViewSection = TEST_GROUP_SECTION;
				
//				this._bodyWidget.showTestGroupList(groups, name);
				this._currentView = name;
				var listArgs = {
					parentController: this.controller, 
					maxRows: 20,
					rangeStart: 1,
					isFilterable: true, 
					showQuery: true, 
					queryTitle: this._currentView, 
					runQueryHref: "#", 
					isQueryEditable: false, 
					editQueryHref: "#",
					showFooter: true,
					sortColumn: 4, // last modified
					sortDirection: SortableFilterableTable.SORT_ASC,
					isDeleteColumn: true,
					isRowSelectable: true };
								
				this._groupTable = new com.ibm.rqm.planning.web.ui.internal.view.common.SortableFilterableTable();
				this._groupTable.initialize(listArgs);

				this._groupTable.addColumn( {title: "Type", isSortable: false, includeInFilter: false, width: "8%" });				
				this._groupTable.addColumn( {title: "Id", isSortable: true, includeInFilter: true, width: "5%"  });				
				this._groupTable.addColumn( {title: "Name", isSortable: false, includeInFilter: true, width: "52%"  });				
				this._groupTable.addColumn( {title: "Status", isSortable: true, includeInFilter: false, width: "15%"  });
				this._groupTable.addColumn( {title: "Last Modified", isSortable: true, includeInFilter: false, width: "20%"  });				
				
				if (groups != null) {
					for (var i=0; i<groups.length; i++)
					{
						var id = new Number(groups[i].id).valueOf();
						this._groupTable.addRow( 
							{	
								href: Utility.getTestGroupURI(groups[i].id, Utility.CONSTRUCTION_PERSPECTIVE), 
								removeParms: {obj: this, parm: id},
								removeMethod: this.removeTestGroup, 								
								elements: [
						  			 {type: SortableFilterableTable.TYPE_ICON, data: "", image: ImageCache.TEST_GROUP, tooltip: "Test Group", isLink: false}, 
			                   {type: SortableFilterableTable.TYPE_NUM, data: id, image: "", tooltip: "", isLink: true}, 
							       {type: SortableFilterableTable.TYPE_STRING, data: groups[i].name, image: "", tooltip: "", isLink: true}, 
									 {type: SortableFilterableTable.TYPE_STRING, data: groups[i].state, image: "", tooltip: "", isLink: false},
									 {type: SortableFilterableTable.TYPE_DATE, data: groups[i].modified, image: "", tooltip: "", isLink: false} 
									]
							});
					}				
				}
				
				this._mainView.setMainContent(this._groupTable.domNode);
				this._groupTable.displayTable();	
			},
			*/
			
			showNewTestGroup: function(name)
			{
				this._deselectPrevious(this._createNavWidget);
				this._createNavWidget.selectEntry(name);
				
//				this._bodyWidget.newTestGroup();				
				this.editor = new com.ibm.rqm.planning.web.ui.internal.view.construction.TestGroupEditor();
				this._mainView.setMainContent(this.editor.domNode);
				this.editor.initialize({ parentController: this.controller });
			},
			
			/* 
			 * EWI ACTIONS
			 */	
			showEwi: function(name)
			{
				this._deselectPrevious(this._ewiNavWidget);
				this._ewiNavWidget.selectEntry(name);
				
			},
				
			showEwiList: function(ewis, name)
			{
				this._deselectPrevious(this._ewiNavWidget);
				this._ewiNavWidget.selectEntry(name);
				this._currentViewSelection = name;
				this._currentViewSection = EWI_SECTION;
				
//				this._bodyWidget.showEwiList(ewis, name);
				var ownerId = getAuthenticatedContributor().userId;
//				this._createEWI = new com.ibm.rqm.execution.web.ui.internal.view.execution.EWIList({parentController: this.controller, 
//																										ewis: ewis, 
//																										owner: ownerId});
//				dojox.data.dom.removeChildren(this._planBody);
				this._mainView.setMainContent(this._createEWI.domNode);
			},
				
			showNewEwi: function(args)
			{
				this._deselectPrevious(this._createNavWidget);
//				this._createNavWidget.selectEntry(name);
				this._createNavWidget.selectEntry(STR_CREATE_EWI);

//				this._bodyWidget.newEwi(args);				
				var testCaseId = args != null && args.testCaseId != null ? args.testCaseId : null;
				var testCases = args != null && args.testCases != null ? args.testCases : null; 
//				var ewiEditor = new com.ibm.rqm.execution.web.ui.internal.view.execution.CreateExecutionWorkItem({ parentController: this.controller});
				this._mainView.setMainContent(ewiEditor.domNode);
			},
				
		/* 
		 * TEST SCRIPT DISPLAY ACTIONS
		 */			
		showTestScript: function(testScript) 
		{				
			var args = { parentController: this.controller, testScript: testScript};
			this._editor = new com.ibm.rqm.planning.web.ui.internal.view.construction.TestScriptEditor();
			this._mainView.setMainContent(this._editor.domNode);
			this._editor.initialize(args);				
//			this._recentNavWidget.addItem({name: testScript.name, type: Constants.TYPE_SCRIPT});
		},		
		
		showNewTestScript: function() 
		{				
			this._deselectPrevious(this._createNavWidget);
			this._createNavWidget.selectEntry(STR_CREATE_TEST_SCRIPT);
			this._editor = new com.ibm.rqm.planning.web.ui.internal.view.construction.TestScriptEditor();
			this._mainView.setMainContent(this._editor.domNode);
			this._editor.initialize({ parentController: this.controller });
		},		
		/*
		showTestScriptList: function(scripts, queryName) {
			this._deselectPrevious(this._scriptsNavWidget);
			this._scriptsNavWidget.selectEntry(queryName);
			this._currentViewSelection = queryName;
			this._currentViewSection = TEST_CASE_SECTION;

			if ( scripts != null && scripts.length > 0 ) {
				this._scripts = scripts;	
			}
			this._currentQuery = queryName;
			var listArgs = {
				parentController: this.controller, 
				maxRows: 20,
				rangeStart: 1,
				isFilterable: true, 
				showQuery: true, 
				queryTitle: this._currentQuery, 
				runQueryHref: "#", 
				isQueryEditable: false, 
				editQueryHref: "#",
				showFooter: true,
				sortColumn: 4, // last modified
				sortDirection: SortableFilterableTable.SORT_ASC,
				isDeleteColumn: true,
				isRowSelectable: true
			}
			this._scriptTable = new com.ibm.rqm.planning.web.ui.internal.view.common.SortableFilterableTable();
			this._scriptTable.initialize(listArgs);
			
			this._scriptTable.addColumn( {title: "Type", isSortable: false, includeInFilter: false, width: "5%" });				
			this._scriptTable.addColumn( {title: "Id", isSortable: true, includeInFilter: true, width: "5%"  });				
			this._scriptTable.addColumn( {title: "Name", isSortable: false, includeInFilter: true, width: "40%"  });				
			this._scriptTable.addColumn( {title: "Description", isSortable: true, includeInFilter: false, width: "30%"  });
			this._scriptTable.addColumn( {title: "Last Modified", isSortable: true, includeInFilter: false, width: "20%"  });				
			
			//add a row for each script				
			if (this._scripts != null) {					
				for (var i = 0; i < this._scripts.length; i++) {
					var s = this._scripts[i];
					var id = new Number(s.id).valueOf();
					
					this._scriptTable.addRow( 
						{ href: Utility.getTestScriptURI(s.id, Utility.CONSTRUCTION_PERSPECTIVE),
						  removeParms: {obj: this, parm: id},
						  removeMethod: this.removeTestScript, 
						  elements: [
				  			 {type: SortableFilterableTable.TYPE_ICON, data: "", image: ImageCache.TEST_SCRIPT, tooltip: "Test Script", isLink: false}, 
	                         {type: SortableFilterableTable.TYPE_NUM, data: id, image: "", tooltip: "", isLink: true}, 
					         {type: SortableFilterableTable.TYPE_STRING, data: s.name, image: "", tooltip: "", isLink: true}, 
							 {type: SortableFilterableTable.TYPE_STRING, data: s.description, image: "", tooltip: "", isLink: false},
							 {type: SortableFilterableTable.TYPE_DATE, data: s.modified, image: "", tooltip: "", isLink: false} 
						  ]
						}
					);
				}				
			}
			
			this._mainView.setMainContent( this._scriptTable.domNode );
			this._scriptTable.displayTable();
//			this._recentNavWidget.setCurrentQuery({name: this._currentQuery, type: Constants.TYPE_SCRIPT});
		},
		*/

      showTestScriptList: function(scripts, queryName)
      {
         this._currentView = queryName;
         this._scriptTableViewer = new TestScriptTableView({scripts: scripts, queryName: this._currentView});
         this._mainView.setMainContent(this._scriptTableViewer.domNode);            
      }, 
					
		removeTestScript: function(self, id)
		{
			var serviceObject = {
				testScriptRemoved: function(args) {
					// remove element with ID = id, which is in column 1
					self._scriptTable.removeElement(1, id);
				},
				error: function(error) { 
					self._error(error, "Error removing Test Script #" + id);
				}
			};
	
			var responseHandler = new ServiceResponseHandler(serviceObject, "testScriptRemoved", "error");
			TestScriptClient.removeTestScript(responseHandler, {id: id});
		},		
		
		showImportWizard: function(name)
		{
//			this._importWizard = new com.ibm.rqm.planning.web.ui.internal.view.construction.ImportScriptWizardPage()
//			this._mainView.setMainContent( this._importWizard.domNode );
		},
		
		_error: function(errorObj) {
			alert("Error: (message: '" + errorObj.message + "') from ConstructionPageView#_error");
		}		
			
	}
);

})();
