/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rational.test.lm.web.ui.internal.pages.InventoryPage");

dojo.require("dojo.date.locale");
dojo.require("net.jazz.ajax.ui.PlatformUI");
dojo.require("net.jazz.ajax.toolbox.lang.internal.Lang");

//xojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

dojo.require("com.ibm.asq.common.web.client.internal.Catalog");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.PrimaryActionButton");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.SecondaryActionsDropdownButton");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.PageLayout");

dojo.require("com.ibm.rational.test.lm.web.client.internal.machine");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.pages.PageUtil");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.pages.AssetUriUtil");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.pages.InventoryUriUtil");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.inventory.InventoryView");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.inventory.AutomationsView");

(function() {
var RtlmUiUtil = com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil;
var PlatformUI   = net.jazz.ajax.ui.PlatformUI;
var AssetUriUtil = com.ibm.rational.test.lm.web.ui.internal.pages.AssetUriUtil;
var InventoryUriUtil = com.ibm.rational.test.lm.web.ui.internal.pages.InventoryUriUtil;
var MACHINE_ASSET_TYPE = "Machine";
var INVENTORY_VIEW_ID   = "inventory_query_view";
var AUTOMATIONS_VIEW_ID   = "automations_query_view";

function getWorkbench() {
    return net.jazz.ajax.ui.PlatformUI.getWorkbench();
}

dojo.declare("com.ibm.rational.test.lm.web.ui.internal.pages.InventoryPage",
    com.ibm.asq.common.web.ui.internal.view.layout.PageLayout,
{
    hideSearchSection: true, // we don't have search in the left action panel yet

    // Parent main page that holds this assets sub-page.  All registered
    // action must have the parent main page bring up this sub-page before
    // performing the action.
    parentMainPage: null,
    
	_moreActionsButton: null,
	_searchButton: null,
    
    postCreate: function() {
        this.inherited("postCreate", arguments);

		this._moreActionsButton = new com.ibm.asq.common.web.ui.internal.view.layout.SecondaryActionsDropdownButton();
		this._moreActionsButton.setLabel(RtlmUiUtil.getMessage("moreActionsButtonLabel"));
        this.setSecondaryActions(this._moreActionsButton.domNode);
		this._moreActionsButton.addAction(function(){window.location.href = InventoryUriUtil.getAutomationsURI();}, "Get Automations");
        this._moreActionsButton.addAction(function(){window.location.href = InventoryUriUtil.getInventoryURI();}, "Get Inventory");

        var viewActions = new com.ibm.rational.test.lm.web.ui.internal.pages.PageNavigator({fixedSelection:"Inventory"});
        this._leftNavigator.getViewsSection().appendChild(viewActions.domNode);
		
		var ActionRegistry = getWorkbench().getActionRegistry();
		ActionRegistry.registerAction("com.ibm.rational.test.lm.web.ui.internal.pages.InventoryPage.showAutomations", this, "showAutomations");
		ActionRegistry.registerAction( InventoryUriUtil.PageRoot + InventoryUriUtil.InventoryKey, this, "queryInventoryView");
		ActionRegistry.registerAction( InventoryUriUtil.PageRoot + InventoryUriUtil.AutomationGroupsRegistryKey, this, "showGroupAutomations");

        this.addSampleRelatedInfo();
    },
	
    // Summary:
    //     Handle registered action for bringing the request query view into the page.
    //     The action may also includes directives to refresh the query results, and/or 
    //     to remove a cached request form view in the page.
    //
    queryInventoryView: function(args)
    {
        if (this.parentMainPage) 
		{
            this.parentMainPage.showInventorySubPage();
        }
    
        var inventoryView = this.getCachedView(INVENTORY_VIEW_ID);
        
        // no request query view created yet, create one and display it.
        if(!inventoryView) 
        {
            inventoryView = new com.ibm.rational.test.lm.web.ui.internal.views.inventory.InventoryView();
        }
        
        this.setPageView(INVENTORY_VIEW_ID, inventoryView);
        
        // carry out the directives.
        //
        if(args.removeViewId != null && this.getCachedView(args.removeViewId)) 
        {
            this.removeCachedView(args.removeViewId);
        }
    },
	
	// Summary:
    //     Handle registered action for bringing the request query view into the page.
    //     The action may also includes directives to refresh the query results, and/or 
    //     to remove a cached request form view in the page.
    //
    showAutomations: function(args)
    {
        if (this.parentMainPage) 
		{
            this.parentMainPage.showInventorySubPage();
        }
    
        var automationsView = this.getCachedView(AUTOMATIONS_VIEW_ID);
        
        // no request query view created yet, create one and display it.
        if(!automationsView) 
        {
            automationsView = new com.ibm.rational.test.lm.web.ui.internal.views.inventory.AutomationsView();
        }

		automationsView.showAutomationsForMachines();
				
        this.setPageView(AUTOMATIONS_VIEW_ID, automationsView);
        
        // carry out the directives.
        //
        if(args.removeViewId != null && this.getCachedView(args.removeViewId)) 
        {
            this.removeCachedView(args.removeViewId);
        }
    },

	// Summary:
    //     Handle registered action for bringing the request query view into the page.
    //     The action may also includes directives to refresh the query results, and/or 
    //     to remove a cached request form view in the page.
    //
    showGroupAutomations: function(args)
    {
        if (this.parentMainPage) 
		{
            this.parentMainPage.showInventorySubPage();
        }
    
        var automationsView = this.getCachedView(AUTOMATIONS_VIEW_ID);
        
        // no request query view created yet, create one and display it.
        if(!automationsView) 
        {
            automationsView = new com.ibm.rational.test.lm.web.ui.internal.views.inventory.AutomationsView();
        }
				
        this.setPageView(AUTOMATIONS_VIEW_ID, automationsView);
        
        // carry out the directives.
        //
        if(args.removeViewId != null && this.getCachedView(args.removeViewId)) 
        {
            this.removeCachedView(args.removeViewId);
        }
    },
	
    init: function()
    {
        console.debug("init machine page");
    },
	
	showInventory: function()
	{
		
	}
});

})();
