/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rational.test.lm.web.ui.internal.pages.ReservationsPage");

dojo.require("net.jazz.ajax.ui.PlatformUI");
dojo.require("net.jazz.ajax.toolbox.lang.internal.Lang");
//xojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.PrimaryActionButton");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.PageLayout");

dojo.require("com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.pages.PageUtil");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.reservations.Reservations");


(function() 
{
var RtlmUiUtil 		= com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil;
var PlatformUI      = net.jazz.ajax.ui.PlatformUI;
var ActionRegistry  = null; // bind to ActionRegistry later
var LOADING         = RtlmUiUtil.getMessage("resMsgRetrievingReservationsWorking");
var QUERY_VIEW_ID   = "reservations_query_view";

function getWorkbench() 
{
    return net.jazz.ajax.ui.PlatformUI.getWorkbench();
}

dojo.declare("com.ibm.rational.test.lm.web.ui.internal.pages.ReservationsPage",
    com.ibm.asq.common.web.ui.internal.view.layout.PageLayout,
{   
    hideSearchSection: true, // we don't have search in the left action panel yet

    // Parent main page that holds this reservations sub-page.  All registered
    // action must have the parent main page bring up this sub-page before
    // performing the action.
    parentMainPage: null,

	postCreate: function() 
	{
		this.inherited("postCreate", arguments);
		this.viewCache = {};
        
		var param = 
		{
			id: "newReservation",
			iconClass: "newReservationIcon",
			actionLabel: RtlmUiUtil.getMessage("newLabel"),
			itemLabel: RtlmUiUtil.getMessage("resResLabel")
		};
        var newReservationAction = new com.ibm.asq.common.web.ui.internal.view.layout.PrimaryActionButton(param);
        newReservationAction.onClick = dojo.hitch(this, "handleNewAction");
        this.setPrimaryAction(newReservationAction.domNode);
        
        var viewActions = new com.ibm.rational.test.lm.web.ui.internal.pages.PageNavigator({fixedSelection:"Reservations"});
        this._leftNavigator.getViewsSection().appendChild(viewActions.domNode);

        ActionRegistry = getWorkbench().getActionRegistry();
        ActionRegistry.registerAction("com.ibm.rational.test.lm.web.ui.internal.pages.ReservationsPage.queryReservationsView", this, "queryReservationsView");
        ActionRegistry.registerAction("com.ibm.rational.test.lm.web.ui.internal.pages.ReservationsPage.newReservationView", this, "newReservationView");      

        this.addSampleRelatedInfo();
    },

    // Summary:
    //     Handle registered action for bringing the request query view into the page.
    //     The action may also includes directives to refresh the query results, and/or 
    //     to remove a cached request form view in the page.
    //
    queryReservationsView: function(args)
    {
        if (this.parentMainPage) {
            this.parentMainPage.showReservationsSubPage();
        }
    
        var queryView = this.getCachedView(QUERY_VIEW_ID);
        
        // no request query view created yet, create one and display it.
        if(!queryView) 
        {
            queryView = new com.ibm.rational.test.lm.web.ui.internal.views.reservations.Reservations();
        }
        this.setPageView(QUERY_VIEW_ID, queryView);
        
        // carry out the directives.
        //
        if(args.removeViewId != null && this.getCachedView(args.removeViewId)) 
        {
            this.removeCachedView(args.removeViewId);
        }
        // refresh the query results.
        if(args.refresh)
            queryView.runSelectedQuery();
    },
    
	// Summary:
	//     Handle registered action for bringing a new request form into the page.
	//
	newReservationView: function(args)
	{
        if (this.parentMainPage) {
            this.parentMainPage.showReservationsSubPage();
        }
    
        //this._showRequestView(args, true);
	},
	
	    // Summary:
    //     Handles the "new request" button click event in the page's action panel. Generates
    //     a new reservation URI and this is forward the action "back" into this page's new reservation action handler.
    //
    handleNewAction: function()
    {
        //window.location.href = UriUtil.getNewRequestURI();
    }

});

})();
