/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.asq.common.web.ui.internal.test.EditorPage");

dojo.require("dijit.form.CheckBox");

dojo.require("net.jazz.ajax.ui.PlatformUI");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.DirectoryPane");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.PageLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewNavigatorCollapsibleArea");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.CollapsibleSection");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.EditorSectionContainer");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.test.TestView");

(function() {

var ImageCache = com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var ViewHeaderLayout = com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;

function getWorkbench() {
    return net.jazz.ajax.ui.PlatformUI.getWorkbench();
}

dojo.declare("com.ibm.asq.common.web.ui.internal.test.EditorPage",
    [com.ibm.asq.common.web.ui.internal.view.layout.PageLayout],
{
    postCreate: function() {
        var headerArg = {
            titleEditable: true,
            useDualContents: true,
            defaultMainContent: false,
            typeLabel: "test",
            iconClass: "machine-icon-48",
            contextHelpId: "dummy.html"
        };
        
        this.defaultView = new ViewHeaderLayout(headerArg);
        this.inherited('postCreate', arguments);
        this.defaultView.setTitle("Editors Demo");
        this.defaultView.setSubTitle("with New Header");
        this.defaultView.setTypeLabel("Testing");
        this.defaultView.getRightHeader().innerHTML = "Last modified some time ago";
        var attribute1 = document.createElement("span");
        var label1 = document.createElement("span");
        var value1 = document.createElement("span");
        label1.innerHTML = "Owner:";
        value1.innerHTML = "Charlie Brown";
        attribute1.className = "attributes-entry";
        label1.className = "attributes-entry-label";
        value1.className = "attributes-entry-value";
        var attribute2 = document.createElement("span");
        var label2 = document.createElement("span");
        var value2 = document.createElement("img");
        attribute2.className = "attributes-entry";
        label2.className = "attributes-entry-label";
        value2.className = "attributes-entry-icon";
        label2.innerHTML = "Priority:";
        value2.src = ImageCache.PRIORITYHIGH_ICON;
        attribute1.appendChild(label1);
        attribute1.appendChild(value1);
        attribute2.appendChild(label2);
        attribute2.appendChild(value2);
        this.defaultView.getInfoAttributesNode().appendChild(attribute1);
        this.defaultView.getInfoAttributesNode().appendChild(attribute2);
        this.defaultView.setSummary("This is a test page for the view header (aka the editor overview) and editors.");

        var divider = document.createElement("table");
        divider.cellSpacing = "10";
        var tr = divider.insertRow(0);
        
        var left = tr.insertCell(0);
        var right = tr.insertCell(1);
        right.width = "100%";
        var leftContainer = document.createElement("div");
        var rightContainer = document.createElement("div");
        left.appendChild(leftContainer);
        right.appendChild(rightContainer);
        this.defaultView.getContentNode().appendChild(left);
        this.defaultView.getContentNode().appendChild(right);
        
        this.defaultView.getAltContentNode().appendChild(document.createTextNode("This is alternate view content."));
        
        ActionRegistry = getWorkbench().getActionRegistry();
        ActionRegistry.registerAction("com.ibm.asq.common.web.ui.internal.test.EditorPage.init", this, "init");

        var expando = new com.ibm.asq.common.web.ui.internal.view.common.CollapsibleSection();
        expando.domNode.name = "first-section";
        expando.setTitle("Generic Collapsible Section");
        expando.infoNode.innerHTML = "This is the info node area.";
        expando.summaryNode.innerHTML = "This is the summary node area. Click on the title to expand this section.";
        expando.headerRightNode.innerHTML = "This is the header right node area.";
        expando.containerHeaderNode.innerHTML = "This is the container header node area - mostly for tool actions.";
        var content = document.createElement("div");
        content.style.borderTop = "1px solid black";
        content.style.paddingTop = "10px";
        content.innerHTML = "<strong>This is the container node area for content.</strong>";
        expando.containerNode.appendChild(content);
        rightContainer.appendChild(expando.domNode);
        
        var containerArgs = {
                                'actionDisplay': EditorSectionContainer.actionIconOnly,
                                'summaryEditable': true,
                                'hideToolbarOnReadOnly': false
                             };
        var expando2 = new com.ibm.asq.common.web.ui.internal.view.common.EditorSectionContainer(containerArgs);
        expando2.domNode.name = "second-section";
        expando2.setTitle("Editor Container");
        expando2.setTitleExt(" - subclass of Generic Collapsible Section");
        
        var inputNode = expando2.addInfoAttribute("Owned by:", "John Doe", ImageCache.FLAG_STATUS_INCOMPLETE, "input", true);
        var comboNode = expando2.addInfoAttribute("Priority:", "", ImageCache.PRIORITYLOW_ICON, "select", true);
        var op1 = document.createElement("option");
        op1.text = "High";
        op1.value = "High";
        var op2 = document.createElement("option");
        op2.text = "Low";
        op2.value = "Low";
        comboNode.domControlNode.add(op1, null);
        comboNode.domControlNode.add(op2, null);
        comboNode.setAttributeValue("Low");

        expando2.setSummary("This is summary that can be edited when in editable mode.");
        expando2.headerRightNode.innerHTML = "Some info goes here.";
        
        expando2.addAction("Hello World", function(){alert("Hello World!");}, null,
                           dojo.hitch(this, "actionChangedHandler"), "add-icon-image", false);
        expando2.addAction("Save", function(){alert("Nothing to save in the demo!");}, null,
                           dojo.hitch(this, "actionChangedHandler"), "save-icon-image", true);
        
        var span = document.createElement("span");
        var button = new dijit.form.CheckBox();
        button.onChange = function() {
            expando2.setEditable(this.checked);
            viewer.tableViewer.setEditable(this.checked);
        }
        span.appendChild(button.domNode);
        span.appendChild(document.createTextNode("Set Editable Mode"));
        expando2.containerNode.appendChild(span);
        
        var viewer = new com.ibm.asq.common.web.ui.internal.test.TestView();
        viewer.tableViewer.setContentPageSize(10);
        viewer.tableViewer.setEditable(false);
        expando2.containerNode.appendChild(viewer.tableViewer.domNode);

        rightContainer.appendChild(expando2.domNode);

        var expando3 = new com.ibm.asq.common.web.ui.internal.view.common.EditorSectionContainer(containerArgs);
        expando3.domNode.name = "third-section";
        expando3.setTitle("Editor Container");
        expando3.setTitleExt(" - subclass of Generic Collapsible Section");
        
        var inputNode = expando3.addInfoAttribute("Owned by:", "John Doe", ImageCache.FLAG_STATUS_INCOMPLETE, "input", true);
        var comboNode = expando3.addInfoAttribute("Priority:", "", ImageCache.PRIORITYLOW_ICON, "select", true);
        var op1 = document.createElement("option");
        op1.text = "High";
        op1.value = "High";
        var op2 = document.createElement("option");
        op2.text = "Low";
        op2.value = "Low";
        comboNode.domControlNode.add(op1, null);
        comboNode.domControlNode.add(op2, null);
        comboNode.setAttributeValue("Low");

        expando3.setSummary("This is summary that can be edited when in editable mode.");
        expando3.headerRightNode.innerHTML = "Some info goes here.";
        
        expando3.addAction("Hello World", function(){alert("Hello World!");}, null,
                           dojo.hitch(this, "actionChangedHandler"), "add-icon-image", false);
        expando3.addAction("Save", function(){alert("Nothing to save in the demo!");}, null,
                           dojo.hitch(this, "actionChangedHandler"), "save-icon-image", true);
        
        var span = document.createElement("span");
        var button = new dijit.form.CheckBox();
        button.onChange = function() {
            expando3.setEditable(this.checked);
            viewer.tableViewer.setEditable(this.checked);
        }
        span.appendChild(button.domNode);
        span.appendChild(document.createTextNode("Set Editable Mode"));
        expando3.containerNode.appendChild(span);
        
        var viewer = new com.ibm.asq.common.web.ui.internal.test.TestView();
        viewer.tableViewer.setContentPageSize(10);
        viewer.tableViewer.setEditable(false);
        expando3.containerNode.appendChild(viewer.tableViewer.domNode);

        rightContainer.appendChild(expando3.domNode);
        
        var expando4 = new com.ibm.asq.common.web.ui.internal.view.common.CollapsibleSection();
        expando4.domNode.name = "forth-section";
        expando4.setTitle("Generic Collapsible Section");
        expando4.infoNode.innerHTML = "This is the info node area.";
        expando4.summaryNode.innerHTML = "This is the summary node area. Click on the title to expand this section.";
        expando4.headerRightNode.innerHTML = "This is the header right node area.";
        expando4.containerHeaderNode.innerHTML = "This is the container header node area - mostly for tool actions.";
        var content = document.createElement("div");
        content.style.borderTop = "1px solid black";
        content.style.paddingTop = "10px";
        content.innerHTML = "<strong>This is the container node area for content.</strong>";
        expando4.containerNode.appendChild(content);
        rightContainer.appendChild(expando4.domNode);
        
        var aLink = document.createElement("a");
        aLink.appendChild(document.createTextNode("goto some place fun!"));
        aLink.href = "http://www.pbs.org";
        aLink.name = "bottom-tag";
        rightContainer.appendChild(aLink);;
        
        var entries = [
            {title:"section 1", node: expando.domNode},
            {title:"section 2", node: expando2.domNode},
            {title:"section 3", node: expando3.domNode},
            {title:"section 4", node: expando4.domNode},
            {title:"Outside Link", tag: "bottom-tag"}
        ];
        
        var toc = new com.ibm.asq.common.web.ui.internal.widgets.DirectoryPane({'entries': entries});
        leftContainer.appendChild(toc.domNode);

// test view header layout
        var headerTest = new com.ibm.asq.common.web.ui.internal.view.layout.ViewNavigatorCollapsibleArea();
        headerTest.setTitle("Test View Header");
        headerTest.addLink(dojo.hitch(this, "showIcon"), "Show Icon");
        headerTest.addLink(dojo.hitch(this, "hideIcon"), "Hide Icon");
        headerTest.addLink(dojo.hitch(this, "showSummary"), "Show Summary");
        headerTest.addLink(dojo.hitch(this, "hideSummary"), "Hide Summary");
        headerTest.addLink(dojo.hitch(this, "getTitle"), "Get Title");
        this._leftNavigator.getPrimaryActionSection().appendChild(headerTest.domNode);

        this.defaultView.addRightViewAction("Start Progress", dojo.hitch(this, "startProgress"));
        this.defaultView.addRightViewAction("End Progress", dojo.hitch(this, "endProgress"));
        
        this.defaultView.addLeftViewAction("Set Success Status", dojo.hitch(this, "okStatus"), null, "test-image-3");
        this.defaultView.addLeftViewAction("Set Error Status", dojo.hitch(this, "errorStatus"), null, "test-image-4");
        this.defaultView.addLeftViewAction("Set Info Status", dojo.hitch(this, "infoStatus"), null, "test-image-5");
        this.defaultView.addLeftViewAction("Clear Status", dojo.hitch(this, "clearStatus"), null, "test-image-2");
        
        this.addSampleRelatedInfo();
    },
    
    actionChangedHandler: function(oldValue, newValue, args) {
        alert("Action got notification on change from " + oldValue + " to " + newValue + " from " + args['changeSrc']);
    },
    
    okStatus: function() {
        this.defaultView.setStatus("This is success message from a server call.", ViewHeaderLayout.SUCCESS);
    },
    
    errorStatus: function() {
        this.defaultView.setStatus("This is bad!  Something is wrong with the server call.", ViewHeaderLayout.ERROR);
    },
    
    infoStatus: function() {
        this.defaultView.setStatus("Just want your attention here! Here! Here!!", ViewHeaderLayout.INFO);
    },
    
    clearStatus: function() {
        this.defaultView.clearStatus();
    },
    
    startProgress: function() {
        this.defaultView.setProgressStart("Starting...");
    },
    
    endProgress: function() {
        this.defaultView.setProgressEnd("Finished");
    },
    
    showIcon: function() {
        this.defaultView.setIconClass("machine-icon-48");
    },
    
    hideIcon: function() {
        this.defaultView.setIconClass(null);
    },
    
    showSummary: function() {
        this.defaultView.setSummary("This is a test page for the view header (aka the editor overview) and editors.");
    },
    
    hideSummary: function() {
        this.defaultView.setSummary("");
    },
    
    getTitle: function() {
        alert("Title is: \"" + this.defaultView.getTitle() + "\"");
    },
    
    init: function() {
    }
});

})();
