/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.asq.common.web.ui.internal.test.TestPage");

dojo.require("net.jazz.ajax.ui.PlatformUI");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.RelatedInfo");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.PageLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.PrimaryActionButton");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.SecondaryActionsDropdownButton");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewNavigatorCollapsibleArea");
dojo.require("com.ibm.asq.common.web.ui.internal.test.TestView");

(function() {

function getWorkbench() {
    return net.jazz.ajax.ui.PlatformUI.getWorkbench();
}

var Root             = "com.ibm.asq.common.web.ui.internal.test.TestPage.";
var BaseActionHref   = "#action=" + Root;
var ViewHeaderLayout = com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;

dojo.declare("com.ibm.asq.common.web.ui.internal.test.TestPage",
    [com.ibm.asq.common.web.ui.internal.view.layout.PageLayout],
{
    postCreate: function() 
    {
        this.defaultView = new com.ibm.asq.common.web.ui.internal.test.TestView({'iconClass': "big-icon-request"});
        this.defaultView.viewHeaderNode.setTitle("Common Widgets Demo Page");
        com.ibm.asq.common.web.ui.internal.test.TestPage.superclass.postCreate.apply(this, arguments);

        var arg = {
            onClick: function() { alert('Hi!'); },
            actionLabel: "Hello",
            itemLabel: "World"
        };
        var button = new com.ibm.asq.common.web.ui.internal.view.layout.PrimaryActionButton(arg);
        this.setPrimaryAction(button.domNode);
        
        var secondaryActions = new com.ibm.asq.common.web.ui.internal.view.layout.SecondaryActionsDropdownButton();
        secondaryActions.setLabel("More Actions");
        secondaryActions.addAction(dojo.hitch(this, "okStatus"), "Test Success");
        secondaryActions.addAction(dojo.hitch(this, "errorStatus"), "Test Error");
        secondaryActions.addAction(dojo.hitch(this, "infoStatus"), "Test Info");
        secondaryActions.addAction(dojo.hitch(this, "clearStatus"), "Test Clear");
        secondaryActions.addAction(dojo.hitch(this, "startProgress"), "Start Progress");
        secondaryActions.addAction(dojo.hitch(this, "endProgress"), "End Progress");
        this.setSecondaryActions(secondaryActions.domNode);
        
        var viewNav = new com.ibm.asq.common.web.ui.internal.view.layout.ViewNavigatorCollapsibleArea();
        viewNav.setTitle("Test Views");
        viewNav.addLink(function(){
            window.location.href = BaseActionHref + "viewDemo";
        }, "Show Demo View");
        viewNav.addLink(function(){alert('Link 1');}, "Link One");
        viewNav.addLink(function(){alert('Link 2');}, "Link Two");
        this._leftNavigator.getViewsSection().appendChild(viewNav.domNode);
        
        // late bind to ActionRegistry to ensure that workbench is instantiated
        ActionRegistry = getWorkbench().getActionRegistry();
        ActionRegistry.registerAction("com.ibm.asq.common.web.ui.internal.test.TestPage.init", this, "init");
        ActionRegistry.registerAction("com.ibm.asq.common.web.ui.internal.test.TestPage.viewDemo", this, "viewDemo");

        var staticRelatedInfo = new com.ibm.asq.common.web.ui.internal.view.common.RelatedInfoPanel();
        staticRelatedInfo.addLink("Related Sites", "IBM", "http://www.ibm.com");
        staticRelatedInfo.addLink("Interesting Sites", "Yahoo", "http://www.yahoo.com");
        
        this._relatedInfoPanel.setCurrentPanel("TestPage", staticRelatedInfo);
    },
    
    okStatus: function() {
        this.defaultView.viewHeaderNode.setStatus("This is ok", ViewHeaderLayout.SUCCESS);
    },
    
    errorStatus: function() {
        this.defaultView.viewHeaderNode.setStatus("This is bad", ViewHeaderLayout.ERROR);
    },
    
    infoStatus: function() {
        this.defaultView.viewHeaderNode.setStatus("This is plain info");
    },
    
    clearStatus: function() {
        this.defaultView.viewHeaderNode.clearStatus();
    },
    
    startProgress: function() {
        this.defaultView.viewHeaderNode.setProgressStart("Starting...");
    },
    
    endProgress: function() {
        this.defaultView.viewHeaderNode.setProgressEnd("Finished");
    },
    
    viewDemo: function() 
    {
        this.setPageView("default", this.defaultView);
    },

    init: function() {
    }
});

})();
