/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.util.MetaNav");

dojo.require("com.ibm.team.dashboard.web.ui.internal.MetaNav");
dojo.require("com.ibm.rqm.planning.web.ui.internal.dnd.DraggableTabs");

(function() {
var DraggableTabs = com.ibm.rqm.planning.web.ui.internal.dnd.DraggableTabs;
	
dojo.declare("com.ibm.rqm.planning.web.ui.internal.util.MetaNav", 
				  com.ibm.team.dashboard.web.ui.internal.MetaNav, 
{
	init: function(args) {		
		if (this.isInitialized) {
			return;
		}
		dojo.subscribe(com.ibm.team.dashboard.web.ui.internal.Constants.serverError, this, "_showErrorMessage");
		dojo.subscribe(com.ibm.team.dashboard.web.ui.internal.Constants.hideServerError, this, "hideMessage");
		
		this.dashboardItem = this.dashboardContainer.getDashboardItem();
		this.viewletPageHelpers = args.viewletPageHelpers;
		
		if (!this.dashboardContainer.isPrivateContributorDashboard())
			this._addBreadcrumbs(this.dashboardItem.getBreadcrumbs());
		else {
			this._breadcrumbs.style.display = "none";
			this._tabWrapper.style.marginTop = "3px";
		}
		
		this.title.value = args.title;
		this.title.domNode.innerHTML = args.title;
		dojo.removeClass(this.title.domNode, "loading-title");
		//create new DraggableTabs container
		var div = document.createElement("div");
		this._tabs.appendChild(div);
		this.draggableTabs = new DraggableTabs(div,{parent: this, accept: ["tab"], selectedTabId: args.selectedTabId, dashboardContainer: this.dashboardContainer, dashboardItem: this.dashboardItem});
		
		for (var i=0; i<this.viewletPageHelpers.length; i++) {
			var viewletPageHelper = this.viewletPageHelpers[i];
			var id = viewletPageHelper.getId();
			this.draggableTabs.add(null,{title: viewletPageHelper.getTitle(), id: id, index: i, helper: viewletPageHelper, type: "tab"});
		}
		this._tabWrapper.style.display = "block";
		this.draggableTabs.startup();
	}
});

})();
