/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.administration.AdministrationEditor");

dojo.require("com.ibm.asq.common.web.client.internal.option");

dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPropertyEditor");
//xojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractContentArea");
//xojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.DefaultRequirementTypeContentArea");
//xojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.DoorsHostnameContentArea");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.DefectsProviderContentArea");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.ReqproHostnameContentArea");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.ResourceEditorContentArea");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.ReportPropertiesContentArea");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.CPUNumberContentArea");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.StateTransitionConstraintContentArea");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.ExecutionStatesContentArea");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.CategoryAdminContentArea");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.RelatedLinksContentArea");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.ArtifactOptionsContentArea");

dojo.require("com.ibm.rqm.planning.web.client.internal.PreferenceClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");

(function(){
	var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
    var Constants 		= com.ibm.rqm.planning.web.client.internal.Constants;
	var AlertDialog 	= com.ibm.asq.common.web.ui.internal.widgets.AlertDialog;
	var EditorUtil		= com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
	var GlobalEvents    = com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
	var ViewHeaderLayout = com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
    var PermissionsClient = com.ibm.asq.common.web.client.internal.PermissionsClient;
    
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.administration.AdministrationEditor", com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPropertyEditor, {
        
		dirty: false,
		savingParticipant: 0,
		
		constructor: function(){
            this.headerTitle = Constants.getMessage("labelAdministration");
            this.defaultProperty = Constants.getMessage("labelRequisiteProHostProperties");
            this.editable = true;
            this._checkPermission();
        },
		
		postCreate: function(){
			this.inherited("postCreate", arguments);
			this._initHeader();
			
		},

        isEditable: function() {
            return this.editable;  
        },
        
        _checkPermission: function() {
            var permission = PermissionsClient.getStoredPermission(PermissionsClient.OP_ADMIN_OPTIONS);                
            if (permission) {
                this.editable = permission[PermissionsClient.ACTION_EDIT];
            }
        },
		
		_initHeader: function(){
			dojox.data.dom.removeChildren(this.viewHeaderNode.getRightActionsContainer());
			this._cancelButton = this.viewHeaderNode.addRightViewAction(Constants.getMessage("labelDiscardChanges"), dojo.hitch(this, "onCancel"));
			this._cancelButton.disabled = true;
			this._saveButton = this.viewHeaderNode.addRightViewAction(Constants.getMessage("labelSave"), dojo.hitch(this, "onSave"));
			this._saveButton.disabled = true;

            if(!this.isEditable()) {
                var text = Constants.getCommonMessage("statusNoEditPerm");
                var details = Constants.getCommonMessage("msgNoEditPermDetails", Constants.getMessage("labelSystemProperties"));
                this.viewHeaderNode.setStatus(text, ViewHeaderLayout.WARNING, details);    
            }
            
		},
        
        setNameContentPairs: function(){
			var artifactOptionsContentArea = new com.ibm.rqm.planning.web.ui.internal.view.administration.ArtifactOptionsContentArea({parent: this});
            var defectsProviderContentArea = new com.ibm.rqm.planning.web.ui.internal.view.administration.DefectsProviderContentArea();
            var reqproHostnameContentArea = new com.ibm.rqm.planning.web.ui.internal.view.administration.ReqproHostnameContentArea({parent: this});
            var resourceEditorContentArea = new com.ibm.rqm.planning.web.ui.internal.view.administration.ResourceEditorContentArea({parent: this});
            var reportPropertiesConentArea = new com.ibm.rqm.planning.web.ui.internal.view.administration.ReportPropertiesContentArea({parent: this});
			var CPUNumberContentArea = new com.ibm.rqm.planning.web.ui.internal.view.administration.CPUNumberContentArea({parent: this});
			var stateTransitionConstraintContentArea= new com.ibm.rqm.planning.web.ui.internal.view.administration.StateTransitionConstraintContentArea({parent: this});
			this.stateTransitionConstraintContentArea = stateTransitionConstraintContentArea;
			var executionStatesContentArea = new com.ibm.rqm.planning.web.ui.internal.view.administration.ExecutionStatesContentArea();
			var planCategories = new com.ibm.rqm.planning.web.ui.internal.view.administration.CategoryAdminContentArea({artifactType: Constants.MODEL_TYPE_PLAN, csHelpId:"rqm_admin_tp_cat.html"});
			var caseCategories = new com.ibm.rqm.planning.web.ui.internal.view.administration.CategoryAdminContentArea({artifactType: Constants.MODEL_TYPE_CASE, csHelpId:"rqm_admin_tc_cat.html"});
			var relatedLinks = new com.ibm.rqm.planning.web.ui.internal.view.administration.RelatedLinksContentArea({parent: this});
            
			this._nameContentPairs = [{
                "name": Constants.getMessage("labelArtifactOptions"),
                "content": artifactOptionsContentArea
            },{
                "name": Constants.getMessage("labelDefectsProviderProperties"),
                "content": defectsProviderContentArea //Hard Code
            }, {
                "name": Constants.getMessage("labelRequisiteProHostProperties"),
                "content": reqproHostnameContentArea //Hard Code
            }, {
                "name": Constants.getMessage("labelResources"),
                "content": resourceEditorContentArea
            }, {
                "name": Constants.getMessage("labelReportProperties"),
                "content": reportPropertiesConentArea
            },{
				"name": Constants.getMessage("labelCPUNumber"),
				"content": CPUNumberContentArea	
			},{
				"name": Constants.getMessage("labelStateTransitionConstraint"),
				"content": stateTransitionConstraintContentArea
			},{
                "name": Constants.getMessage("labelExecutionStates"),
                "content": executionStatesContentArea
            },{
                "name": Constants.getMessage("labelTypeCategories", Constants.TYPE_PLAN),
                "content": planCategories
            },{
                "name": Constants.getMessage("labelTypeCategories", Constants.TYPE_CASE),
                "content": caseCategories
            },{
                "name": Constants.getMessage("labelRelatedSites"),
                "content": relatedLinks
            }]
        },
        
        _onOK: function(){
            this._getProjectPreference();
        },
		
		_getProjectPreference: function(){
			var keyValues = this.getCurrentContentArea().getValues();
            var self = this;
            for (var i = 0; i < keyValues.length; i++) {
				var keyValue = keyValues[i];
				var handler = {
	                success: function(property){
	                    if(property == null){
							self._createProjectPreference(keyValue.key, keyValue.value);
						}else{
							self._updateProjectPreference(property.itemId, keyValue.value);
						}
	                },
	                
	                error: function(e){
	                    console.debug(e);
	                }
	            }
	            var responseHandler = new ServiceResponseHandler(handler, "success", "error");
				
				var option = new com.ibm.asq.common.web.client.internal.option();
				option.getProjectPreferences(responseHandler, com.ibm.team.process.web.projectArea.itemId, keyValues[i].key);
            }
		},
		
		_createProjectPreference: function(key, value){
            var responseHandler = new ServiceResponseHandler(this, "_savedSuccess", "_error");
			
			var option = new com.ibm.asq.common.web.client.internal.option();
			option.createProjectPreferences(responseHandler, com.ibm.team.process.web.projectArea.itemId, key, dojo.toJson(value));
		},
		
		_updateProjectPreference: function(preferenceItemId, value){
            var responseHandler = new ServiceResponseHandler(this, "_savedSuccess", "_error");
			
			var option = new com.ibm.asq.common.web.client.internal.option();
			option.updateProjectPreferences(responseHandler, com.ibm.team.process.web.projectArea.itemId, preferenceItemId, dojo.toJson(value));
		},
		
		_savedSuccess: function(){
			var alertDialog = new AlertDialog({
                'message': Constants.getMessage("msgSavedSuccessfully")
            });
            alertDialog.setSecondaryTitle("");
            alertDialog.open();
			
			//if we are updating the artifact constraints then reload the cache
			if (this.getCurrentContentArea() == this.stateTransitionConstraintContentArea)
				EditorUtil.loadStateTransitionConstraintSettings(null, true);
		},
		
		setDirty: function(){
            if(!this.isEditable())
                return;
                
			var _dirty = false;
			var dirtyContentNames = "";
			for(var i = 0; i < this._nameContentPairs.length; i++){
				if(this._nameContentPairs[i].content.isDirty()){
					_dirty = true;
					dirtyContentNames += this._nameContentPairs[i].name + ",";
				}
			}
			dirtyContentNames = dirtyContentNames.substring(0, dirtyContentNames.length - 1);
			
			if(this.isDirty() == false && _dirty == true){
				dojo.publish(GlobalEvents.UpdateTabLabel, [window.location.hash, "", null, true]);
			}else if(this.isDirty() == true && _dirty == false){
				dojo.publish(GlobalEvents.UpdateTabLabel, [window.location.hash, "", null, false]);
			}
			this.dirty = _dirty;
			if(this.dirty){
				this.viewHeaderNode.setStatus(Constants.getCommonMessage("statusDirty"), ViewHeaderLayout.INFO, Constants.getMessage("labelUnsavedChanges", dirtyContentNames));
				this._saveButton.disabled = false;
				this._cancelButton.disabled = false;
			}else{
				this.viewHeaderNode.clearStatus();
				this._saveButton.disabled = true;
				this._cancelButton.disabled = true;
			}
		},
		
		isDirty: function(){
			return this.dirty;
		},
		
		onCancel: function(){
			this.postCreate();
			this.setDirty();
		},
		
		onSave: function(){
			//clean Header Status: 
			this.viewHeaderNode.clearStatus();
			
			//validation
			for(var i = 0; i < this._nameContentPairs.length; i++){
				if(this._nameContentPairs[i].content.onValidate){
					var result = this._nameContentPairs[i].content.onValidate();
					if(result.pass == false){
						this.viewHeaderNode.setStatus(result.message, ViewHeaderLayout.WARNING);
						return;
					}
				}
			}
			
			//invoke the global save transaction     
			this._cancelButton.disabled = true;
			this._saveButton.disabled = true;	
			
			this.viewHeaderNode.setProgressStart(Constants.getMessage("labelSavingArtifact", this.headerTitle));	
			
			for(var i = 0; i < this._nameContentPairs.length; i++){
				if (this._nameContentPairs[i].content.onSave) {
					this._nameContentPairs[i].content.onSave();
				}
			}
		},
		
		addSaveParticipantNum: function() {
			this.savingParticipant++;
		},
		
		saveFinished: function() {
			this.savingParticipant--;
			if(this.savingParticipant == 0) {
				this.viewHeaderNode.setProgressEnd();
				this.setDirty();
			}
		},
		 
		_error: function(e){
			console.debug(e);
		}
    });
})();
