/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.administration.CategoryAdminContentArea");

dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPropertyContentArea");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function(){
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
	
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.administration.CategoryAdminContentArea", com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPropertyContentArea, {
        
		className: "com.ibm.rqm.planning.web.ui.internal.view.administration.CategoriesEditor",
		artifactType: null,
		
		postCreate: function() {
			//ensure there is an artifact type specified
            if (!this.artifactType) {
                throw new Error("Parameter 'artifactType' is REQUIRED!");
            }			
			this.inherited('postCreate', arguments);
			
			this.csHelp.setButtonLabel(Constants.getMessage("labelCategoryHelp", this._getTypeDisplayName()));
		},
		
		setName: function(){
            this.name = Constants.getMessage("labelTypeCategories", this._getTypeDisplayName());
            dojox.data.dom.removeChildren(this._name);
            var name = document.createTextNode(this.name);
            this._name.appendChild(name);
        },
        
        setText: function(){
            this.text = Constants.getMessage("labelManageCategoriesText", this._getTypeDisplayName());
			dojox.data.dom.removeChildren(this._text);
            var text = document.createTextNode(this.text);
            this._text.appendChild(text);
        },
        
        setContent: function(){
			net.jazz.ajax.core.internal.loader.load_async(this.className, dojo.hitch(this, "_showEditor"));
			//this._showEditor();
        },

        _showEditor: function() {
			var editorConstructor = dojo.getObject(this.className);
			if (editorConstructor) {
	            dojox.data.dom.removeChildren(this._content);
	            this._editor = new editorConstructor({
					artifactType: this.artifactType,
					isDialog: false,
					nonDialogWidth: "95%"
				});
	            this._content.appendChild(this._editor.domNode);            				
			} else {
				console.error(this.declaredClass + ": Unable to load widget: " + this.className);
			}
		},
		
		_getTypeDisplayName: function() {
			if (this.artifactType == Constants.MODEL_TYPE_PLAN) {
				return Constants.TYPE_PLAN;
			} else if (this.artifactType == Constants.MODEL_TYPE_CASE) {
                return Constants.TYPE_CASE;
            }
		},
        
        getValues: function(){
        	return [];
        }
    });
})();
