/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.administration.DefectsProviderContentArea");

dojo.require("net.jazz.ajax.ui.PlatformUI");
dojo.require("net.jazz.ajax.core.internal.loader");

dojo.require("com.ibm.team.repository.web.foundation.Status");

dojo.require("com.ibm.team.repository.web.transport.ExternalTeamServerDescription");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.require("com.ibm.team.process.web.client.projectarea");


dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractContentArea");
dojo.require("com.ibm.rqm.planning.web.client.internal.PreferenceClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");

//dojo.require("com.ibm.rqm.defects.web.client.DefectsManager");
dojo.require("com.ibm.team.repository.web.foundation.NullProgressMonitor");

//dojo.require("com.ibm.rqm.defects.web.ui.internal.wizard.WizardDialog");


(function(){

var Status							= com.ibm.team.repository.web.foundation.Status;

var ServiceResponseHandler			= com.ibm.team.repository.web.transport.ServiceResponseHandler;
var Constants 						= com.ibm.rqm.planning.web.client.internal.Constants;
var AlertDialog 					= com.ibm.asq.common.web.ui.internal.widgets.AlertDialog;
var NullProgressMonitor				= com.ibm.team.repository.web.foundation.NullProgressMonitor;

//var WizardDialog					= com.ibm.rqm.defects.web.ui.internal.wizard.WizardDialog;

var getCurrentProjectArea			= com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
var getWorkbench					= net.jazz.ajax.ui.PlatformUI.getWorkbench;
//var getDefectsManager				= com.ibm.rqm.defects.web.client.DefectsManager.getInstance;

/*
 * FIXME this administartion page is not planning related and must be contributed by the defects plugin 
 */
dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.administration.DefectsProviderContentArea", 
			 [com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractContentArea], {

	csHelpId: "defectsprovider_admin_prop.html",
	_contentWidget: null,
			 	
	// ---- constructor mixed-in properties --------------------------------------------------------------------------------	

	// ---- api ------------------------------------------------------------------------------------------------------------	

	// ---- implementation -------------------------------------------------------------------------------------------------

    setName: function(){
		this._setTextNls("labelDefectsProviderProperties", this._name);
    },
    
    setText: function(){
		this._setTextNls("labelSetDefectsProviderProperties", this._text);
    },
    
    setContent: function() {
		this._contentWidget= new com.ibm.rqm.planning.web.ui.internal.view.administration.DefectsProviderContentArea._Content({}, this._content);
    },

    getValues: function(){
		return this._contentWidget.getValues();
    },
    
    isDirty: function() {
    	return false;
    },

	_setTextNls: function(labelKey, node) {
        dojox.data.dom.removeChildren(node);
        node.appendChild(document.createTextNode(Constants.getMessage(labelKey)));
	},

	__sentinel: null // terminates this class definition
});

dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.administration.DefectsProviderContentArea._Content",
			 [dijit._Widget, dijit._Templated], { 

	labelLoading: Constants.getMessage("labelLoading"),
	labelDefectsProviderProperties: Constants.getMessage("labelDefectsProviderProperties"),
	labelProvider: Constants.getMessage("labelProvider"),
	labelSummaryWithColon: Constants.getMessage("labelSummaryWithColon"),
	labelStatusWithColon: Constants.getMessage("labelStatusWithColon"),
	labelConfigure: Constants.getMessage("labelConfigure"),
	lableClear: Constants.getMessage("lableClear"),

	// ---- constructor mixed-in properties --------------------------------------------------------------------------------	

	_contentWrapper: null,
	
	_provider: null,
	_serverSummary: null,
	_serverDetails: null,
	_statusIcon: null,
	_statusMessage: null,
	_configureButton: null,
	
	_currentProvider: null,
	
	constructor: function(args){
	},

	// ---- api ------------------------------------------------------------------------------------------------------------	

	getValues: function() {
		return [];
	}, 
	
	// ---- widget implementation ------------------------------------------------------------------------------------------

	_rtcIconSrc: dojo.moduleUrl("com.ibm.rqm.planning.web", "RTC_logo.png"),
	templatePath: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/view/templates/administrator/DefectsProviderContentArea.html"),

	postCreate: function() {
		var className = "com.ibm.rqm.defects.web.client.DefectsManager";
		
		var loaded = function(){
			this._loadOptions();
		
			this.connect(this._configureButton, "onclick", this._configureClicked);
			this.connect(this._provider, "onchange", this._providerChanged);
			this.connect(this._deleteButton, "onclick", this._deleteClicked);
		};
		
		net.jazz.ajax.core.internal.loader.load_async("com.ibm.rqm.defects.web.ui.internal.wizard.WizardDialog", function(){});
        net.jazz.ajax.core.internal.loader.load_async(className, dojo.hitch(this, loaded));
	},

	// ---- implementation -------------------------------------------------------------------------------------------------

	_loadOptions: function() {
		var defectsManager = com.ibm.rqm.defects.web.client.DefectsManager.getInstance();
		defectsManager.ensureInitialized(new NullProgressMonitor(), dojo.hitch(this, function(status) {
			
			var defectsProviders= defectsManager.getDefectsProviders();
			
			if (defectsProviders) {
				for (var providerId in defectsProviders) {
					var providerName= defectsProviders[providerId].name;
					var providerOption= document.createElement("option");
					providerOption.appendChild(document.createTextNode(providerName));
					providerOption.setAttribute("value", providerId);
					
					if (providerId == defectsManager.getCurrentDefectsProviderId()) {
						providerOption.setAttribute("selected", "selected");
					}
	
					this._provider.appendChild(providerOption);
				}
				
				this._updateConnectionState(defectsManager.getDefectsProvider(defectsManager.getCurrentDefectsProviderId()));
			} else {
                var providerOption = document.createElement("option");
                providerOption.appendChild(document.createTextNode(Constants.getMessage("labelNoneProvidersAvailable")));
                providerOption.setAttribute("value", "");
                providerOption.setAttribute("selected", "selected");
                this._provider.appendChild(providerOption);
				this._configureButton.setAttribute("disabled", "");
			}
			dojo.removeClass(this._container, "loading");
			dojo.addClass(this._container, "loaded");
			this._isLoading= false;
		}));
	},

	_updateConnectionState: function(defectsProvider) {
		if (!defectsProvider)
			return; 
		this._setText(this._serverSummary, defectsProvider.getConnectionName());
		this._setText(this._serverDetails, defectsProvider.getConnectionDetails());

		this._checkProviderStatus(defectsProvider, true);
		this._currentProvider= defectsProvider;
	},
	
	_checkProviderStatus: function(defectsProvider, cancelIfNotLoggedIn) {
		this._status.className= "checking";
		this._setText(this._statusMessage, Constants.getMessage("labelChecking"));
		dojo.toggleClass(this._configureButton, "enabled", defectsProvider.needsConfiguration());

        defectsProvider.checkProviderStatus(dojo.hitch(this, function(status){
            this._checkProviderStatusHandler(status, defectsProvider)
        }), cancelIfNotLoggedIn);
	},
	
	_checkProviderStatusHandler: function(status, defectsProvider) {
		var statusClass= "ok";
		var statusMessage= Constants.getMessage("labelOk");

		if (status.getSeverity() == Status.CANCEL) {
			var statusClass= "unconfirmed";
			var statusMessage= Constants.getMessage("labelClickToVerify");
			
			var handle= this.connect(this._statusMessage, "onclick", function(evt) {
				evt.stopPropagation();
				this.disconnect(handle);
				this._checkProviderStatus(defectsProvider, false);
			});
		} else if (!status.isOK()) {
			statusClass= "error";
			statusMessage= status.getMessage();
		}

		this._status.className= statusClass;
		this._setText(this._statusMessage, statusMessage);
	},
	
	_setText: function(node, text) {
		dojox.data.dom.removeChildren(node);
		if (text != null) {
			node.appendChild(document.createTextNode(text));
		}
	},

	_configureClicked: function(evt) {
		var provider= this._currentProvider;
		if (provider != null && provider.needsConfiguration()) {
			var wizardDialog= com.ibm.rqm.defects.web.ui.internal.wizard.WizardDialog.create(provider.getConfigurationWizard());
	        this.connect(wizardDialog, "onFinish", dojo.hitch(this, function(){
	           this._updateConnectionState(provider);
	        }));
		}
	},
	
	_providerChanged: function(evt) {
		var defectsManager= com.ibm.rqm.defects.web.client.DefectsManager.getInstance();
		defectsManager.ensureInitialized(new NullProgressMonitor(), dojo.hitch(this, function(status) {
			var defectsProvider= defectsManager.getDefectsProvider(this._provider.value);
			this._updateConnectionState(defectsProvider);
		}));
	},
	
	_deleteClicked: function(evt){
		var provider= this._currentProvider;
		if (provider != null && provider.isConfigured()) {
			provider.clearConnectionDetails(dojo.hitch(this, function(status, response) {
					var defectsManager = com.ibm.rqm.defects.web.client.DefectsManager.getInstance();
					defectsManager.setUninitialized(); 
					this._providerChanged();
			}));
		}
	},

	__sentinel: null // terminates this class definition
});

})();
