/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008,2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
/*
 * This widget provides the basic structure of any execution widget.
 *
 * Author: vasrivas
 */
console.debug("Loading: com.ibm.rqm.execution.web.ui.internal.view.common.ExecutionViewer");
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.common.ExecutionViewer");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.client.internal.CommonPreferenceClient");

dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("com.ibm.rational.test.lm.web.client.internal.config");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ToolAdapterRegistrationClient");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionClient");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.table.MachineAdapterTableView");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");

(function() {

var ServiceResponseHandler			= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var Utility							= com.ibm.rqm.execution.web.ui.internal.util.Utility;
var Constants       				= com.ibm.rqm.planning.web.client.internal.Constants;
var ExecutionClient 				= com.ibm.rqm.execution.web.client.internal.execution.ExecutionClient;
var ExecutionWorkItemClient			= com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient;
var ToolAdapterRegistrationClient	= com.ibm.rqm.execution.web.client.internal.execution.ToolAdapterRegistrationClient;
var ExecutionWorkItemClient 		= com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient;
var getAuthenticatedContributor		= com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
var MachineAdapterTV           		= com.ibm.rqm.execution.web.ui.internal.view.table.MachineAdapterTableView;
var GlobalEvents 					= com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
var AlertDialog 					= com.ibm.asq.common.web.ui.internal.widgets.AlertDialog;

dojo.declare(
	"com.ibm.rqm.execution.web.ui.internal.view.common.ExecutionViewer",
	[dijit._Widget, dijit._Templated],
	{
		templateString: "<div dojoAttachPoint=\"_container\">"+
						"<div dojoAttachPoint=\"_dialog\"></div>"+
						"</div>",
		
		EXECUTE: 0,
		progressPercent: 0,
		autoSelect: true,
		isNew: false,
		
		constructor: function() {
			/*
			 * parentController: Required 
			   parentEditor: Required - should be ExecutionPageBody
			   ewiItemId: Required 
			   script: Required
			   ewiConfigId: optional
			   _resultId: Optional 
			   ergId: Optional 
			   requestId: Optional 
			 */
		},
		
		postCreate: function() {
		},	
		
		//Optional over-ride for custom initialization
		initialize: function(){
			this.parentEditor.cancelButton.disabled = true;
			var ewi = this.parentEditor._ewi;
			if(ewi && ewi.currentResult && ewi.currentResult.script && ewi.currentResult.script.id == this.script.id){
				if(ewi.currentResult.properties){
					for(var j=0;j<ewi.currentResult.properties.length;j++){
						if(ewi.currentResult.properties[j].propertyName == "adapterId"){
							this.lastSelectedAdapterExternalId = ewi.currentResult.properties[j].propertyValue;
							break;
						}
					}
				}
			}
			if(!this.requestId)
				this.openAdapterSelectionDialog(this.script.scriptType.id)
			else
				this.setRequestId({id: this.requestId});
		},
		
		//Required over-ride
		getHelpContextID: function(){
			return null;
		},
		
		//Helper
		getCurrentUserId: function(){
			return getAuthenticatedContributor().userId;
		},
		
		//Optional over-ride 
		openAdapterSelectionDialog: function(/*String - scriptTypeId*/scriptTypeId){
			var responseHandler = new ServiceResponseHandler(this, "_setCurrentServerTime", "_error");
			ExecutionClient.getServerTime(responseHandler);
		},
		
		//Required over-ride: Pass on the attributes/properties needed as part of execution request
		getExecutionRequestProperties: function(){
			var props = [];
			if (this.script.properties){
				for(var i=0;i<this.script.properties.length;i++){
					props.push(this.script.properties[i])
				}
			}
			return props;
		},
		
		getLocation: function(sections, type){
			var sectionId = "com.ibm.rqm.planning.editor.section.planResources";
			var location = "";
			var items = [];
			for(var i=0;i<sections.length;i++){
				if(sections[i].id == sectionId){
					items = sections[i].content ? dojo.fromJson(sections[i].content) : []
					break;
				}
			}
			for(var j=0;j<items.length;j++){
				if(items[j].type == type)
					location =items[j].resolvedPath; 
			}
			return location;
		},
		
		updateParentDetailSection: function(adapter){
			this.parentEditor.updateDetailSection(adapter);
		},
		
		//Optional over-ride
		createExecutionRequest: function(){
			//Show adapterDetails in the parent.
			this.updateParentDetailSection(this.selectedAdapter);
			
			//createExecutionRequest properties and post request
			var properties = this.getExecutionRequestProperties();//Must return an Array of properties
			properties.push({propertyName: "scriptId", propertyValue: this.script.id+"", propertyType: "String"});
			properties.push({propertyName: "scriptItemId", propertyValue: this.script.itemId, propertyType: "String"});
			properties.push({propertyName: "scriptTypeName", propertyValue: this.script.scriptType.name, propertyType: "String"});
			if(this.ewiConfiguration){
				properties.push({propertyName: "configuration", propertyValue: this.ewiConfiguration, propertyType: "String"});
				properties.push({propertyName: "configId", propertyValue: this.ewiConfigId, propertyType: "String"});
			}	
			properties.push({propertyName: "testCaseName", propertyValue: this.parentEditor._ewi.testCase.name, propertyType: "String"});
			if(this.parentEditor._ewi.testPlan){
				var shareLocation = this.getLocation(this.parentEditor._ewi.testPlan.sections, this.script.scriptType.name);
				properties.push({propertyName: "testPlan", propertyValue: this.parentEditor._ewi.testPlan.name, propertyType: "String"});
				properties.push({propertyName: "sharePrefix", propertyValue: shareLocation, propertyType: ""});
			}
			properties.push({propertyName: "testPhase", propertyValue: (this.parentEditor._ewi.phase ? this.parentEditor._ewi.phase.name: ""), propertyType: "String"});
			properties.push({propertyName: "ewiId", propertyValue: this.parentEditor._ewi.id, propertyType: "link"});
			properties.push({propertyName: "scriptType", propertyValue: this.script.scriptType.id, propertyType: "String"});
			properties.push({propertyName: "scriptItemId", propertyValue: this.script.itemId, propertyType: "link"});
			properties.push({propertyName: "machine", propertyValue: this.selectedAdapter.hostName, propertyType: "String"});
			/*properties.push({propertyName: "owner", propertyValue: this.getCurrentUserId(), propertyType: "String"});*/
			properties.push({propertyName: "ewiItemId", propertyValue: this.ewiItemId, propertyType: "String"});
			properties.push({propertyName: "scriptName", propertyValue: this.script.name, propertyType: "String"});
			
			//If reservations were created for this execution they will be in the this.reservations variable.
			//If there are any then extract them into a comma delimited string and add them to the properties array.
			//These reservations will be released once the execution finishes.
			if (this.reservations && this.reservations.ids && this.reservations.ids.length > 0)
			{
				var idArray = this.reservations.ids;
				var resIDs = "";
				for (var i = 0; i < idArray.length; i++)
				{
					if (i > 0)
						resIDs += ",";  //comma separate
					resIDs += idArray[i];
				}
				//add the string to the array of properties
				properties.push({propertyName: "reservationUUIDs", propertyValue: resIDs, propertyType: "String"});
			}
			
			this.isNew = true;
			var requestObj = {
				selectedAdapterId: this.selectedAdapter.id,
				requestType: this.EXECUTE,
				properties: properties,
				isNew: this.isNew
			}
			var responseHandler = new ServiceResponseHandler(this, "setRequestId", "createRequestError");
			ExecutionClient.postCreateRequest(responseHandler, requestObj);
		},
		
		//Optional over-ride if need to ping faster/slower - Time is in Milliseconds
		getPingTimeOut: function(){
			return 1500;
		},
		
		//Optional over-ride if want to check progress in widget
		setRequestId: function(request){
			if(this.isNew)
				this.parentEditor.setHeaderStatus(Constants.getMessage("msgExecReqCreated"), 3);
			this.isNew = false;	
			this.requestId = request.id;
			this._remoteProgress();
		},
		
		createRequestError: function(error){
			this.parentEditor.setHeaderStatus(Constants.getMessage("msgErrorStartingRun"), 1, error);
		},
		
		//Optional over-ride if there is a need to show custom messages, call this after over-riding
		setCurrentRequest: function(/*Object*/ request){
			
			if(this.parentEditor && this.parentEditor.cancelButton && this.parentEditor.cancelButton.disabled){
				this.parentEditor.cancelButton.disabled = false;
			}
			
			if(request.state && request.state.id == "com.ibm.rqm.executionframework.common.requeststate.cancelled" && this.parentEditor){
				this.parentEditor.setHeaderStatus(Constants.getMessage("msgExeCancel"), 3);
				if(this.__timer){
					console.debug("request state is cancelled. Stopping timer.")
					clearInterval(this.__timer);
					delete this.__timer;
				}
				this.parentEditor.cancelButton.disabled = true;
				dojo.style(this.parentEditor.showResultButton, "display", "none");
				this.parentEditor._header.addRightViewAction(Constants.getMessage("labelClose"), dojo.hitch(this, "onClose"), null, null);
				return;
			}
			
			if(this.selectedAdapter == null){
				var eSelf = this;
				var callbackObj = {
					success: function(adapters){
						if(adapters && adapters.length > 0){
							eSelf.selectedAdapter = adapters[0];
							eSelf.updateParentDetailSection(eSelf.selectedAdapter);
						}	
					},
					failure: function(errorObj){
						console.error("Error fetching adapter info in ExecViewer, message - "+errorObj.message);
					}
				}
				var params = {
					id: this.latestRequestObject.selectedAdapterId
				}
				var responseHandler = new ServiceResponseHandler(callbackObj, "success", "failure");
				ToolAdapterRegistrationClient.getAdaptersWithMachines(responseHandler, params);
			}
			
			var percent =request.progress+"%";
			if(percent && parseInt(percent) > 0){
				this.parentEditor.clearHeaderStatus()
				dojo.publish(GlobalEvents.ArtifactsUpdated, [Constants.TYPE_REQUEST, [request]]);
			}
			if(percent=="100%"){
				var properties = request.propertiesMap;
				var executionResultId = "";
				for(var i=0;i<properties.length;i++){
					if(properties[i].propertyName === "resultItemId"){
						executionResultId = properties[i].propertyValue;
						break;
					}
				}	
				this._finalizeForLog(executionResultId);
				return;
			}
		},
		
		onClose: function(){
			setTimeout(dojo.hitch(this.parentEditor, "publishClosure"), 1500);
		},
		
		//Optional over-ride
		updateProgressBar: function(percent /*eg. 5 */){
			//Calling updateProgress function in EPB
			if(this.parentEditor){
				this.parentEditor.updateProgress(percent);
			}	
		},
		
		//Optional over-ride
		onStartOfExecution: function(reservations){
			//If reservations were made for this execution remember them for later processing
			this.reservations = reservations;
			//this.selectedAdapter gives the selected Adapter details
			var self = this;
			var callbackObj = {
				success: function(config){
					self.ewiConfiguration = config.name;
					self.ewiConfigId = config.id;
					self.createExecutionRequest();
				},
				failure: function(){
					console.error("EWI configuration was not fetched & set");
					self.createExecutionRequest();
				}
			}
			
			if (this.parentEditor._ewi.configuration) {
			 	var responseHandler = new ServiceResponseHandler(callbackObj, "success", "failure");
			 	this.config = new com.ibm.rational.test.lm.web.client.internal.config();
			 	this.config.retrieveConfigurationWithDetails(responseHandler, this.parentEditor._ewi.configuration);
			}else
				self.createExecutionRequest();
		},

		//Optional over-ride
		onCancel: function(/*Boolean*/showAlertMessage, /*String*/message){
			if(showAlertMessage){	
				var msg = ""
				if(message)
					msg=message;
				this.parentEditor.setHeaderStatus(Constants.getMessage("msgExeCancel")+msg, 3);
			}
			//Clear off the timer if cancel is hit.
			if(this.__timer){
				clearInterval(this.__timer);
				delete this.__timer;
			}			
			var instructions = [];
			instructions.push({requestId: this.requestId, instructionType: "CANCEL"});
			var adapterId = this.selectedAdapter ? this.selectedAdapter.id : this.latestRequestObject.selectedAdapterId;

			var params = {
				id: adapterId,
				instructions: instructions,
				isNew: false
			}
			
			var responseHandler = new ServiceResponseHandler(this, "_refreshCancelState", "_error");
			ToolAdapterRegistrationClient.postRegister(responseHandler, params);

			history.back();	
		},
		
		_refreshCancelState: function() {
			console.debug("after cancel");
		},
		
		//Optional over-ride
		onEndOfExecution: function(){	/*Shows the result of the EWI*/
			if(!this._resultItemId)	{
				console.error("Missing required parameter this._resultItemId in ExecutionViewer");
				return;
			}	
			var resultId = this._resultItemId;
			var args = {
				ewiId: this.parentEditor._ewi.id,
				resultItemId: resultId
			};
			if(this.ergId)
				parent.location = Utility.runSuite({groupId: this.ergId});//Return to the suite execution page not result
			else	
				parent.location = Utility.getResultURI(args);
		},
		
		//Helper
		setAdapter: function(/*Adapter object*/adapter){
			this.selectedAdapter = adapter
		},
		
		//////////////////////////////////////////////////////////////////////////////////
		////////////////////Internal Functions //////////////////////////////////////////
		////////////////////////////////////////////////////////////////////////////////
		
		_setCurrentServerTime: function(currentServerTime){
			this._currentServerTime = currentServerTime;
				var adapterArgs = {
					serverTime:this._currentServerTime,
					scriptType: this.script.scriptType.id,
					/*configID: this.ewiConfigId,*/
					loadingCompleteCallback: dojo.hitch(this, this._createDialog),
					onCheckedStateChange: dojo.hitch(this, this._onCheckedStateChange),
					lastSelectedAdapterExternalId: this.lastSelectedAdapterExternalId
					}
				this.adapterTable = new MachineAdapterTV(adapterArgs);
		},
		
		_createDialog: function(engineList){
			var userPref = com.ibm.asq.common.web.client.internal.CommonPreferenceClient.getAutomaticAdapterSelectionPreference();
			if(userPref && this.autoSelect){
				var avaiableAdapters = [];
				for(var i=0;i<engineList.length;i++){
					if(engineList[i].adapterInfo && ((engineList[i].adapterInfo.serverTime - engineList[i].adapterInfo.lastHeartBeat) <= 2*(engineList[i].adapterInfo.pollingInterval))){
						if(engineList[i].adapterInfo.requestsInQueue == 0)
							avaiableAdapters.push(engineList[i]);
					}
				}
				if(avaiableAdapters.length == 1){
					this.selectedAdapter = avaiableAdapters[0].adapterInfo;
					this._reserveMachine(avaiableAdapters[0].machineID);
					return;
				}
			}
			
			if (!this._adapterDialog) {
				//create dialog
		        var dialogArgs = {
		            okCallback: dojo.hitch(this, "_okButtonClicked"),
		            cancelCallback: dojo.hitch(this, "_cancelButtonClicked"),
					style: "z-index: 9999;"
		        };
		        
		        this._adapterDialog = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(dialogArgs);
		        this._adapterDialog.setWidth("80%");
		        this._adapterDialog.setHeight("80%");
				this._adapterDialog.getOkButton().innerHTML = Constants.getMessage("labelRun");
				this._adapterDialog.contentContainer.appendChild(this.adapterTable.domNode);
		        this._adapterDialog.setSecondaryTitle(Constants.getMessage("labelChooseMachineForRun"));
		        this._adapterDialog.getOkButton().disabled = false;
				
			} else {
				//Clean off the selected adapter before being re-used.
				this.selectedAdapter = null;
			}			
		    this._adapterDialog.open(false);   				
		},
		_onCheckedStateChange: function(isChecked){
			if(this._adapterDialog){
				//It is possible that the dialog was not created and auto selection happened.
				if(isChecked){
					this._adapterDialog.getOkButton().disabled = false;
				}else{
					this._adapterDialog.getOkButton().disabled = true;
				}
			}	
		},
		_onHide: function(){
			if(this._adapterDialog){
				this._adapterDialog.getCancelButton().disabled = true;
				this._adapterDialog.getOkButton().disabled = true;
			}
			if(this.selectedAdapter == null)
				alert(Constants.getMessage("msgExeCancel"));
		},
		
		_okButtonClicked: function(){
			var selection = this.adapterTable.getSelectedInfo();
			if(!selection.adapter){
				alert(Constants.getMessage("msgSelectAdapter"))
				return;
			}
			if(this._adapterDialog){
				this._adapterDialog.getCancelButton().disabled = true;
				this._adapterDialog.getOkButton().disabled = true;
			}
			this.selectedAdapter = selection.adapter;
			this._reserveMachine(selection.machineID);
		},
		
		_reserveMachine: function(machineId){
			try{
				var responseHandler = new ServiceResponseHandler(this, "onStartOfExecution", "_machineReservationFailed");
				this.adapterTable.reserveMachine(machineId, responseHandler);
			}catch(execp){
				console.error("exception in ExecutionViewer _reserveMachine: "+execp.message)
			}
		},
		
		_machineReservationFailed: function(errorObj){
			//this._displayAlertDialog(Constants.getMessage("msgMachineReservationFailed",errorObj.message));
			console.debug(Constants.getMessage("msgMachineReservationFailed",errorObj.message));
			this.onStartOfExecution(null);
		},
		
		_cancelButtonClicked: function(){
			setTimeout(dojo.hitch(this.parentEditor, "publishClosure"), 500);
		},
		////////////////////////////////////////////////////////////////////////////////////////////
		////////////////////////////////Remote Progress Monitor Functions///////////////////////////
		////////////////////////////////////////////////////////////////////////////////////////////
		
		_getProgressReport: function(result){
			if(this.haveLatest){
				var deferred = new dojo.Deferred();
				//use the result here to calculate the progress and return then
				if(result == "")
					result = "0:";
				this.progressPercent = result;
				deferred.callback(this.progressPercent);
				
				this.haveLatest=false;
				return deferred;
			}
			else{
				var execViewerSelf = this;
				var callbackObj = {
					success: function(items){
						var resp = "";
						resp = items;
						execViewerSelf.haveLatest=true;
						var def = execViewerSelf._getProgressReport(resp);
						execViewerSelf.responseFromService = def;
					},
					error: function(e){
						execViewerSelf._error(e);
					}				
				}
			
				var param = {
					requestId: execViewerSelf.requestId
				}
				var responseHandler = new ServiceResponseHandler(callbackObj, "success", "error");
				ExecutionWorkItemClient.getRequestDTO(responseHandler, param);
			}
		},

		_remoteProgress: function(){
			var execViewerSelf = this;
			var timeOut = this.getPingTimeOut();
			var _timer = setInterval(function(){
				var report = execViewerSelf._getProgressReport();
				if(!report)
					report = execViewerSelf.responseFromService;
				if(report){
					report.addCallback(function(requests){
						var requestObject = requests ? requests[0] : null;
						if(requestObject && execViewerSelf.requestId == requestObject.id){
							execViewerSelf.latestRequestObject = requestObject;
							var percent = requestObject.progress;
							execViewerSelf.updateProgressBar(percent);
							execViewerSelf.setCurrentRequest(requestObject);
							console.debug("timer running");
							if(percent == "100"){
								clearInterval(_timer);
								_timer = null;
							}
						}			
					});
				}
			}, timeOut); 
			
			this.__timer = _timer;
		},

		_isArray: function(arr){
			return (arr.constructor.toString().indexOf("Array") != -1);
		},

		_finalizeForLog: function(resultId){
			this._resultItemId = resultId;
			if(!this.parentEditor._resultId || this.parentEditor._resultId != resultId){
				this.parentEditor._resultId = resultId;
				dojo.publish(GlobalEvents.UpdateTabUri, [window.location.hash, 
					Utility.startExecution(this.parentEditor.ewi, this.parentEditor.runScript, 
						this.parentEditor._resultId, this.parentEditor.requestId, this.parentEditor.ergId)
					]);
			}			
			this.parentEditor.enableNavigationToResultPage();
		},
		
		cleanUp: function(){
			if(this.__timer){
				console.debug("deleting timer on tabClose");
				clearInterval(this.__timer);
				delete this.__timer;
			}
		},
		
		_error: function(errorObj) {
			if(this.__timer){
				console.error("Error in ExecutionViewer  [ " + errorObj.message + " ]")
				clearInterval(this.__timer);
				delete this.__timer;
			}
		},
		_displayAlertDialog: function(message){
            var alertDialog = new AlertDialog({
                'message': message
            });
            alertDialog.open();
        }
	}
);

})();
