/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.configuration.web.ui.internal.view.configuration.WeightingPanel");

dojo.require("com.ibm.rqm.configuration.web.ui.internal.view.configuration.WeightingPanelBody");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.Button");

(function() {
var WeightingPanelBody = com.ibm.rqm.configuration.web.ui.internal.view.configuration.WeightingPanelBody;
var LEFTTAB_CSS = "lefttab";
var LEFTTAB_ACTIVE_CSS = "lefttab-active";
var Button = com.ibm.asq.common.web.ui.internal.widgets.Button;
dojo.declare(
	"com.ibm.rqm.configuration.web.ui.internal.view.configuration.WeightingPanel",
	[dijit._Widget, dijit._Templated],
	{
		templatePath: dojo.moduleUrl("com.ibm.rqm.configuration.web", "ui/internal/view/templates/configuration/WeightingPanel.html"),
		
		constructor: function(args) {
			this.env = (args.env != null) ? args.env : null;
		},
		
		postCreate: function(){
			this.tabMap = new Array();
			this.tabContainerMap = new Array();
			this._setTab();
			if(dojo.isArray(this.env) && this.env.length != 0){
				this._initTabContainer(this.env);
				this._setActiveTab(this.env[0]);
				this._setTabContainer(this.env[0]);
			}
		},
		
		_setTab: function() {
			dojox.data.dom.removeChildren(this._EWIAdvancedWeightingsLabelTable);
			for(var i=0; i<this.env.length; i++) {
				var tr = this._setTabNameElement(this.env[i]);
//				this._addEvent(tr, this.env[i]);
				this._EWIAdvancedWeightingsLabelTable.appendChild(tr);
			}
		},
		
		_initTabContainer: function(env){
			for(var i=0; i<env.length; i++){
				var tabContainer = new WeightingPanelBody({env: env[i]});
				var args = {};
				args.key = env[i].key;
				args.value = tabContainer;
				this.tabContainerMap.push(args);
			}
		},
		
		_setTabContainer: function(value) {
			dojox.data.dom.removeChildren(this._WeightingPanelTabContent);
			for(var i=0; i<this.tabContainerMap.length; i++){
				if(this.tabContainerMap[i].key && this.tabContainerMap[i].key == value.key){
					this._WeightingPanelTabContent.appendChild(this.tabContainerMap[i].value.domNode);
					break;
				}
			}
		},
		
		_setTabNameElement: function(env) {
			var tr = document.createElement("tr");
			var td = document.createElement("td");
			td.appendChild(document.createTextNode(env.key));
			td.className = LEFTTAB_CSS;
			var self = this;
			dojo.connect(td, "onclick", function(e){
				self._setActiveTab(env);
				self._setTabContainer(env);
			});
			td.id = env.key;
			tr.appendChild(td);
			this.tabMap.push({key:env.key, value:td});
			return tr;
		},
		
		_addEvent: function(element,value){
			var self = this;
			dojo.connect(element, "onclick", 
								function(e){
									self._setActiveTab(value);
									self._setTabContainer(value);
								});
		},
		
		_setActiveTab: function(value){
			for(var i=0; i<this.tabMap.length; i++){
				if(this.tabMap[i].key != value.key){
					this.tabMap[i].value.className = LEFTTAB_CSS;
				}else{
					this.tabMap[i].value.className = LEFTTAB_ACTIVE_CSS;
				}
			}
		},
		
        getWeightings: function(){
			var weightings = [];
			for(var i=0; i<this.env.length; i++){
				for(var j=0; j<this.tabContainerMap.length; j++){
					if(this.tabContainerMap[j].key && this.tabContainerMap[j].key == this.env[i].key){
						weightings.push(this.tabContainerMap[j].value.getWeightings());
					}
				}
			}
			return weightings;
		},
		
		_error: function(e) {
			if(e && e.message){
				console.error(e.message);
			}else{
				console.error(e);
			}
		}			
	}
);

})();
