/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
DataPoolPlugin = dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.construction.manualscripteditor.DataPoolPlugin");
DataPoolPlugin.PLUGIN_ID = 'datapool';

dojo.require("dijit._editor._Plugin");

dojo.require("dijit.Dialog");
dojo.require("dijit.form.Button");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.properties.DataPoolView");
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");

dojo.requireLocalization("dijit._editor", "LinkDialog");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function(){
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.construction.manualscripteditor.DataPoolPlugin", [dijit._editor._Plugin], {
        buttonClass: dijit.form.Button,
        useDefaultCommand: false,
        
        _onOpenDialog: function(){
			
 //           if (this.editor.iframe.contentDocument) {
                var a = dojo.withGlobal(this.editor.window, "getAncestorElement", dijit._editor.selection, [this.tag]);
                var url, text;
                // FIXME: IE is *really* b0rken
                if (dojo.isIE) {
                    this._savedSelection = this.editor.document.selection.createRange().getBookmark();
                }
                var dataPool = this.editor.parentWidget._getDatapool();
                if (!dataPool) {
                    alert(Constants.getMessage("msgNoTestDataSelected"));
                    return;
                }
                var mainDiv = document.createElement("div");
                this.dataPoolWidget = new com.ibm.rqm.planning.web.ui.internal.view.construction.properties.DataPoolView();
                this.dataPoolWidget.initialize({
                    parent: this
                });
                var args = {
                    primaryTitle: Constants.getMessage("labelInsertTestDataColumn"),
                    isClosable: true,
                    contentNode: this.dataPoolWidget.domNode,
					okCallback: dojo.hitch(this.dataPoolWidget, "ok"),
					cancelCallback: dojo.hitch(this.dataPoolWidget, "cancel")
                }
                this.dialog = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(args);
				this.dataPoolWidget.setData(dataPool);
					
                this.dialog.open(false);
//            }
        },
        
        _initButton: function(){
            var _this = this;
            this.tag = this.command == DataPoolPlugin.PLUGIN_ID ? 'inserthtml' : 'a';
            this.command = 'inserthtml';
            this.button = new this.buttonClass({
                label: Constants.getMessage("labelInsertTestDataColumn"),
                showLabel: false,
                iconClass: "DatapoolIcon DatapoolIconPos",
                onClick: dojo.hitch(this, "_onOpenDialog"),
                tabIndex: "-1"
            });
        },
        updateState: function(){},
        setValue: function(args){
            //TODO: prevent closing popup if the text is empty
            if (dojo.isIE) {
                var a = dojo.withGlobal(this.editor.window, "getAncestorElement", dijit._editor.selection, [this.tag]);
                if (a) {
                    dojo.withGlobal(this.editor.window, "selectElement", dijit._editor.selection, [a]);
                }
            }
            var template = "";
            for (var i = 0; i < args.length; i++) {
                var src = args[i].id;
                template += '<button type="button" name="variable" id="' + args[i].id + '" disabled="true" style="color: #005C87; background-color: #EBF3F1;">' + args[i].col1 + '</button> ';
            }
            this.editor.execCommand('inserthtml', template);
        }
    });
    
})();
dojo.subscribe("dijit.Editor.getPlugin", null, function(o){
        if (o.plugin) {
            return;
        }
        switch (o.args.name) {
            case DataPoolPlugin.PLUGIN_ID:
                o.plugin = new com.ibm.rqm.planning.web.ui.internal.view.construction.manualscripteditor.DataPoolPlugin({
                    command: o.args.name
                });
        }
    });