/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading.. com.ibm.rqm.planning.web.ui.internal.view.construction.properties.CompareView");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.construction.properties.CompareView");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function() { // module container

var COMPARE_VIEW			="compareView"
var Constants 				= com.ibm.rqm.planning.web.client.internal.Constants;
dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.construction.properties.CompareView",[dijit._Widget, dijit._Templated],
	{
		templatePath: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/view/templates/construction/properties/CompareView.html"),
		hideActual:false,
		editable:true,
		
		constructor: function(params){
			if(params.hideActual)
				this.hideActual = params.hideActual;
			if(params.editable)
				this.editable = params.editable;
			if(params.callback)
				this.callback = params.callback;
			if(params.callbackData)
				this.callbackData = params.callbackData;
			this.isForDataEntry = false;
		},
		postCreate: function(){
			this._initializeView();
		},
		setExpectedValue: function(comment){
			this._expectedtextArea.value = comment;
			this._expectedValue = comment;
		},
		setActualValue: function(comment){
			this._actualtextArea.value = comment;
			this._actualValue = comment;
		},
		setFocus:function(){
			//if(this.editable){
				this._expectedtextArea.focus();
				if(!this.isForDataEntry && !this.hideActual)
					this._actualtextArea.focus();
			//}
		},
		setDataEntryOnly:function(value){
			this.isForDataEntry = value;
		},
		getDataEntryOnly:function(){
			return this.isForDataEntry;
		},
		setData: function(elements){
			if(!elements || elements.length ==0){
				this.setExpectedValue("");
				this.setActualValue("");
				return;
			}
			for(var i=0;i<elements.length;i++){
				var name = elements[i].propertyName;
				var value = elements[i].propertyValue;
				if(value){
					var splitValues = value.split(":");
					if(name == "compare" || name == "dataentry"){
						this.setExpectedValue(this._fixColon(splitValues[0],true));
						if(splitValues[1]){
							this.setActualValue(this._fixColon(splitValues[1],true));
							this._compare();
						}
						else
							this.setActualValue("");
						if(!this.editable)
							this._compare();
						if (name == "dataentry") {
							this.isForDataEntry = true;
							this._hideActualArea();
						}else{
							this.isForDataEntry = false;
							this._hideActualArea();
						}
						break;
					}
				}					
			}
		},
		getData: function(){
			var returnData = new Array();
			returnData.push(COMPARE_VIEW);
			if(!this.isForDataEntry)
				returnData.push("compare");
			else
				returnData.push("dataentry");
			var expectedText = this._expectedValue;
			if(expectedText.length>250){
				expectedText = expectedText.substr(0,249);
			}
			var value = this._fixColon(expectedText,false);
			if (!this.isForDataEntry && this._actualValue && this._actualValue.length > 0) {
				var actualText = this._actualValue;
				if(actualText.length>250){
					actualText = actualText.substr(0,249);
				}
				value = value + ":" + this._fixColon(actualText, false);
			}
			returnData.push(value);			
			return returnData;
		},
		_fixColon:function(value,reverse){
			if (reverse){
				var str = value.replace(/&colon;/g, ":");
			}else {
				var str = value.replace(/\:/g, "&colon;");
			}
			return str;
		},
		_hideActualArea:function(){
			if(this.isForDataEntry && !this.hideActual){
				this._expectedtextArea.readOnly = true;	
				dojo.addClass(this._actual,"hidden");
				if(this.actualAreaHandle)
					dojo.disconnect(this.actualAreaHandle);
				if(this.expectedAreaHandle)
					dojo.disconnect(this.expectedAreaHandle);
				this._expectedtextAreaLabel.innerHTML = "<b>"+Constants.getMessage("labelDuringCompare")+"</b>";
			}else if (!this.hideActual) {
				this._expectedtextArea.readOnly = true;
				this._expectedtextAreaLabel.innerHTML = "<b>"+Constants.getMessage("labelDuringCompare")+"</b>";
				dojo.removeClass(this._actual, "hidden");
				this._actualtextAreaLabel.innerHTML = "<b>" + Constants.getMessage("labelToCompare") + "</b>";
				this.actualAreaHandle = dojo.connect(this._actualtextArea, "onkeypress", this, this._compare);
			}
			if(!this.editable){
				this._expectedtextArea.readOnly = true;
				this._actualtextArea.readOnly = true;
				if(this.actualAreaHandle)
					dojo.disconnect(this.actualAreaHandle);
				if(this.expectedAreaHandle)
					dojo.disconnect(this.expectedAreaHandle);
			}
		},
		
		_initializeView: function(){
			this._expectedtextAreaLabel.innerHTML = "<b>"+Constants.getMessage("labelForCompare")+"</b>";
			this.setExpectedValue("");
			this.expectedAreaHandle = dojo.connect(this._expectedtextArea, "onkeypress", this, this._validate);
			this.setActualValue("");
			this._resultLabel.innerHTML = Constants.getMessage("labelComparisonResult");
			this._hideActualArea(this.hideActual,this.editable);
		},
		_validate:function(e){
			if(e && (e.keyChar || e.keyCode)){
				setTimeout(dojo.hitch(this, this._validate), 1);
			}else{
				this._expectedValue = this._expectedtextArea.value 
				if(this._expectedValue.length>250){
					this._msgArea.innerHTML = "<b>"+Constants.getMessage("labelError")+": "+Constants.getMessage("labelTextTooLong")+"<b>";
					dojo.removeClass(this._msgArea,"hidden");
					this.msgAreaShowing = true;
				}
				else if(this.msgAreaShowing == true){
					this._msgArea.innerHTML = "";
					dojo.addClass(this._msgArea,"hidden");
					this.msgAreaShowing = false;					
				}
			}
	
		},
		_compare:function(e){
			if(e && (e.keyChar || e.keyCode)){
				setTimeout(dojo.hitch(this, this._compare), 1);
			}else{
				this._actualValue = this._actualtextArea.value;
				if (this._actualValue.length > 250) {
					this._msgArea.innerHTML ="<b>"+Constants.getMessage("labelError")+": "+Constants.getMessage("labelTextTooLong")+"<b>";
					dojo.removeClass(this._msgArea, "hidden");
					this.msgAreaShowing = true;
				}else {
					if(this.msgAreaShowing == true){
						this._msgArea.innerHTML = "";
						dojo.addClass(this._msgArea,"hidden");
						this.msgAreaShowing = false;
					}
					if ((this._actualtextArea.value) == this._expectedValue) 
						this._resultLabel.innerHTML = Constants.getMessage("labelComparisonResult")+"<b>"+Constants.getMessage("labelSuccess")+"</b>";
					else 
						this._resultLabel.innerHTML = Constants.getMessage("labelComparisonResult")+"<b>"+Constants.getMessage("labelFailure")+"</b>";
				}
			}
		},
		_onBlur:function(e){
			if(this.callback)
				this.callback(this.callbackData);
		},
		_error: function(errObj){
			alert("Error: (message: '" + errObj.message + "') from CompareView#_error");
		}
}
);

})();	
