/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading.. com.ibm.rqm.planning.web.ui.internal.view.construction.properties.DataPoolView");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.construction.properties.DataPoolView");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.properties.DataPoolTableView");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function() { // module container

var DATAPOOL_VIEW			="dataPoolView";
var Constants = com.ibm.rqm.planning.web.client.internal.Constants;

dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.construction.properties.DataPoolView",[dijit._Widget, dijit._Templated],
	{
		templateString: '<div style="background-color: white; border: 1px gray solid; padding: 0.5em; ">' +
			'<div style="max-height: 25em; overflow: auto; padding: 0.5em;" dojoAttachPoint="_variableDiv"></div>'+
			'</div>',
		
		labelOk: Constants.getMessage("labelOk"),
		labelCancel: Constants.getMessage("labelCancel"),
		
		constructor: function()
		{
			
		},
		
		postCreate: function()
		{
		},
		
		initialize: function(args){
            this.parent = args.parent;
        },
		
		setData: function(dataPool)
		{
			dojox.data.dom.removeChildren(this._variableDiv);
			this.table = new com.ibm.rqm.planning.web.ui.internal.view.construction.properties.DataPoolTableView();
			this.table.initialize({
				variable: dataPool.variables,
				dialog: this.parent.dialog
			});
			this._variableDiv.appendChild(this.table.domNode);
		},
		
		ok: function() {
			var data = this.table.tableViewer.getCheckedRows();
			if(!data) {
				alert(Constants.getMessage("msgSelectVariableType"));
				return;
			}
			this.parent.setValue(data);
			this.parent.editor.focus();
		},
		
		cancel: function() {
			this.parent.editor.focus();
		},
		
		_error: function()
		{
			alert("Error: (message: '" + errorObj.message + "') from DataPoolView#_error");
		}

}
);

})();	
