/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.execution.web.ui.internal.view.execution.CreateExecutionWorkItem");
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.execution.CreateExecutionWorkItem");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");

// Clients Required
dojo.require("com.ibm.rqm.planning.web.client.internal.UserClient");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rqm.planning.web.client.internal.construction.TestCaseClient");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient");
// Utilities required
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");
dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");
dojo.require("com.ibm.rqm.process.web.client.internal.timebox.TimeboxClient");
dojo.require("com.ibm.rational.test.lm.web.client.internal.config");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
dojo.require("com.ibm.rqm.planning.web.client.internal.mapper.TestPlanMapper");
dojo.require("com.ibm.rqm.planning.web.client.internal.mapper.TestCaseMapper");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.TestCaseTableView");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.CollapsibleSection");
dojo.require("net.jazz.ajax.ui.PlatformUI");
(function() { // module container

var ServiceResponseHandler		   	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var Constants    				   	= com.ibm.rqm.planning.web.client.internal.Constants;
var getAuthenticatedContributor		= com.ibm.team.repository.web.client.session.getAuthenticatedContributor;					
var TestCaseClient   			   	= com.ibm.rqm.planning.web.client.internal.construction.TestCaseClient;
var UserClient 						= com.ibm.rqm.planning.web.client.internal.UserClient;
var ExecutionWorkItemClient 	   	= com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient;
var Utility						    = com.ibm.rqm.execution.web.ui.internal.util.Utility;
var PlanClient						= com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient;
var EditorUtil						= com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
var TimeBoxClient					= com.ibm.rqm.process.web.client.internal.timebox.TimeboxClient;
var GlobalEvents                    = com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
var TestPlanMapper					= com.ibm.rqm.planning.web.client.internal.mapper.TestPlanMapper;
var TestCaseMapper					= com.ibm.rqm.planning.web.client.internal.mapper.TestCaseMapper;
var SelectUtility 					= dojo.getObject( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
var YesNoDialog						= com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog;
var CSHelp							= com.ibm.asq.common.web.ui.internal.util.CSHelp;
var ViewHeaderLayout				= com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
var TestCaseTableView       		= com.ibm.rqm.planning.web.ui.internal.view.table.TestCaseTableView;
var TestScriptClient				= com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient;
var RtlmUiUtil						= com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil;
dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.execution.CreateExecutionWorkItem", [dijit._Widget, dijit._Templated],
{
		templatePath: dojo.moduleUrl("com.ibm.rqm.execution.web", "ui/internal/view/templates/execution/CreateExecutionWorkItem.html"),
		widgetsInTemplate: true,
		labelBrowse: Constants.getMessage("labelBrowse"),
		constructor: function(){
		},		

		postCreate: function(){		
			this._isNew = true;
            this._dirty = false;
			this._header = this._createHeader();
			dojox.data.dom.removeChildren(this.header);
			this.header.appendChild(this._header.domNode);
            this._TPLabel.innerHTML = Constants.getMessage("labelTestPlan");
            this._IterationLabel.innerHTML = Constants.getMessage("labelIteration");
            this._executeTCLabel.innerHTML = Constants.getMessage("labelTestCase");
			this._defaultTSLabel.innerHTML = Constants.getMessage("labelDefaultTS");
            this._configLabel.innerHTML =Constants.getMessage("labelAvaiableConfiguration");
            this._TC.value = Constants.getMessage("labelUnassigned");
			this._startLoading();
            
			this.detailSection.setDisplayTitle(Constants.getMessage("labelDetail"));
			this.testEnvironmentSection.setDisplayTitle(Constants.getMessage("labelConfig"));
            
			this.initialize();
			dojo.connect(this._Iteration,"onchange",this,"_onChange");
			dojo.connect(this._configurations,"onchange",this,"_onChange");
			dojo.connect(this._TS,"onchange",this,"_onChange");
			dojo.connect(this._browseTC,"onclick",this,"_browseClick");
			this.allTestCases = [];
			this.testCases = [];
		},
		initialize: function(){
			this._isNew = true;
			this._dirty = false;
			if(this.ewi){
				this._isNew = false;
				this._header.setTitle(this.ewi.name);
			}
			else{
				this._header.setTitle("");
			}
			
			this. _updateBrowserTitle();
					
			//clean header
			dojox.data.dom.removeChildren(this._header.getInfoAttributesNode());
			
			//set originator
			var originatorlabel = document.createElement("span");
            originatorlabel.innerHTML = Constants.getMessage("labeloriginatorLabel");
            var originator = document.createTextNode(this.ewi ? this.ewi.originator.name : getAuthenticatedContributor().name);
            this._header.addInfoAttribute(originatorlabel, originator);
			
			this._initContributors();
		},
		_initContributors: function(){
			//get the list of contributors
			var responseHandler = new ServiceResponseHandler(this, "_doInitContributors", "_error");			
			UserClient.getContributors(responseHandler);			
		},
		_doInitContributors: function(contributors){	
			var ownerlabel = document.createElement("label");
            ownerlabel.innerHTML = Constants.getMessage("labelowner");
			ownerlabel.setAttribute("for", "owner-select");
            this._owner = document.createElement("select");
			this._owner.id = "owner-select";
			this._owner.name = "owner-select";
			dojo.connect(this._owner, "onchange", this, "_onChange");
					
			var ewiData = "";
			if(this.ewi){
				ewiData = this.ewi.owner.name;
			}
			for (var i = 0; i < contributors.length; i++){
				if (contributors[i].name != "ADMIN" && contributors[i].name != "GUEST"){

					var contributorName = contributors[i].name;
                    if (contributorName == "Unassigned") {
                        contributorName = Constants.getMessage("labelUnassigned");
                    }
					var option = new Option(contributorName, contributors[i].userId);
					if(ewiData !== "" ){
						if(contributors[i].name == ewiData)
							option.selected = true;
					}
					SelectUtility.add( this._owner, option );
				}
			}
			this._header.addInfoAttribute(ownerlabel, this._owner);
			
			if (this.ewi) 
				this._initTP(this.allPlans);
			else {
				this._header.setProgressStart(Constants.getMessage("labelLoadTestPlanList"));
				var responseHandler = new TestPlanMapper(this, "_initTP", "_error");
				PlanClient.getTestPlansSummary(responseHandler, {});
			}
		},
		_initTP: function(plans){
			var ewiData = "";
			if(this.ewi)
				ewiData = this.ewi.testPlan ? this.ewi.testPlan.id : Constants.getMessage("labelGlobal");
			else
				this.allPlans = [];
			this._fillTPCombo(plans,ewiData);
			if(this.ewi){
				this._TP.disabled = true;
				this._updateTestCases();
				this._updateIterationCombo();
				var ewiData = this.ewi.configuration ? this.ewi.configuration : "global";
				this._fillConfigurationCombo(ewiData);
                this._endLoading();
				//no need to proceed further. We already have all the info loaded
				return;
			}
			if(plans && plans.length>0){
				var createEWISelf = this;
				for(var i=0;i<plans.length;i++){
					this.allPlans.push(plans[i]);
					this.allPlans[i].iterations = [];
					this.allPlans[i].testCases = [];
					var callbackObj = {
						index:i,
						success: function(results){
							createEWISelf.allPlans[this.index].configurations = results;
						},
						failure: function(e){
							createEWISelf._error(e);
						}
					}
					var responseHandler2 = new ServiceResponseHandler(callbackObj, "success", "failure");
					PlanClient.getConfigurations(responseHandler2, this.allPlans[i].versionableItemId);					
				}
				var responseHandler= new ServiceResponseHandler(this, "_appendIterations", "_error");
				TimeBoxClient.getTestPhasesDTO(responseHandler, {});
			}
			this._initTC();
		},
		
		_fillTPCombo:function(plans,selectedValue){
			dojox.data.dom.removeChildren(this._TP);
			var option = new Option(Constants.getMessage("labelUnassigned"), "global");
			if(selectedValue == "global")
				option.selected = true;
			SelectUtility.add( this._TP, option );
			if (plans && plans.length > 0) {
				for (var i = 0; i < plans.length; i++) {
					var planoption = new Option(plans[i].name, plans[i].id);
					if(selectedValue == plans[i].id)
						planoption.selected = true;
					SelectUtility.add(this._TP, planoption);
				}
			}
			
			
		},
		_appendIterations: function(iterations){
			if(iterations && iterations.length > 0){
				for(var j=0;j<iterations.length;j++){
					for(var i=0;i<this.allPlans.length;i++){
						if(!this.allPlans[i].iterations)
							this.allPlans[i].iterations = [];
						if(this.allPlans[i].versionableItemId === iterations[j].targetTestPlanUUID){
							this.allPlans[i].iterations.push(iterations[j]);
						}	
					}
				}
			}
		},
		_initTC: function(testCases) {
			this.allTestCases = testCases ? testCases:[];
			if(this.allTestCases.length ===0 )
				this._saveButton.disabled = true;
            this._header.setProgressStart(Constants.getMessage("labelLoadConfig"));
			var responseHandler= new ServiceResponseHandler(this, "_updateConfigurationCombo", "_error");
			var cfg = new com.ibm.rational.test.lm.web.client.internal.config();
			cfg.getAll(responseHandler);
		},
		_updateConfigurationCombo: function(configs){
			var ewiData = "";
			if(this.ewi)
				ewiData = this.ewi.configuration ? this.ewi.configuration : "global";
			this.configs = configs;
			this._fillConfigurationCombo(ewiData);
			if(ewiData == "global"){
				this.updateSaveable();
                this._endLoading();
				return;
			}
			//Start the init for TPlans to show Test cases and Iterations
            this._updateIterationCombo();
			this.updateSaveable();
            this._endLoading();
            if (this._isNew) {
                if (this._header.viewEditableTitle) {
                    setTimeout(dojo.hitch(this._header.viewEditableTitle, "focusWithPrompt"), 1);
                }
            }
		},
		_fillConfigurationCombo:function(ewiData){
			dojox.data.dom.removeChildren(this._configurations);
			var option = new Option(Constants.getMessage("labelUnassigned"), "global");
			if(ewiData == "global"){
				option.selected = true;
				this._configurations.disabled = true;
			}
			SelectUtility.add( this._configurations, option );
			if(this.configs){
				var configs = [];
				var planId = this._TP.value;
				if(planId ==="global"){
					configs = this.configs;
				}else{
					for(var i=0;i<this.allPlans.length;i++){
						var id = parseInt(planId, 10);
						if(this.allPlans[i].id === id && this.allPlans[i].configurations && this.allPlans[i].configurations.length>0){
							for(var k=0;k<this.allPlans[i].configurations.length;k++){
								for(var j=0;j<this.configs.length;j++){
									if(this.configs[j].id == this.allPlans[i].configurations[k]){
										configs.push(this.configs[j]);
									}
								}
							}
						}
					}
				}
				var sortedConfig = [];
				if(configs.length > 0){
			        for ( var i = 0; i < configs.length; i++ ) {
						sortedConfig.push(configs[i]);
			        }
					sortedConfig = sortedConfig.sort(function(c1, c2) {
			            var cSort1 = c1 && c1.name ? (c1.name).toLowerCase() : "";
			            var cSort2 = c2 && c2.name ? (c2.name).toLowerCase() : "";
			            if(cSort1 == cSort2){
							return 0;
						}else
							return cSort1 < cSort2 ? -1 : 1;//Ascending order
			        });
				}
				configs = sortedConfig;
				for(var i=0;i<configs.length;i++){
					var opt = new Option(configs[i].name, configs[i].id);
					if(ewiData != "" ){
						if(configs[i].id == ewiData){
							opt.selected = true;
							this._configurations.disabled = true;
						}
					}
					SelectUtility.add( this._configurations, opt );
				}
			}
		},
		_updateIterationCombo: function(){
			var planId = this._TP.value;
			dojox.data.dom.removeChildren(this._Iteration);
			if(planId ==="global"){
				this._Iteration.disabled = true;
				return;
			}
			this._Iteration.disabled = false;
			for(var i=0;i<this.allPlans.length;i++){
				var id = parseInt(planId, 10);
				if(this.allPlans[i].id === id){
					var planIterations = this.allPlans[i].iterations;
					if(planIterations){
						var ewiData = "";
						if(this.ewi && this.ewi.testPlan && this.ewi.testPlan.id === id && this.ewi.phase){
							ewiData = this.ewi.phase.name;
						}
						for(var j=0;j<planIterations.length;j++){
							var opt = new Option(planIterations[j].name, planIterations[j].itemId);
							if(ewiData !== "" && ewiData === planIterations[j].name)
								opt.selected = true;
							SelectUtility.add( this._Iteration, opt );
						}
						break;	
					}else
						this._Iteration.disabled = true;
				}
			}
		},
		_updateTestCases: function(){
			var planId = this._TP.value;
			if (this.ewi) {
				this._TC.value = this.ewi.testCase.name;
				this._setTS(this.ewi.testCase.scripts,this.ewi.defaultScript);
				this._browseTC.disabled=true;
				return;
			}
			this._TC.value = Constants.getMessage("labelUnassigned");
			this._setTS();
			if (planId === "global") 
				this.testCases = this.allTestCases;
			else {
				for (var i = 0; i < this.allPlans.length; i++) {
					var id = parseInt(planId, 10);
					if (this.allPlans[i].id === id) {
						this.testCases = this.allPlans[i].testCases? this.allPlans[i].testCases:[];
						if (this.testCases.length === 0) {//test Case is required field
							this._saveButton.disabled = true;
							return;
						}
						break;
					}
				}
			}
		},
		isDirty:function(){
			return this._dirty;
		},
		setDirty:function(value){
			if (value) {
				dojo.publish(GlobalEvents.UpdateTabLabel, [window.location.hash, "", null, value]);
				this._header.clearStatus();
			}
			this._dirty = value;
		},
		updateSaveable: function() {
            if (this._saveButton) {
                this._saveButton.disabled = !this.isDirty();
            }
            if (this._cancelButton) {
                this._cancelButton.disabled = !this.isDirty();
            }
        },
		onCancel: function(){
			var self = this;
			var args = {
				title: "",
				message: Constants.getMessage("msgConfirmCancel"),
				yesCallback: function(){
					self.setDirty(true);
					self.initialize();
					return true;          
				},
				noCallback: function() {
					return false;
				}
			};
			var dialog = new YesNoDialog(args);
	        dialog.setTitle(args.title);
	        dialog.open();
		},
		onSave: function(){
			if(!this.ewi){
				if(this._header.getTitle() == ""){
					this._header.setStatus(Constants.VALIDATION_ERROR, Constants.HEADER_STATUS_ERROR, Constants.getMessage("msgNameRequired"));
					return;
				}	
			}
			if (!this._TCItemId) {
				this._header.setStatus(Constants.VALIDATION_ERROR, Constants.HEADER_STATUS_ERROR, Constants.getMessage("msgTestCaseRequired"));
				return;
			}
			var found = false;
			for(var i=0;i<this.testCases.length;i++){
				if (this._TCId == this.testCases[i].id) {
					found = true;
					break;
				}
			}
			if(!found){
				this._header.setStatus(Constants.VALIDATION_ERROR, Constants.HEADER_STATUS_ERROR, Constants.getMessage("msgTestCaseNotInPlan"));
				return;
			}
			this._setLastSaved(Constants.STATUS_SAVING);
			this.setDirty(false);
			this.updateSaveable();
			this._onSave();
		},
		_onSave: function(){
			var testConfig = this._configurations.value;
			var testCase = this._TCItemId;
			var owner = this._owner.value;
			var name = this._header.getTitle();
			var testPlanItemId = this._getSelectedPlanItemId();
			var testPhase = this._Iteration.disabled ? "" : this._Iteration.value;  
			var params ={
					newExecutionWorkItem: this._isNew,
					owner: owner,
					name: name,
					testCase: testCase
				};
			if (this._TS.value != "" && this._TS.value != "-1") 
				params.defaultScript = this._TS.value;
			if(testConfig && testConfig != "global")
				params.testConfig = testConfig;
			if(testPlanItemId != "global"){
				params.testPlanItemId = testPlanItemId;
			}
			if(testPhase != ""){
				params.testPhase = testPhase;
			}
			if(this.ewi){
				params.id = this.ewi.id;
				if(this.ewi.stateId)
					params.ewiStateId = this.ewi.stateId;
			}
			
			var responseHandler = new ServiceResponseHandler(this, "_savedEWI", "_saveError");
			ExecutionWorkItemClient.postExecutionWorkItem(responseHandler, params);

		},
		_savedEWI: function(args){
			this._setLastSaved(Constants.STATUS_SUCCESS);
            this.wasNew = this._isNew;
			this._isNew = false;
			var responseHandler = new ServiceResponseHandler(this, "_updateUI", "_error");
			ExecutionWorkItemClient.getExecutionWorkItemDTOs(responseHandler, {id: args.id});
		},
		_saveError: function(errorObj){
			this._setLastSaved(Constants.STATUS_FAILURE, errorObj);
			this.setDirty(true);
			this.updateSaveable();
		},
		_updateUI: function(ewis){
            dojo.publish(GlobalEvents.UpdateTabLabel, [window.location.hash, ewis ? ewis[0].name : "", "ewi-icon-16-inTab",this._dirty]);
			this.ewi = ewis[0];
			var duplicateTab = false;
			var uri = Utility.getEwiURI(this.ewi.id);
			if(this.wasNew && this.parentController._contentArea.hasPage(uri)){
				this.parentController._contentArea.closeTab(uri);
				duplicateTab = true;
			}
			var name = this._header.getTitle();
			if (name != this.ewi.name || duplicateTab){
				if(duplicateTab){
					this._header.setStatus(Constants.getMessage("labelDuplicateTab"), ViewHeaderLayout.WARNING, Constants.getMessage("msgDuplicateTab"));
				}else{
					this._header.setStatus(Constants.getMessage("labelDuplicate"), ViewHeaderLayout.WARNING, Constants.getMessage("msgDuplicateTER"));
					var anchorNode = document.createElement('span');
					anchorNode.style.textDecoration = "underline";
					anchorNode.style.paddingLeft="5px";
					var label = document.createElement('label');
					label.innerHTML = this.ewi.name;
					anchorNode.appendChild(label);
					this._header.statusLineNode.appendChild(anchorNode);
				}
				dojo.publish(GlobalEvents.ArtifactsUpdated, [ Constants.TYPE_EWI, ewis, null ]);
				dojo.publish(GlobalEvents.UpdateTabUri, [window.location.hash, Utility.getEwiURI(this.ewi.id)]);
			}else{
				dojo.publish(GlobalEvents.ArtifactsAdded, [ Constants.TYPE_EWI, ewis, null ]);
				dojo.publish(GlobalEvents.UpdateTabUri, [window.location.hash, Utility.getEwiURI(this.ewi.id)]);
			}
			this.initialize();
		},
		
		closePage: function(){
			this.oldUri = window.location.hash;
			parent.location = Utility.getEwiURI(this.ewi.id);
			setTimeout(dojo.hitch(this, "publishClosure"), 2000);
		},
		
		publishClosure: function(){
			dojo.publish(GlobalEvents.CloseTab, [this.oldUri]);
		},
		
		_setLastSaved: function(status, error) {   
            var st_code = -1; // none, no status icon
            var text = "";
            var detail_msg = null;
            
			//VS: Add back permissions, figure out
            // don't change the status message if this is not editable.                                 
//            if (!this.isRolePermitsEdit()) {
//                return;
//            }
            if ( status == Constants.STATUS_SUCCESS ) {
                st_code = ViewHeaderLayout.SUCCESS;
                text = Constants.getCommonMessage("statusSaveSuccess", EditorUtil.getTimeString());  
            } 
            else if ( status == Constants.STATUS_FAILURE ) {
                if(error && error.message && error.message.toLowerCase().indexOf('license') > -1) {
                    var licenseMsg = Constants.getCommonMessage("serverLicenseErrMsg");
                    EditorUtil.showServerErrorMessage(licenseMsg);
                }
                st_code = ViewHeaderLayout.ERROR;
                text = Constants.getCommonMessage("statusSaveFail", EditorUtil.getTimeString());  
                
                if(error && error.message) {
                    detail_msg = "<b>" + Constants.getCommonMessage("labelError") + "</b><br/>" + error.message;
                    if (error.caughtAt) {
                        detail_msg += "<br/><br/><b>" + Constants.getCommonMessage("labelErrorCaughtAt") + "</b> " + error.caughtAt;
                    }                
                }
            } 
            else if ( status == Constants.STATUS_SAVING ) {
                st_code = ViewHeaderLayout.INFO;
                text = Constants.getCommonMessage("statusSaving");
            } 
            else if ( status == Constants.STATUS_NEW ) {
                st_code = ViewHeaderLayout.INFO;
                text = Constants.getCommonMessage("statusNewNeedSave");
            } 
            else if ( status == Constants.STATUS_DIRTY ) {
                st_code = ViewHeaderLayout.INFO;
                text = Constants.getCommonMessage("statusDirty");
            }
            
            if(st_code > -1)
                this._header.setStatus(text, st_code, detail_msg);
            else
                this._header.clearStatus();
        },
		_getTestCaseVersionableItemId: function(testCaseItemId){
			if ( this.allTestCases !== null && this.allTestCases.length > 0 ){
				for(var i = 0; i< this.allTestCases.length; i++){
					if(this.allTestCases[i].id == testCaseItemId){
						return this.allTestCases[i].versionableItemId;
					}
				}
			}
		},
		_getSelectedPlanItemId: function(){
			var selectedId = this._TP.value;
			var itemId = "";
			for (var i = 0; i < this.allPlans.length; i++){
				var plan = this.allPlans[i];
				if(plan.id == selectedId){
					itemId = plan.versionableItemId;
					break;
				}
			}
			return itemId;
		},
		onSelectTP: function(){
			var ewiData = "";
			if(this.ewi)
				ewiData = this.ewi.configuration ? this.ewi.configuration : "global";
			this._fillConfigurationCombo(ewiData);
			this._updateIterationCombo();
			this._updateTestCases();
		},
		_createHeader: function(title) {
			var iconClass = "ewi-icon-48";
			var args = {
				title: "",
				titleEditable: true,
                typeLabel: Constants.getMessage("labelEWI"),
                iconClass: iconClass,
                summary: ""
            };
            this._header = new ViewHeaderLayout(args);            
			this._header.setCSHelpId("rqm_create_ter.html");
			this._header.setCSHelpButtonLabel(Constants.getMessage("labelTestExecutionRecordHelp"));
            this._header.setNoValueEditableTitleLabel(Constants.getMessage("labelEnterNewEWITitle"));
			this._cancelButton = this._header.addRightViewAction(Constants.getMessage("labelDiscardChanges"), dojo.hitch(this, "onCancel"), null, null);
			this._saveButton = this._header.addRightViewAction(Constants.getMessage("labelSave"), dojo.hitch(this, "onSave"), null, null);
			this._header.onTitleEdited = dojo.hitch(this, "_onChange");
            return this._header;          
        }, 
		_onChange: function() {
			this.setDirty(true);
			this.updateSaveable();
        },
		_browseClick:function(){
			var planId = this._TP.value;
			var loading =  false;
			if (this.testCases.length == 0) {
				loading = true;
				if (planId == "global") {
					var responseHandler = new TestCaseMapper(this, "_refreshTC", "_error");
					TestCaseClient.getTestCasesMinimal(responseHandler, {});
				}else{
					var itemId = this._getSelectedPlanItemId();
					var responseHandler = new TestCaseMapper(this, "_refreshTC", "_error");
					TestCaseClient.getTestPlanTestCasesMinimal(responseHandler, { versionedTestPlanItemId: itemId});
				}
			}
			var tableArgs = {
				testCases: this.testCases,
                profile: Constants.TABLE_PROFILE_MINIMAL,
				isSingleSelect:true
			};
			if(loading)
				tableArgs.showInitLoadProgress = true;
			this._list = new TestCaseTableView(tableArgs);
            var dialogArgs = {
                primaryTitle: Constants.getMessage("labelSelectTestCase"),
                okCallback: dojo.hitch(this, "_setTC"),
				_truncate: function() {}  //disable the Dialog's '_truncate'
            };                
            this._dialog = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(dialogArgs);
	        var cshelp = new CSHelp({contextID: "rqm_add_test_cases.html"});
	        cshelp.setButtonLabel(Constants.getMessage("labelAddExistingCSHelp"));
            this._dialog.setSecondaryTitleNode(cshelp.domNode);
            this._dialog.setWidth(this.width);
            this._dialog.contentContainer.appendChild(this._list.domNode);
			this._dialog.open(false);
			this._dialog.updatePosition();
			this._dialog.getOkButton().disabled = false;
		},
		_refreshTC:function(testcases){
			var planId = this._TP.value;
			if (planId != "global") {
				for (var i = 0; i < this.allPlans.length; i++) {
					if (this.allPlans[i].id == planId) {
						this.allPlans[i].testCases = testcases?testcases:[];
						break;
					}
				}
			}else 
				this.allTestCases = testcases?testcases:[];
			this.testCases = testcases;
			this._list.refresh(this.testCases);
		},
		_setTC:function(){
			var addedItems = this._list.getSelectedItems();
			if (addedItems && addedItems.length > 0) {
				this._TCId = addedItems[0].id;
				if(addedItems[0].versionableItemId)
					this._TCItemId = addedItems[0].versionableItemId;
				else
					this._TCItemId = this._getTestCaseVersionableItemId(addedItems[0].id);
				this._TC.value = addedItems[0].name;
				this._updateDefaultTestScriptCombo(this._TCItemId);
				this._onChange();
			}
		},
		_updateDefaultTestScriptCombo: function(tcItemId){
			
			var responseHandler = new TestPlanMapper(this, "_setTS", "_error");
			var args = {versionedTestCaseItemId: tcItemId};
			if (args.versionedTestCaseItemId != "") {
				TestScriptClient.getTestCaseTestScripts(responseHandler, args);
			}	
			else{
				dojox.data.dom.removeChildren(this._TS);
			}
		},
		_setTS: function(testscripts,defaultscript){
			this.allTestScripts = [];
			dojox.data.dom.removeChildren(this._TS);
			if(testscripts && testscripts.length>0){
				for(var i=0;i<testscripts.length;i++){
					this.allTestScripts.push(testscripts[i]);
					var testscript = testscripts[i];
					var option = new Option(testscript.name, testscript.id);
					if(defaultscript && defaultscript.itemId == testscript.itemId)
						option.selected = true;
					else if((!defaultscript) && (i === 0))
						option.selected = true;
					SelectUtility.add( this._TS, option );		
				}	
			}		
			var option = new Option(Constants.getMessage("labelNone"), -1);
			SelectUtility.add( this._TS, option );	
		},
		// handler on artifacts changed.. lots of work done here. is it better than making a service call?
	    onArtifactChanged: function(changeType, artifactType, artifactArray) {
			if (!this.ewi) {
				if (artifactType == Constants.TYPE_PLAN) {
					var createEWISelf = this;
					if (changeType == GlobalEvents.ArtifactsAdded) {
						for (var i = 0; i < artifactArray.length; i++) {
							this.allPlans.push(artifactArray[i]);
							var planoption = new Option(artifactArray[i].name, artifactArray[i].id);
							SelectUtility.add(this._TP, planoption);
							var responseHandler= new ServiceResponseHandler(this, "_appendIterations", "_error");
							TimeBoxClient.getTestPhasesDTO(responseHandler, {testPlanId: artifactArray[i].versionableItemId});
							var callbackObj = {
								index:this.allPlans.length-1,
								success: function(results){
									createEWISelf.allPlans[this.index].configurations = results;
								},
								failure: function(e){
									createEWISelf._error(e);
								}
							}
							var responseHandler2 = new ServiceResponseHandler(callbackObj, "success", "failure");
							PlanClient.getConfigurations(responseHandler2, artifactArray[i].versionableItemId);
						}
						this.onSelectTP();
					}else if ((changeType == GlobalEvents.ArtifactsUpdated)||(changeType == GlobalEvents.ArtifactsDeleted)){
						var found = false;
						for (var i = 0; i < artifactArray.length; i++) {
							for(var j=0;j<this.allPlans.length;j++){
								if(this.allPlans[j].id == artifactArray[i].id){
									if (changeType == GlobalEvents.ArtifactsUpdated) {
										this.allPlans.splice(j, 1, artifactArray[i]);
										var responseHandler= new ServiceResponseHandler(this, "_appendIterations", "_error");
										TimeBoxClient.getTestPhasesDTO(responseHandler, {testPlanId: artifactArray[i].versionableItemId});
										var callbackObj = {
											index:j,
											success: function(results){
												createEWISelf.allPlans[this.index].configurations = results;
											},
											failure: function(e){
												createEWISelf._error(e);
											}
										}
										var responseHandler2 = new ServiceResponseHandler(callbackObj, "success", "failure");
										PlanClient.getConfigurations(responseHandler2, artifactArray[i].versionableItemId);
										break;
									}else{ 
										this.allPlans.splice(j, 1);
										break;
									}
									found = true;
								}
							}
						}
						if (found) {
							this._fillTPCombo(this.allPlans);
							this.onSelectTP();
						}
					}
					if(changeType == GlobalEvents.ArtifactsUpdated)
						this._header.setStatus(Constants.getMessage("msgTestPlansUpdated"), ViewHeaderLayout.INFO);
					else if (changeType == GlobalEvents.ArtifactsDeleted)
						this._header.setStatus(Constants.getMessage("msgTestPlansDeleted"), ViewHeaderLayout.INFO);
					else if (changeType == GlobalEvents.ArtifactsAdded)
						this._header.setStatus(Constants.getMessage("msgTestPlansAdded"), ViewHeaderLayout.INFO);
				}else if (artifactType == Constants.TYPE_CASE){
					if (changeType == GlobalEvents.ArtifactsAdded) {
						for (var i = 0; i < artifactArray.length; i++) {
							this.allTestCases.push(artifactArray[i]);
						}
					}else if ((changeType == GlobalEvents.ArtifactsUpdated)||(changeType == GlobalEvents.ArtifactsDeleted)){
						for (var i = 0; i < artifactArray.length; i++) {
							for(var j=0;j<this.allTestCases.length;j++){
								if (this.allTestCases[j].id == artifactArray[i].id) {
									if (changeType == GlobalEvents.ArtifactsUpdated) {
										this.allTestCases.splice(j, 1, artifactArray[i]);
									}else {
										this.allTestCases.splice(j, 1);
									}
								}
							}
							for(var m=0;m<this.allPlans.length;m++){
								if(this.allPlans[m].testCases){
									for(var n=0;n<this.allPlans[m].testCases.length;n++){
										if(this.allPlans[m].testCases[n].id == artifactArray[i].id){
											if(changeType == GlobalEvents.ArtifactsUpdated)
												this.allPlans[m].testCases.splice(n,1,artifactArray[i]);
											else
												this.allPlans[m].testCases.splice(n,1);
										}
									}
								}
								if (this._TP.value == this.allPlans[m].id) {
									this.testCases = this.allPlans[m].testCases;
								}
							}
							if (this._TC.value == artifactArray[i].name) {
								if(changeType == GlobalEvents.ArtifactsUpdated)
									this._setTS(artifactArray[i].scripts);
								else{
									this._TC.value = Constants.getMessage("labelUnassigned");
									this._setTS();
								}
							}
						}
					}
					if(changeType == GlobalEvents.ArtifactsUpdated)
						this._header.setStatus(Constants.getMessage("msgTestCasesUpdated"), ViewHeaderLayout.INFO);
					else if (changeType == GlobalEvents.ArtifactsDeleted)
						this._header.setStatus(Constants.getMessage("msgTestCasesDeleted"), ViewHeaderLayout.INFO);
					else if (changeType == GlobalEvents.ArtifactsAdded)
						this._header.setStatus(Constants.getMessage("msgTestCasesAdded"), ViewHeaderLayout.INFO);	
				}if (artifactType == RtlmUiUtil.TYPE_CONFIG){
					if(this.configs){
						if (changeType == GlobalEvents.ArtifactsAdded) {
							for (var i = 0; i < artifactArray.length; i++) {
								this.configs.push(artifactArray[i]);
							}
						}else{
							for (var i = 0; i < artifactArray.length; i++) {
								for(var j=0;j<this.configs.length;j++){
									if (artifactArray[i].id == this.configs[j].id) {
	                            		if (changeType == GlobalEvents.ArtifactsUpdated) {
											this.configs.splice(j,1,artifactArray[i]);
										}else if (changeType == GlobalEvents.ArtifactsDeleted) {
											this.configs.splice(j,1);
										}
									}
								}
							}
						}
						this._fillConfigurationCombo();
						this._header.setStatus(Constants.getMessage("msgTestEnvironmentUpdated",ViewHeaderLayout.INFO));
					}
				}
			}
		},
        
        _startLoading: function()
        {
            this._header.setProgressStart(Constants.getMessage("labelLoadContributors"), /*hideContent*/true);
            dojo.style(this.detailSection.domNode, "visibility", "hidden");
            dojo.style(this.testEnvironmentSection.domNode, "visibility", "hidden");
        },

        _endLoading: function()
        {
            this._header.setProgressEnd();
            dojo.style(this.detailSection.domNode, "visibility", "visible");
            dojo.style(this.testEnvironmentSection.domNode, "visibility", "visible");            
        },
        
		_error: function(errorObj){
            // TODO: better handling
            this._endLoading();
            this._header.setStatus("Error...", Constants.HEADER_STATUS_ERROR, errorObj.message);
			console.error("Error: (message: '" + errorObj.message + "') from Create EWI#_error");
		},
					
		_updateBrowserTitle: function(){
			if (this.page) {
				var name="";
				
				if (this._isNew) {
					name = Constants.getMessage("labelCapitalNew");
				}
				else if (this.ewi && this.ewi.name){
					name = this.ewi.name;
				}
				
				// update browser title
				this.page.browserTitle = Constants.getMessage("labelEWI") + Constants.getMessage("labelColen") +" " + name;
				net.jazz.ajax.ui.PlatformUI.getWorkbench().setTitle(this.page.browserTitle);
				net.jazz.ajax.ui.PlatformUI.getWorkbench().browserTitle = this.page.browserTitle;	

 
			}
		}
	}
);
}
)();
