/********************************EWIList****************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.execution.web.ui.internal.view.execution.EWIList");
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.execution.EWIList");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");

// Require the Clients
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rqm.execution.web.client.internal.mapper.EWIMapper");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.UserClient");
dojo.require("com.ibm.rqm.process.web.client.internal.timebox.TimeboxClient");
// Utilities
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");
//Local widget
dojo.require("com.ibm.rational.test.lm.web.client.internal.config");
dojo.require("com.ibm.asq.common.web.client.internal.Catalog");
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.RelatedInfo");

dojo.require("com.ibm.rqm.configuration.web.ui.internal.view.configuration.ReassignPopup");
dojo.require("com.ibm.rqm.configuration.web.ui.internal.view.common.FloatingDiv");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.BlockingDefectsPopUp");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.table.ExecutionWorkItemTableView");
dojo.require("com.ibm.team.process.web.client.projectarea");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.EWIConfigSelector");
dojo.require("com.ibm.rational.test.lm.web.client.internal.config");
dojo.require("com.ibm.rqm.defects.web.client.DefectsManager");
dojo.require("com.ibm.team.repository.web.foundation.NullProgressMonitor");
dojo.require("com.ibm.rqm.defects.web.ui.view.common.ProgressDialog");
dojo.require("com.ibm.team.repository.web.foundation.Status");

(function() {

var ServiceResponseHandler		= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var EWIMapper					= com.ibm.rqm.execution.web.client.internal.mapper.EWIMapper;
var ExecutionWorkItemClient 	= com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient;
var UserClient 					= com.ibm.rqm.planning.web.client.internal.UserClient;
var TimeBoxClient				= com.ibm.rqm.process.web.client.internal.timebox.TimeboxClient;
var Constants    				= com.ibm.rqm.planning.web.client.internal.Constants;
var Utility						= com.ibm.rqm.execution.web.ui.internal.util.Utility;
var ImageCache					= com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache;
var ExecutionWorkItemTableView  = com.ibm.rqm.execution.web.ui.internal.view.table.ExecutionWorkItemTableView;
var FloatingDiv 				= com.ibm.rqm.configuration.web.ui.internal.view.common.FloatingDiv;
var ReassignPopup 				= com.ibm.rqm.configuration.web.ui.internal.view.configuration.ReassignPopup;
var getCurrentProjectArea		= com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
var AlertDialog = com.ibm.asq.common.web.ui.internal.widgets.AlertDialog;
var LOCATION                    = "jazz/web/projects/";
var DEFECT_URL                  = "#action=com.ibm.team.workitem.viewWorkItem&id=";
var GlobalEvents   				= com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
var BlockingDefectsPopUp		=com.ibm.rqm.execution.web.ui.internal.view.common.BlockingDefectsPopUp;
var MAX_DEFECTS					=25;
var ViewHeaderLayout            = com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
var EditorUtil                  = com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
var EWIConfigSelector           = com.ibm.rqm.execution.web.ui.internal.view.common.EWIConfigSelector;
var getDefectsManager 			= com.ibm.rqm.defects.web.client.DefectsManager.getInstance;
var NullProgressMonitor			= com.ibm.team.repository.web.foundation.NullProgressMonitor;
var ProgressDialog              = com.ibm.rqm.defects.web.ui.view.common.ProgressDialog;
var Status                      = com.ibm.team.repository.web.foundation.Status;

dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.execution.EWIList", [dijit._Widget, dijit._Templated,
						com.ibm.asq.common.web.ui.internal.view.common.RelatedInfoMixin],
		{
		templatePath: dojo.moduleUrl("com.ibm.rqm.execution.web", "ui/internal/view/templates/execution/EWIList.html"),
		
		showArchived: false,
		plansReceived: 0,
		totalPlans: 0,
		contributors: [],
		fireToRTC: false,
		
		constructor: function() {
            this.tableActions = [];
			this.catalog = null;
			this.ewis = null;
		},
		//override RelatedInfoMixin methods
		getStaticRelatedInfo: function() {
	        return this._relatedInfo;
	    },
	        
	    getStaticRelatedInfoId: function() {
	        return "com.ibm.rqm.execution.web.ui.internal.view.execution.EWIList";
	    },
		
		setupRelatedInfo: function(relatedInfoPanel){
			if(this._hasRelatedInfoPane){
				this._relatedInfo = relatedInfoPanel;
				this._defectArea = this._relatedInfo.getInfoGroup(Constants.getMessage("labelBlockingDefects"), true);
			}
        },
		postCreate: function() {		
			//if this will receive this.testCase
			if (this.testCase != null) {
				this._testCaseId = this.testCase.id;
			}
			this.initialize();
		},
		
		initialize: function(){
			this._preLoadCheck();
			var responseHandler = new ServiceResponseHandler(this, "_setContributors", "_error");			
			UserClient.getContributors(responseHandler);
		},

		_setContributors: function(contributors){
			this.contributors = contributors;
			var responseHandler= new ServiceResponseHandler(this, "_setIterations", "_error");
			TimeBoxClient.getTestPhasesDTO(responseHandler, {});
		},

		_setIterations: function(iterations){
			this.iterations = iterations;
            if (this.showQueryFilters && this.parentController) {
                // showing filters in All EWI after fetching all the contributors and iterations
                this._showEWITable();
            } else if (this._ewiTableViewer){
				this._ewiTableViewer.refresh(this.ewis, this.iterations, this.contributors, false);
			}
		},
		
		_preLoadCheck: function(){	
			//load EWIs based on parameters
			if (this.owner) {
				this._hasRelatedInfoPane = true;	
				//load EWIs for a specific Contributor
				this.queryTitle = Constants.getMessage("labelMyEWI");
				var args = {owner: this.owner}
				this._showEWITable();
				var responseHandler = new EWIMapper(this, /* "_setEWIs" */ "_setEWITableContent", "_error");
				ExecutionWorkItemClient.getExecutionWorkItemSummaryDTOs(responseHandler, args);							
			} else if (this.testCase) {
				//load EWIs for a specific Test Case
	            this.queryTitle = Constants.getMessage("labelMyEWI");
				this._showEWITable();
				var args = { 
				    testCaseItemId: this.testCase.versionableItemId,
					includeArchived: this.showArchived
				};
				if(this.testCase.stateId)
					args.testcaseStateId  =  this.testCase.stateId;
	            var responseHandler = new EWIMapper(this, /* "_setEWIs" */ "_setEWITableContent", "_error");
	            ExecutionWorkItemClient.getExecutionWorkItemSummaryDTOs(responseHandler,args);
         	} 
		 	else if(this.parentController){ // we get the parentController when in Execution perspective
				this._hasRelatedInfoPane = true;	
				//load ALL EWIs
				this.queryTitle = Constants.getMessage("labelAllEWI");
                if (!this.showQueryFilters) {
                    // if using filters, no query and show the EWI table view after fetching the contributors
                    // and the iterations in initialize()
                    this._showEWITable();
                    var responseHandler = new EWIMapper(this, /* "_setEWIs" */ "_setEWITableContent", "_error");
                    ExecutionWorkItemClient.getExecutionWorkItemSummaryDTOs(responseHandler);
                }
			}
			else{ // new test case creation so no EWIs
				this.queryTitle = Constants.getMessage("labelEWIs");
				this._showEWITable(null);
				this._setEWITableContent();
			}
		},
		
        _showEWITable: function(name) {
			if(!this._ewiTableViewer){
	        	var args = {
                    ewiList: this,
                    showQueryFilters: this.showQueryFilters,
	        		executionWorkItems: [],				
                    showInitLoadProgress: !this.showQueryFilters,
	        		executable: true,
	                queryName: name ? name : this.queryTitle,
					contributors: this.contributors,
					iterations: this.iterations,
	        		rowCheckListener: dojo.hitch(this, function(rowObject, state) {
	                    this._updateRelatedInfo(rowObject, state);  
	                }),
	                actions: this.getTableActions(),
					parentSection: this.parentSection ? this.parentSection : null
	        	}
	            if (this.isEditorSection) {
	                args.showTestCase = this.showTestCase;
	                args.queryName = null;
	                args.editable = this.editable;                
	            }
	            this._ewiTableViewer = new ExecutionWorkItemTableView(args);
				if(!this.isEditorSection && !this.showQueryFilters)
					this._ewiTableViewer.setInProgress(Constants.getMessage("msgQueryTableList", args.queryName));
	            //display the table
	        	dojox.data.dom.removeChildren(this._listContainer);
    	    	this._listContainer.appendChild(this._ewiTableViewer.domNode);	
        	}
        },
		
		_dispatchDefectsManagerInitialized: function(initializedCallback, uninitializedCallback){
			var defectsManager= getDefectsManager();
			defectsManager.ensureInitialized(new NullProgressMonitor(), dojo.hitch(this, function(status) {
				var defectsProviders = defectsManager.getDefectsProviders();
				var currentProviderInstance = defectsManager.getDefectsProvider(defectsManager.getCurrentDefectsProviderId());
				if (currentProviderInstance != null && currentProviderInstance != undefined && currentProviderInstance.isConfigured()){
					initializedCallback();
				} else {
					uninitializedCallback();
				}
			}));
		},
      
	  	_setEWITableContent: function(ewis) {
			this.ewis = ewis ? ewis : [];
			
			this._dispatchDefectsManagerInitialized(dojo.hitch(this, function(){
				this.fireToRTC = true;
				ProgressDialog.doRunWithProgress(Constants.getMessage("labelQueryAssociatedBlockingDefects"), dojo.hitch(this, function(monitor) {
					var ewis = this.ewis;
					var itemIdOrUriArray = [];
					for(var i = 0; i < ewis.length; i++){
						itemIdOrUriArray.push(ewis[i].itemId);
					}
					getDefectsManager().queryAssociatedDefects("com.ibm.rqm.execution.linktype.ewiblockingdefect", false, itemIdOrUriArray, monitor, dojo.hitch(this, function(status, response) {
						monitor.done();
						if(status.isOK()){
							dojo.forEach(this.ewis, dojo.hitch(this, function(ewi){
								var defects = [];
								if (dojo.isArray(response)){
									dojo.forEach(response, dojo.hitch(this, function(workItem) {
										workItem.isBlocking = true;
										if(ewi.itemId == workItem.ewiItemId)
												defects.push(workItem);
									}));
								}
								ewi.defects = defects;
							}));
							this._ewiTableViewer.refresh(this.ewis, this.iterations, this.contributors, true);
							if(!this.isEditorSection)
								this._ewiTableViewer.stopInProgress();
						} else if(!status.isOK() && status.getSeverity() != Status.CANCEL) {
							status.log();
						}
					}));
				}));
			}), dojo.hitch(this, function(){
				if(this.ewis.length>0){
					for(var i=0;i<this.ewis.length;i++){
						this.ewis[i].defects = this._fixDefectInfo(this.ewis[i].defects);
					}
				}
				this._ewiTableViewer.refresh(this.ewis, this.iterations, this.contributors, true);
				if(!this.isEditorSection)
					this._ewiTableViewer.stopInProgress();
			}));
		},
		
        getTableActions: function() {    
            var actions = [];       
            var ewi_type = com.ibm.asq.common.web.client.internal.PermissionsClient.OP_EXECUTION_EWI_EXE;
            var ewi_exe_perm = com.ibm.asq.common.web.client.internal.PermissionsClient.getStoredPermission(ewi_type);
            
            if (!ewi_exe_perm || ewi_exe_perm.execute) {
                actions.push({
                    actionId: "execute",
                    label: Constants.getMessage("labelExecute"),
                    actionHandler: dojo.hitch(this, "onExecute"),
                    iconClass: "execute-icon-image",
                    disabled: true
                });
                actions.push({
                    actionId: "resume",
                    label: Constants.getMessage("labelResumeExe"),
                    actionHandler: dojo.hitch(this, "onResume"),
                    iconClass: "resume-icon-image",
                    disabled: true
                });
            }
            ewi_type = com.ibm.asq.common.web.client.internal.PermissionsClient.OP_EXECUTION_EWI;
            var ewi_perm = com.ibm.asq.common.web.client.internal.PermissionsClient.getStoredPermission(ewi_type);
            if (!ewi_perm || ewi_perm.edit) {
                actions.push({
                    actionId: "edit",
                    label: Constants.getMessage("labelEdit"),
                    actionHandler: dojo.hitch(this, "onEdit"),
                    iconClass: "edit-icon-image",
                    disabled: true
                });
                actions.push({
                    actionId: "discardedit",
                    label: Constants.getMessage("labelDiscardChanges"),
                    actionHandler: dojo.hitch(this, "onEdit"),
                    iconClass: "discard-edit-icon-image",
                    disabled: true,
					hidden:true
                });
                actions.push({
                    actionId: "batcheditowner",
                    label: Constants.getMessage("labelChangeOwner"),
                    actionHandler: dojo.hitch(this, "onChangeOwner"),
                    iconClass: "change-owner-icon-image",
                    disabled: true,
					hidden: true
                });
                
                actions.push({
                    actionId: "save",
                    label: Constants.getMessage("labelSave"),
                    actionHandler: dojo.hitch(this, "onSave"),
                    iconClass: "save-icon-image",
                    disabled: true,
					hidden: true
                });
				
				actions.push({
	                actionId: "unblock",
	                label: Constants.getMessage("editBlockingDefects"),
	                actionHandler: dojo.hitch(this, "onUnBlock"),
	                iconClass: "change-blocked-defect-status-icon-image",
	                disabled: true
	            }); 
            } 
            if (this.tableActions) {
                actions = actions.concat(this.tableActions);
            }
            
            if (!this.showQueryFilters) {
                actions.push({
                    actionId: "refresh",
                    label: Constants.getMessage("labelRefreshEWI"),
                    actionHandler: dojo.hitch(this, "onRefresh"),
                    iconClass: "refresh-icon-image",
                    disabled: false
                });
            }
            return actions;
        },
        _getSortedDefectList:function(defectList){
			if(defectList){
				defectList.sort(function(defect1,defect2){
					var id1 = parseInt(defect1.id, 10);
					var id2 = parseInt(defect2.id, 10);
					id1 = isNaN(id1) ? -1 : id1;
					id2 = isNaN(id2) ? -1 : id2;
					return id2-id1;  //if id2 is greater than id1 return positive 
				});
			}
            return defectList;
        },
		_fixDefectInfo:function(defects){
			var defectList = [];
			if(defects){
				for(var i=0;i<defects.length;i++){
					if(defects[i].workItem){
		                var defect = defects[i].workItem;
		                var defectId = "";
		                var defectStatus = Constants.getMessage("labelUnknown");
						var defectStatusId = 1;
		                var defectSummary = "";
						var blocking = false;
		                for(var j=0;j<defect.attributes.length;j++){
							switch (defect.attributes[j].key)
							{
								case "id":
									defectId = defect.attributes[j].value.id;
									break;
								case "summary":
									defectSummary = defect.attributes[j].value.content;
									break;
		                        case "internalState":
		                            defectStatus = defect.attributes[j].value.label;
									defectStatusId = parseInt(defect.attributes[j].value.id,10);
		                            break;
							}
						}
						if(defectStatusId != 5)//id 5 corresponds to Closed
							blocking = true;
						defectList.push({id:defectId,status:defectStatus,summary:defectSummary,statusId:defectStatusId,isBlocking:blocking});
					}else if(defects[i].id){
						if(defects[i].statusId && defects[i].statusId != 5){
							defects[i].isBlocking = true;
						}
						defectList.push(defects[i]);
					}
				}
			}
			return defectList;
		},	 
		_updateRelatedInfo: function(rowObject,state){
			this.toggleResume(rowObject,state);//To check if this EWI is resumable or not
			var ewis = this._ewiTableViewer.getSelectedEWIs();
			var ewiCount = ewis.length;
			if(this._relatedInfo && this._hasRelatedInfoPane == true){
				dojox.data.dom.removeChildren(this._defectArea._actionListNode);
				if(ewiCount >= 1){
					var unSortedDefects = this.fireToRTC ? this._getDefectsFromEwisViaProvider(ewis) : this._getDefectsFromEwis(ewis);
					var defects = this._getSortedDefectList(unSortedDefects);
					if(defects && defects.length>0){
						//this will eventually grow too big. Limiting to last MAX_DEFECTS
						var length = defects.length;
						if(length > MAX_DEFECTS)
							length = MAX_DEFECTS;
						for(var j=0;j<length;j++){
							var defectText = "";
							if(defects[j].summary.length>10)
								defectText = defects[j].id+":"+defects[j].summary.substr(0, 9) +"... -- "+defects[j].status;
							else
								defectText = defects[j].id+":"+defects[j].summary+" -- "+defects[j].status;
							var defectUrl = defects[j].reference ? defects[j].reference : (DEFECT_URL+defects[j].id);
							this._relatedInfo.addLink(Constants.getMessage("labelBlockingDefects"), defectText, defectUrl);
						}
					}
				}
			}			
		},
		
		toggleResume: function(ewi, state) {		
            var showResume = state && Utility.isPaused(ewi ? ewi.currentResult : null);
			if (showResume)
					this._ewiTableViewer.enableAction("resume");
				else
					this._ewiTableViewer.disableAction("resume");
		},
		
		getConfiguration: function(ewi) {
         if (ewi.configuration) {
				if (!ewi.config) {
					var self = this;
					var callbackObj = {
						success: function(config){
							self._createCatalog(ewi,config);
						},
						failure: function(e){
							self.error(e);
						}
					}
					var responseHandler = new ServiceResponseHandler(callbackObj, "success", "failure");
                    var config = new com.ibm.rational.test.lm.web.client.internal.config(); 
					config.retrieveConfigurationWithDetails(responseHandler, ewi.configuration);
				} else {
					this._createCatalog(ewi);
				}
         } else {
			ewi.configurationText = Constants.getMessage("labelNotConfig");
			this._ewiTableViewer.addConfigurationInfo(ewi.id, Constants.getMessage("labelNotConfig"));
         }			
		},
		
		_createCatalog: function(ewi,config){	
		   this.theCatalog = this.theCatalog ? this.theCatalog : new com.ibm.asq.common.web.client.internal.Catalog();
         //initialize the catalog if necessary
			var catalog = com.ibm.asq.common.web.client.internal.Catalog;
			if (!catalog.theCatalog) {			
				var self = this;
				var callbackObj = {
					success: function(){
						self._setConfig(ewi,config);
					},
					failure: function(e){
						self._error(e);
					}
				}
				var responseHandler = new ServiceResponseHandler(callbackObj, "success", "failure");
				this.theCatalog.initializeTemplates(responseHandler);
			} else {
				this._setConfig(ewi,config);
			}
		},
		
		_setConfig: function(ewi,config){
			this._ewiTableViewer.addConfigurationInfo(ewi.id, config);
		},
		
		onExecute: function(){
			//Only execute the first selected EWI.  Convert to Single Select table mode once available (See RQM WI: 1664)
			var selectedEWIs = this._ewiTableViewer ? this._ewiTableViewer.getSelectedEWIs() : null;						
         	if(!selectedEWIs || selectedEWIs.length == 0) {
				if(this.parentSection)
					this.parentSection.getParentEditor().setHeaderStatus(Constants.OPERATION_WARNING, Constants.HEADER_STATUS_WARNING, Constants.getMessage("msgSelectEWIExe"));
				else
					this._displayAlertDialog(Constants.getMessage("msgSelectEWIExe"));
	            return;
         	}	
			var ewi = selectedEWIs[0];
			var scriptId = null;
			if(ewi.selectedScriptId && ewi.selectedScriptId != "-1")
				scriptId = ewi.selectedScriptId;
         	if (scriptId != null)
				parent.location = Utility.startExecution(ewi.itemId, scriptId);
			else
				parent.location = Utility.getResultURI({ewiId: ewi.id, resultItemId: null, editable:true});							     				
		},
		onResume: function(){
         //Only resume the first selected EWI.  Convert to Single Select table mode once available (See RQM WI: 1664)
         var selectedEWIs = this._ewiTableViewer ? this._ewiTableViewer.getSelectedEWIs() : null;                 
         if(!selectedEWIs || selectedEWIs.length == 0) {
			if(this.parentSection)
				this.parentSection.getParentEditor().setHeaderStatus(Constants.OPERATION_WARNING, Constants.HEADER_STATUS_WARNING, Constants.getMessage("msgSelectEWIResume"));
			else
				this._displayAlertDialog(Constants.getMessage("msgSelectEWIResume"));
            return;
         }  
         var ewi = selectedEWIs[0]; 
		 if (!Utility.isPaused(ewi ? ewi.currentResult : null)) {
			if(this.parentSection)
				this.parentSection.getParentEditor().setHeaderStatus(Constants.OPERATION_WARNING, Constants.HEADER_STATUS_WARNING, Constants.getMessage("msgEWInotResumable"));
			else 
				this._displayAlertDialog(Constants.getMessage("msgEWInotResumable"));	
           	return;				
		 }      
         //run currently paused script, not selected script - TODO notify user ?
			var scriptId = ewi.currentResultScritpId ? ewi.currentResultScritpId : null;
			var resultId = ewi.currentResult.itemId;
			
         parent.location = Utility.startExecution(ewi.itemId, scriptId, resultId);			
		},
		
		_getResumeURL: function(ewiItemId, scriptId, resultItemId){
			return Utility.startExecution(ewiItemId, scriptId, resultItemId);
		},
		
		getList: function(){
			return this._list;
		},
		
		onRefresh: function(){
			this._ewiTableViewer.disableAction("refresh");
			this.initialize();
		},

		onEdit: function(){
			this._ewiTableViewer.toggleTableStateForEditing(true);
		},

		onChangeOwner: function(){
			//Bring up change owner dialog and then on press of OK on that dialog update the table for that
			//Save only on global save on table

            var floatDiv = new FloatingDiv();
            floatDiv.initialize({ title: Constants.getMessage("labelChangeOwner") });
            var reassignWidget = new ReassignPopup({
                objectScope: this,
                callbackFunction: "_batchChangeOwners",
                valueType: "userId"
            });
            floatDiv.addChild(reassignWidget);
			var contributors = []
			for(var i=0;i<this.contributors.length;i++){
				if(this.contributors[i].name != "ADMIN" && this.contributors[i].name != "GUEST" && !this.contributors[i].archived)
					contributors.push({value: this.contributors[i].name, id: this.contributors[i].userId});
			}
			var args = {
                        datas: contributors,
                        type: "User"
                    }
			reassignWidget.initData(args);
		},
		
		_batchChangeOwners: function(args){
			var selectedEWIs = this._ewiTableViewer.getCurrentEditableRows();
			for(var i=0;i<selectedEWIs.length;i++){
				this._ewiTableViewer.updateOwnerInfo(selectedEWIs[i].id, args.value);
			}
		},
		
		onSave: function(){
			var changedWorkitems = this._ewiTableViewer.getChangedEWIs();
			if(changedWorkitems && changedWorkitems.length>0){
				for(idx in changedWorkitems){
					var row = changedWorkitems[idx];
					if (row.weight < 0) {
						this._ewiTableViewer.viewHeaderNode.setStatus(Constants.getMessage("labelWeightValueWarning"), ViewHeaderLayout.WARNING);
						return;
					}
				}
				this._ewiTableViewer.toggleTableStateForEditing();
				if( this.parentSection){
					this.parentSection.setDirty();
				}
				var responseHandler = new ServiceResponseHandler(this, "_afterUpdatingWorkitem" , "_saveError");
				this.lastSavedEWI = changedWorkitems[changedWorkitems.length-1].id;
				for(var i=0;i<changedWorkitems.length;i++){
					var args = changedWorkitems[i];
					ExecutionWorkItemClient.postExecutionWorkItemDTO(responseHandler, args);
				}
			}else{
				this._ewiTableViewer.toggleTableStateForEditing();
			}
		},
		
		_afterUpdatingWorkitem: function(workitem){
			if (this.lastSavedEWI == workitem.id) {
				this._ewiTableViewer.updateEWI(workitem, true);
				this._ewiTableViewer.viewHeaderNode.setStatus(Constants.getCommonMessage("statusSaveSuccess", EditorUtil.getTimeString()),
					ViewHeaderLayout.SUCCESS);
			}
			else {
				this._ewiTableViewer.updateEWI(workitem, false);
			}
		},
			
		// handler on artifacts changed
	    onArtifactChanged: function(changeType, artifactType, artifactArray) {
	        // handle Test Execution Records
	        if (artifactType == Constants.TYPE_EWI) {
	            var ewiArray = [];
	            if ((changeType == GlobalEvents.ArtifactsAdded) || (changeType == GlobalEvents.ArtifactsUpdated) || (changeType == GlobalEvents.ArtifactsDeleted)) {
	                // update the config that is associated to the EWI
	                for (var i = 0; i < artifactArray.length; i++) {
	                    if (this.owner) {
							if((artifactArray[i].owner.id && this.owner != artifactArray[i].owner.id)||
								(artifactArray[i].owner.userId && this.owner != artifactArray[i].owner.userId))
	                        // skip EWI if it is for "My EWI" page and the owner is not the current owner
	                        continue;
	                    }
						artifactArray[i].defects = this._fixDefectInfo(artifactArray[i].defects);
	                    var idx = ewiArray.push(artifactArray[i])
	                    this.getConfiguration(ewiArray[idx - 1]);
	                }
	            }
	            if (this._ewiTableViewer) {
	                this._ewiTableViewer.onArtifactChanged(changeType, artifactType, ewiArray);
					this._updateRelatedInfo();
	            } else {
	                this.onRefresh();
				}
	        } else if ((artifactType == Constants.TYPE_SCRIPT) && ((changeType == GlobalEvents.ArtifactsDeleted))) {
	            	// for test script only care about deletion
					this._preLoadCheck();
			}else if ((artifactType == Constants.TYPE_CASE) && ((changeType == GlobalEvents.ArtifactsUpdated))){
					this._ewiTableViewer.onArtifactChanged(changeType, artifactType, artifactArray);
				}
	    },
		
		_saveError:function(err){
			this._displayAlertDialog(err.message);
		},
		_getDefectsFromEwis:function(ewis){
			var defects = [];
			var temp = [];
			if(ewis.length == 1)
				return ewis[0].defects;
			for(var i=0;i<ewis.length;i++){
				for(var j=0;j<ewis[i].defects.length;j++){
					//put each defect in its bucket and then check bucket count to find intersection
					var defectId = ewis[i].defects[j].id;
					if(temp[defectId])
						temp[defectId].count++;
					else{
						var defectStatus = ewis[i].defects[j].status;
						var defectSummary = ewis[i].defects[j].summary;
						var blocking = ewis[i].defects[j].isBlocking;
						temp[defectId] = {id:defectId,status:defectStatus,summary:defectSummary,isBlocking:blocking,count:1};
					}
				}
			}
			for (var defect in temp){
				if(temp[defect].count == ewis.length)
					defects.push({id:temp[defect].id,status:temp[defect].status,summary:temp[defect].summary,isBlocking:temp[defect].isBlocking});
			}
			return defects;
		},
		
		_getDefectsFromEwisViaProvider: function(ewis){
			var temp = [];
			for(var i = 0; i < ewis.length; i++){
				for(var j = 0; j < ewis[i].defects.length; j++){
					if(temp[ewis[i].defects[j].reference] && ewis[i].defects[j].ewiItemId == ewis[i].itemId )
						temp[ewis[i].defects[j].reference].count++;
					else if (ewis[i].defects[j].ewiItemId == ewis[i].itemId){
						temp[ewis[i].defects[j].reference] = ewis[i].defects[j];
						temp[ewis[i].defects[j].reference].count = 1;
						temp[ewis[i].defects[j].reference].isBlocking = true;
					}
				}
			}
			var defects = [];
			for (var defect in temp) {
				if(temp[defect].count == ewis.length)
					defects.push(temp[defect]);
			}
			return defects;
		},
		
		onUnBlock: function(){
			this._dispatchDefectsManagerInitialized(dojo.hitch(this, function(){
				this.onUnBlock1();
			}), dojo.hitch(this, function(){
				this.onUnBlock2();
			}));
		},
		
		onUnBlock1: function() {
			var ewis = this._ewiTableViewer.getSelectedEWIs();

			var blockingdefectsPopUp = new BlockingDefectsPopUp();
			var args= {
				ewis: ewis,
				fireToRTC: true,
				okCallback: dojo.hitch(this, function(){
					this._setEWITableContent(this.ewis);
				}),
				cancelCallback: dojo.hitch(this, function(){
					this._setEWITableContent(this.ewis);
				})
			}
			blockingdefectsPopUp.initialize(args);
		},
		
		onUnBlock2: function(){
			if(this._ewiTableViewer){
				var selectedItems = this._ewiTableViewer.getSelectedEWIs();
				var ewis = [];
				for(var i=0;i<selectedItems.length;i++){
					ewis.push({id:selectedItems[i].id,stateId:selectedItems[i].stateId, itemId:selectedItems[i].itemId});
				}
				var defects = this._getDefectsFromEwis(selectedItems);
			    var blockingdefectsPopUp = new BlockingDefectsPopUp();
				var args= {
                    ewis:ewis,
					defects: defects,
					okCallback: dojo.hitch(this, this._onOk),
					cancelCallback: dojo.hitch(this, this._onCancel),
					isClosable: true
				};
				blockingdefectsPopUp.initialize(args);
			}
		},
		
		_onOk: function(selectedEWIs,addedDefectIds,removedDefectIds){
			if((addedDefectIds && addedDefectIds.length > 0)||(removedDefectIds && removedDefectIds.length>0)){
				for(var i=0;i<selectedEWIs.length;i++){
					var args = {
						id: selectedEWIs[i].id,
						ewiStateId:selectedEWIs[i].stateId,
						addDefectIds:addedDefectIds,
						removeDefectIds: removedDefectIds
					};
					this.lastModifiedEWI = selectedEWIs[selectedEWIs.length-1].id;
					var self = this;
					var callbackObj = {
						success: function(ewi){
							ewi.defects = self._fixDefectInfo(ewi.defects);
							if(ewi.id == self.lastModifiedEWI){
								self.lastModifiedEWI = null;
								self._ewiTableViewer.updateEWI(ewi,true);
								self._updateRelatedInfo();
							}
							self._ewiTableViewer.updateEWI(ewi,false);
						},
						failure: function(errorObj){
							console.error("could not remove blocking defects from EWIList")
						}
					}
					var responseHandler = new ServiceResponseHandler(callbackObj, "success" , "failure");
					ExecutionWorkItemClient.postExecutionWorkItemDTO(responseHandler, args);
				}
			}
		},
		_isBeingEdited:function(){
			return this._ewiTableViewer.getIsInEditMode();
		},
		_onCancel: function(){
		},
		
		_error: function(errorObj){
			console.error("Error: (message: '" + errorObj.message + "') from EWIList#_error");
		},
		
		_displayAlertDialog: function(message){
            var alertDialog = new AlertDialog({
                'message': message
            });
            alertDialog.open();
        }
	}
);

})();
