
/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2006. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rqm.adapter.rft.web.ui.internal.view.extension.FunctionalExecutionSection");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.rqm.adapter.rft.web.ui.internal.view.execution.FunctionalExecution");
//xojo.require("com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.ExecutionViewer");

(function() { // module container

var   ExecutionViewer    				= com.ibm.rqm.execution.web.ui.internal.view.common.ExecutionViewer;
var   ACTUALNAME					   	= "actualName";
var   DATASTOREPATH					   	="datastore"

dojo.declare(
   "com.ibm.rqm.adapter.rft.web.ui.internal.view.extension.FunctionalExecutionSection", 
   [dijit._Widget, dijit._Templated, ExecutionViewer], 
   {
   templateString: "<div dojoAttachPoint=\"_functionalExecutionSection\" class=\"com-ibm-rqm-execution-web-ui-internal-view-extension-FunctionalExecutionSection\"></div>",
   
   constructor: function(args) {    
   },
   
   postCreate: function() {
	},

	//@Overriden from ExecutionViewer
   	initialize: function()
	{   
		
		var scriptInfo = {
			itemId: this.script.itemId,
			type: this.script.scriptType.id,
			_resultId: this._resultId,
			parentWidget:this.parentEditor
		};
		if (this.script != null) {
		  if(this.script.properties)
		  {
			for(var i=0;i<this.script.properties.length; i++)
			{
				if(this.script.properties[i].propertyName === ACTUALNAME)
					scriptInfo.actualName = this.script.properties[i].propertyValue;
				if(this.script.properties[i].propertyName === DATASTOREPATH)
					scriptInfo.dataStoreLocation = this.script.properties[i].propertyValue;	
			}
		  }
		}         
		this.scriptInfo = scriptInfo;     
		dojox.data.dom.removeChildren(this._functionalExecutionSection);
		this._funcWidget = new com.ibm.rqm.adapter.rft.web.ui.internal.view.execution.FunctionalExecution({ parentController: this.parentController, ewiItemId: this.ewiItemId, scriptInfo: scriptInfo, parentSection: this});
		this._functionalExecutionSection.appendChild(this._funcWidget.domNode);
		this.inherited("initialize", arguments);	        
   },

	//@Overriden from ExecutionViewer
	getHelpContextID: function()
	{
	  return "rqm_test_cases.html";
	}, 

	//@Overriden from ExecutionViewer
	//SATYAM COMMENTED getExecutionRequestProperties: function()
	//{
		//return [];
		//var props = [];
		//props.push({propertyName: "scriptName", propertyValue: this.scriptInfo.actualName});
		//props.push({propertyName: "scriptPath", propertyValue: this.scriptInfo.dataStoreLocation});
		//return props;
	//},
	
	//@Overriden from ExecutionViewer
	setCurrentRequest: function(request)
	{
		this._funcWidget.showMessages(request.response)
		this.inherited("setCurrentRequest", arguments)
	}
});

})();