/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2006. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rqm.adapter.testrt.web.ui.internal.view.extension.TestRTExecutionSection");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.rqm.adapter.testrt.web.ui.internal.view.execution.TestRTExecution");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.ExecutionViewer");

(function() { // module container

var   ExecutionViewer					= com.ibm.rqm.execution.web.ui.internal.view.common.ExecutionViewer;

dojo.declare(
   "com.ibm.rqm.adapter.testrt.web.ui.internal.view.extension.TestRTExecutionSection", 
   [dijit._Widget, dijit._Templated, ExecutionViewer], 
   {
   templateString: "<div dojoAttachPoint=\"_testrtExecutionSection\" class=\"com-ibm-rqm-execution-web-ui-internal-view-extension-TestRTExecutionSection\"></div>",
   
   constructor: function(args) {    
   },
   
   postCreate: function() {
	},

	//@Overriden from ExecutionViewer
   	initialize: function()
	{   
		var scriptInfo = {
			itemId: this.script.itemId,
			type: this.script.scriptType.id,
			_resultId: this._resultId,
			parentWidget:this.parentEditor
		};
		if (this.script != null) {
		  if(this.script.properties)
		  {
			for(var i=0;i<this.script.properties.length; i++)
			{
				if(this.script.properties[i].propertyName === "testRtScriptPath")
					scriptInfo.testrtScriptPath = this.script.properties[i].propertyValue;
				if(this.script.properties[i].propertyName === "testNodeName")
					scriptInfo.testNodeName = this.script.properties[i].propertyValue;
			}
		  }
		}         
        this.scriptInfo = scriptInfo;
		dojox.data.dom.removeChildren(this._testrtExecutionSection);
		this._testrtWidget = new com.ibm.rqm.adapter.testrt.web.ui.internal.view.execution.TestRTExecution({ parentController: this.parentController, ewiItemId: this.ewiItemId, scriptInfo: scriptInfo, parentSection: this});
		this._testrtExecutionSection.appendChild(this._testrtWidget.domNode);
		this.inherited("initialize", arguments);	
   },

	//@Overriden from ExecutionViewer
	getHelpContextID: function()
	{
	  return "rqm_testrt_test.html";
	}, 

	//@Overriden from ExecutionViewer
	setCurrentRequest: function(request)
	{
		this._testrtWidget.showMessages(request.response)
		this.inherited("setCurrentRequest", arguments)
	}
});

})();