/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading com.ibm.rqm.keyword.web.ui.internal.view.keyword.TagCloud");
dojo.provide("com.ibm.rqm.keyword.web.ui.internal.view.keyword.TagCloud");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

(function(){
    
    /**
     *
     */
    dojo.declare("com.ibm.rqm.keyword.web.ui.internal.view.keyword.TagCloud", [dijit._Widget, dijit._Templated], {
        templateString: '<div dojoAttachPoint="_tagCloud"></div>',
        
		postCreate: function(){
			this._MIN_LIST_FONT_SIZE = 12;  // pixels
			this._MAX_LIST_FONT_SIZE = 24;  // pixels		
			this._DEFAULT_LIST_FONT_SIZE = 12;  // pixels
			this._MAX_LIST_DISPLAY_ITEMS = 30;
			this.showTagList(this.tagList);
		},
		showTagList:function(tagList)
		{
			var parameters = {maxValue:0,minValue:0,parameterCount:0,parameterNames:[],parameterValues:[]};
			var tagMap = [];
			for(var i=0;i<tagList.length;i++)
			{
				if(tagMap[tagList[i]])
					tagMap[tagList[i]]++;
				else
					tagMap[tagList[i]] = 1;
			}
			for (var name in tagMap)
			{
				parameters.parameterNames.push(name);
				parameters.parameterValues.push(tagMap[name]);
				parameters.parameterCount++;
				if(parameters.maxValue < tagMap[name])
					parameters.maxValue = tagMap[name];
				if(parameters.minValue == 0 || parameters.minValue > tagMap[name] )
					parameters.minValue = tagMap[name];
			}
			this._createList(parameters);
		},
		_createList: function(parameters) {
			// Create the list entry filter (if necessary)
			this._createListEntryFilter(parameters);
			// Calculate the list font size ratio
			var maxValue = parameters.maxValue;
			var minValue = parameters.minValue;
			var fontSizeRatio = this._calculateListFontSizeRatio(
				minValue, maxValue);
			// Get the attach point
			var node = this._contentArea;
			// Create the list
			var list = document.createElement("div");
			dojo.addClass(list, "weighted-list");
			dojo.addClass(list, "hide-frequencies");
			// Create the table body
	 		for (var i = 0; i < parameters.parameterCount; i++) {
				// Get the name
				var name = parameters.parameterNames[i];
				// Get the value
				var value = parameters.parameterValues[i];
				// Add the entry to the list
				this._createListEntry(list, name, value, fontSizeRatio, maxValue);
			}
			// Add the list entry filter control (if necessary)
			//this._createListControlArea(list);
	 		// Assemble table contents
			//this._addReportNode(node, list);
			dojox.data.dom.removeChildren(this._tagCloud);
			this._tagCloud.appendChild(list);
		},	

		_cloneContainer: function(container) {
				// Container
				var newContainer = new Object();
				// Parameter count
				newContainer.parameterCount = container.parameterCount;
				// Parameter names
				newContainer.parameterNames = new Array();
				// Parameter values
				newContainer.parameterValues = new Array();
				// Populate
				for (var i = 0; i < container.parameterCount; i++) {
					newContainer.parameterNames[i] = container.parameterNames[i];
					newContainer.parameterValues[i] = container.parameterValues[i];
				}
				
				return newContainer;
			},

		_createListEntryFilter: function(parameters) {
			// Clear filter
			this._listEntryFilter = null;
			// Determine if there is anything to do
			if (parameters.parameterCount <= this._MAX_LIST_DISPLAY_ITEMS) {
				return;
			}
			// Create filter
			this._listEntryFilter = new Array();		
			// Clone the parameters
			var newContainer = this._cloneContainer(parameters);
			// Sort the names and values by descending value
			this._parameterValuesShellSort(newContainer);
			// Only the list entries with the highest values will be displayed
			// Populate filter with the list items that exceed the maximum number
			// of displayable items
			for (var i = this._MAX_LIST_DISPLAY_ITEMS; i < newContainer.parameterCount; i++) {
				// Get the name
				var name = newContainer.parameterNames[i];
				// Add name to filter
				// Name is key
				// Value is null for now (will be populated with DOM element later)
				this._listEntryFilter[name] = null;
			}
		},	
        _calculateListFontSizeRatio: function(minValue, maxValue) {
			var fontSizeDifference = this._MAX_LIST_FONT_SIZE -
									 this._MIN_LIST_FONT_SIZE;
			var valueDifference = maxValue - minValue;
			var ratio = 0;
			if (valueDifference > 0) {
				ratio = fontSizeDifference / valueDifference;
			} else {
				// Edge case
				// The min and max values are the same (i.e. the list values are 
				// all of equal weight)
				// A ratio of -1 indicates that the default font size should be
				// used for all values (used to be maximum font size)
				ratio = -1;
			}
	
			return ratio;
		},
	
		/*
	 	 * Private Method
	 	 * 
	 	 * @param Number value
	 	 * @param Number ratio
	 	 * @param Number maxValue
	 	 * @return String
	 	 */		
		_calculateListEntryFontSize: function(value, ratio, maxValue) {
			var fontSize;
			if (ratio < 0) {
				// Edge case
				// The list values are all of equal weight
				fontSize = this._DEFAULT_LIST_FONT_SIZE;
			} else {
				var scaledValue = Math.abs(value - maxValue) * ratio;
				fontSize = Math.round(this._MAX_LIST_FONT_SIZE - scaledValue);			
			}
	
			return fontSize + "px";
		},
		_createListEntry: function(list, name, value, fontSizeRatio, maxValue) {
			// Create the link
			var link = this._createTableClickThroughLink(name, value);
			// Create the text
			var frequency = document.createElement("span");
			dojo.addClass(frequency, "frequency");
			frequency.innerHTML = "(" + value + ")";
			// Create the span
			var container = document.createElement("span");
			dojo.addClass(container, "list-entry");
			container.style.fontSize = this._calculateListEntryFontSize(value, fontSizeRatio, maxValue);
			// Determine whether to filter this entry
			//if (this._isListEntryFiltered(name)) {
				// Store node
			//	this._listEntryFilter[name] = container;
				// Hide node
			//	container.style.display = "none";
			//}
			// Assemble contents
			// Do not allow breaking between the link and frequency
			var nobr = document.createElement("nobr");
			nobr.appendChild(link);
			nobr.appendChild(frequency);
			container.appendChild(nobr);
			// Create whitespace in order to allow breaking between list entries
			container.appendChild(document.createTextNode(" "));
			
			list.appendChild(container);
		},
		_createTableClickThroughLink: function(name, value) {
			// Name
			var data1 = document.createTextNode(name);		
			// Create click through link on name
			var link = document.createElement("a");
			link.setAttribute("title", value);
			link.appendChild(data1);
			link.style.cursor = "pointer";
			// Create a reference to this object to use in the service object
			var self = this;		
			// Handle click events
			this.connect(link, "onclick", 
				function() {
					self.viewer.handleTagClick(name);
				}
			);
			
			return link;				
		},	
		_parameterValuesShellSort: function(container) {
			// Validate data
			if (container.parameterCount <= 0) {
				// Nothing to do
				return;
			}
			// Custom sort required to sort names and values simultaneously
			var names = container.parameterNames;
			var values = container.parameterValues;
			// Shell sort O(n^2)
			for (var increment = values.length / 2; increment > 0; increment = (increment == 2 ? 1 : Math.round(increment / 2.2))) {
				for (var i = increment; i < values.length; i++) {
					// Descending sort
					for (var j = i; j >= increment && values[j - increment] < values[j]; j -= increment) {
						// Values
						var temp1 = values[j];
						values[j] = values[j - increment];
						values[j - increment] = temp1;
						// Names
						var temp2 = names[j];
						names[j] = names[j - increment];
						names[j - increment] = temp2;
					}
				}
			}
		}
    });
})();
