/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.planning.web.ui.internal.view.planning.PlanningBody");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.planning.PlanningBody");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");

// Require the common widgets needed
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.team.repository.web.client.session.Session");

dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.WorkItemEditor");
dojo.require("com.ibm.team.workitem.web.ui.internal.page.WorkItemPageView");
dojo.require("com.ibm.team.workitem.web.client.internal.WorkItemClient");

dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.TestPlanTableView");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.TestCaseTableView");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.TestScriptTableView");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.construction.TestGroupClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.construction.TestCaseClient");

dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");
//xojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.QueryEditor");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.TestGroupEditor");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.TestScriptEditor");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.TestCaseEditor");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.planning.TestPlanEditor");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.SortableFilterableTable");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.RelatedInfo");

(function() 
{
	var Constants  					= com.ibm.rqm.planning.web.client.internal.Constants;
	var ServiceResponseHandler		= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
	var WorkItemClient				= com.ibm.team.workitem.web.client.internal.WorkItemClient;	
	var PlanningPageClient			= com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient;
	var TestGroupClient				= com.ibm.rqm.planning.web.client.internal.construction.TestGroupClient;
	var TestCaseClient				= com.ibm.rqm.planning.web.client.internal.construction.TestCaseClient;
	var TestScriptClient			   = com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient;
	//var SortableFilterableTable	= com.ibm.rqm.planning.web.ui.internal.view.common.SortableFilterableTable;
	var TestPlanTableView         = com.ibm.rqm.planning.web.ui.internal.view.table.TestPlanTableView;
	var TestCaseTableView         = com.ibm.rqm.planning.web.ui.internal.view.table.TestCaseTableView;
	var TestScriptTableView       = com.ibm.rqm.planning.web.ui.internal.view.table.TestScriptTableView;
	
	var Utility						   = com.ibm.rqm.planning.web.ui.internal.util.Utility;
	var ImageCache					   = com.ibm.rqm.planning.web.ui.internal.view.common.ImageCache;
	var getAuthenticatedContributor	= com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
	
	var _anchors;
	var _currentOption;
	
	dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.planning.PlanningBody",
				 [dijit._Widget, dijit._Templated],
		{
			templateString: "<div><div dojoAttachPoint=\"_relatedInfo\"></div><div class=\"com-ibm-rqm-test-planning-page-body\" dojoAttachPoint=\"_planBody\"></div></div>", // dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/view/templates/planning/PlanningBody.html"),
//			templateCssPath: dojo.uri.dojoUri("../com.ibm.rqm.planning.web/ui/internal/view/templates/planning/PlanningBody.css"),
			
			// object constructor
			constructor: function(args)
			{
				this.controller = args.parentController;
				this.parentControler = args.parentController;
				this._currentView = "";
				this._plans = null;
			},
			
			postCreate: function()
			{
				dojox.data.dom.removeChildren(this._planBody);
				this._planBody.appendChild(document.createTextNode(Constants.getMessage("labelLoading")));
							
			},

			viewWorkItem: function(args)
			{
				dojox.data.dom.removeChildren(this._planBody);

				if (this._wiView == null)
				{
					this._wiView = new com.ibm.team.workitem.web.ui.internal.page.WorkItemPageView({});
				}

				var wiEditor = new com.ibm.team.workitem.web.ui.internal.view.editor.WorkItemEditor({ parentController: this._wiView.getController() });

				var self = this;
				var serviceObject =
				{
					viewWorkItemHandler: function(workItem)
					{
						if (workItem)
						{
							var tab = (args.tab != null) ? args.tab : null;
							wiEditor.setWorkItem(workItem, tab);
//							wiEditor.setWorkItem(workItem, tab, false);

							var div = document.createElement("div");
							div.className = "com-ibm-team-workitem";
							div.appendChild(wiEditor.domNode);
							self._planBody.appendChild(div);	
						}
						else
						{
							alert(Constants.getMessage("labelIdNotFound", id));
						}
					},
					error: function(error)
					{ 
						self._error(error, Constants.getMessage("labelEroorViewingWorkItem"));
					}
				};
		
				var responseHandler = new ServiceResponseHandler(serviceObject, "viewWorkItemHandler", "error");
		
				WorkItemClient.getWorkItem(responseHandler, {id: args.id});
			},
			
			//**********************************************************************
			// ACTIONS FOR DISPLAYING SINGLE 'NEW' ARTIFACT IN EDITOR
			//**********************************************************************
			newQuery: function()
			{
//				dojox.data.dom.removeChildren(this._planBody);
//				var editor = new com.ibm.rqm.planning.web.ui.internal.view.common.QueryEditor({ parentController: this.controller });
//				this._planBody.appendChild(editor.domNode);	
			},

			newTestPlan: function()
			{
				dojox.data.dom.removeChildren(this._planBody);
				this.editor = new com.ibm.rqm.planning.web.ui.internal.view.planning.TestPlanEditor();
				this._planBody.appendChild(this.editor.domNode);
				this.editor.initialize({ parentController: this.controller, plan: null });
			},
			
			newTestGroup: function()
			{
				dojox.data.dom.removeChildren(this._planBody);
				this.editor = new com.ibm.rqm.planning.web.ui.internal.view.construction.TestGroupEditor();
				this._planBody.appendChild(this.editor.domNode);
				this.editor.initialize({ parentController: this.controller });
			},
			
			newTestCase: function()
			{
				dojox.data.dom.removeChildren(this._planBody);
				this.editor = new com.ibm.rqm.planning.web.ui.internal.view.construction.TestCaseEditor();
				this._planBody.appendChild(this.editor.domNode);
				this.editor.initialize({ parentController: this.controller });					
			},						
			
			newTestScript: function()
			{
				dojox.data.dom.removeChildren(this._planBody);
				this.editor = new com.ibm.rqm.planning.web.ui.internal.view.construction.TestScriptEditor();
				this._planBody.appendChild(this.editor.domNode);
				this.editor.initialize({ parentController: this.controller });					
			},
			
         /*
			newEwi: function(args)
			{
				dojox.data.dom.removeChildren(this._planBody);
				var testCaseId = args != null && args.testCaseId != null ? args.testCaseId : null;
				var testCases = args != null && args.testCases != null ? args.testCases : null; 
				var ewiEditor = new com.ibm.rqm.execution.web.ui.internal.view.execution.CreateExecutionWorkItem({ parentController: this.controller});
				this._planBody.appendChild(ewiEditor.domNode);
			},
			*/
         
			//**********************************************************************
			// ACTIONS FOR DISPLAYING EXISTING SINGLE ARTIFACT IN EDITOR
			//**********************************************************************
			showTestPlan: function(plan)
			{
				dojox.data.dom.removeChildren(this._planBody);
				dojox.data.dom.removeChildren(this._relatedInfo);

				var relatedInfo = new com.ibm.asq.common.web.ui.internal.view.common.RelatedInfo();
				this._relatedInfo.appendChild(relatedInfo.domNode);

				this.editor = new com.ibm.rqm.planning.web.ui.internal.view.planning.TestPlanEditor();
				this._planBody.appendChild(this.editor.domNode);	
				this.editor.initialize({ parentController: this.controller, plan: plan });
			},
			
			showTestGroup: function(aGroup)
			{
				dojox.data.dom.removeChildren(this._planBody);
				this.editor = new com.ibm.rqm.planning.web.ui.internal.view.construction.TestGroupEditor();
				this._planBody.appendChild(this.editor.domNode);	
				this.editor.initialize({ parentController: this.controller, testGroup: aGroup});
			},			

			showTestCase: function(aCase)
			{
				dojox.data.dom.removeChildren(this._planBody);
				this.editor = new com.ibm.rqm.planning.web.ui.internal.view.construction.TestCaseEditor();				
				this._planBody.appendChild(this.editor.domNode);
				this.editor.initialize({ parentController: this.controller, testCase: aCase});
			},
			
			showTestScript: function(aScript) 
			{				
				dojox.data.dom.removeChildren(this._planBody);
				this.editor = new com.ibm.rqm.planning.web.ui.internal.view.construction.TestScriptEditor();
				this._planBody.appendChild(this.editor.domNode);	
				this.editor.initialize({parentController: this.controller, testScript: aScript});				
			},
			      
			//**********************************************************************
			// ACTIONS FOR COPYING EXISTING ARTIFACTS
			//**********************************************************************
			copyTestPlan: function(plan)
			{
				dojox.data.dom.removeChildren(this._planBody);
				this.editor = new com.ibm.rqm.planning.web.ui.internal.view.planning.TestPlanEditor();
				this._planBody.appendChild(this.editor.domNode);	
				this.editor.initialize({ parentController: this.controller, plan: plan, isCopy: true });
			},
			
			copyTestGroup: function(aGroup)
			{
				dojox.data.dom.removeChildren(this._planBody);
				this.editor = new com.ibm.rqm.planning.web.ui.internal.view.construction.TestGroupEditor();
				this._planBody.appendChild(this.editor.domNode);	
				this.editor.initialize({ parentController: this.controller, testGroup: aGroup, isCopy: true});
			},
			
			copyTestCase: function(aCase)
			{
				dojox.data.dom.removeChildren(this._planBody);
				this.editor = new com.ibm.rqm.planning.web.ui.internal.view.construction.TestCaseEditor();				
				this._planBody.appendChild(this.editor.domNode);
				this.editor.initialize({ parentController: this.controller, testCase: aCase, isCopy: true});
			},
			
			//**********************************************************************
			// ACTIONS FOR DISPLAYING EXISTING ARTIFACT LISTS USING SF TABLE
			//**********************************************************************
			showGenericSearchResults: function(results)
			{
				dojox.data.dom.removeChildren(this._planBody);
				this._currentView = "Search string: ";

				var listArgs = { 
					parentController: this.controller, 
					maxRows: 20,
					rangeStart: 1,
					isFilterable: true, 
					showQuery: true, 
					queryTitle: this._currentView, 
					runQueryHref: "#", 
					isQueryEditable: false, 
//					editQueryHref: "#",
					showFooter: true,
					sortColumn: 0, // score
					sortDirection: SortableFilterableTable.SORT_DSC,
					isDeleteColumn: true,
//					isMultiselect: true,
					isRowSelectable: true };

				var list = new com.ibm.rqm.planning.web.ui.internal.view.common.SortableFilterableTable();
				list.initialize(listArgs);

				list.addColumn( {title: Constants.getMessage("labelScorePlanningBody")+" (%)", isSortable: true, includeInFilter: false, width: "11%" });				
				list.addColumn( {title: Constants.getMessage("labelNamePlanningBody"), isSortable: false, includeInFilter: true, width: "44%"  });				
				list.addColumn( {title: Constants.getMessage("labelTypePlanningBody"), isSortable: true, includeInFilter: false, width: "15%"  });				
				list.addColumn( {title: Constants.getMessage("labelDetailsPlanningBody"), isSortable: false, includeInFilter: true, width: "30%"  });

				if (results != null)
				{
					for (var i=0; i < results.length; i++)
					{
						var score = new Number(results[i].score);
						var tmpVal = score / 1000;
						var val = new Number(tmpVal.toFixed());
						
						var type = results[i].resultValue.typeVal.substr(results[i].resultValue.typeVal.lastIndexOf(".") + 1);
						var id = results[i].resultValue.name.split(":")[0];
						var image = "";
						var tooltip = "";

						if (type == Constants.TYPE_PLAN.replace(" ", ""))
						{
							image = ImageCache.TEST_PLAN;
							tooltip = Constants.TYPE_PLAN; 
						}
						else if (type == Constants.TYPE_WORK_ITEM.replace(" ", ""))
						{
							image = ImageCache.WORK_ITEM;
							tooltip = Constants.TYPE_WORK_ITEM;
						}
						else if (type == Constants.TYPE_GROUP.replace(" ", "").replace(" ", ""))
						{
							image = ImageCache.TEST_GROUP;
							tooltip = Constants.TYPE_GROUP;
						}
						else if (type == Constants.TYPE_CASE.replace(" ", ""))
						{
							image = ImageCache.TEST_CASE;
							tooltip = Constants.TYPE_CASE;
						}
						else if (type == Constants.TYPE_SCRIPT.replace(" ", ""))
						{
							image = ImageCache.TEST_SCRIPT;
							tooltip = Constants.TYPE_SCRIPT;
						}
						
						var uri = this._getURI(type, id);
						
						list.addRow( {href: uri, 
									  removeParms: {obj: this, parm: results[i].name},
									  removeMethod: this.removeArtifact, 
									  elements: [
						                         {type: SortableFilterableTable.TYPE_NUM, data: val, image: "", tooltip: "", isLink: false, href: null}, 
										         {type: SortableFilterableTable.TYPE_STRING, data: results[i].resultValue.name, image: image, tooltip: tooltip, isLink: true, href: uri}, //Util.getTestPlanURI({id: this._plans[i].id})}, 
									  			 {type: SortableFilterableTable.TYPE_STRING, data: type, image: "", tooltip: "", isLink: false}, 
												 {type: SortableFilterableTable.TYPE_STRING, data: results[i].resultValue.details, image: "", tooltip: "", isLink: false}
												]});
					}				
				}

				this._planBody.appendChild(list.domNode);
				list.displayTable();
			},
			
            _getURI: function(type, id) {
                switch(type) {
				    case "TestPlan": return Utility.getTestPlanURI({id: id});
				    case "TestCaseGroup": return Utility.getTestGroupURI(id);
				    case "TestCase": return Utility.getTestCaseURI(id);
				    case "ExecutionScript": return Utility.getTestScriptURI(id);
				    case "SizingRecord": return Utility.getSizingRecordURI(id);
				    default: return "#";
                }
			 },
					
			showTestPlanList: function(plans, name) 
			{
				dojox.data.dom.removeChildren(this._planBody);
				//this._plans = plans;
				this._currentView = name;
            this._planTableViewer = new TestPlanTableView({plans: plans, queryName: this._currentView});
				this._planBody.appendChild(this._planTableViewer.domNode);
			},		
			
			removeTestPlan: function(self, id)
			{
				var serviceObject = 
				{
					testPlanRemoved: function(args) {
						// remove element with ID = id, which is in column 1
						self._planTable.removeElement(1, id);
					},
					error: function(error) { 
						self._error(error, Constants.getMessage("labelErrorRemoving", id));
					}
				};
		
				var responseHandler = new ServiceResponseHandler(serviceObject, Constants.getMessage("labelTestPlanRemoved"), Constants.getMessage("labelError"));
				PlanningPageClient.postDeleteTestPlan(responseHandler, {id: id});
			},
         
			//@DEPRECATED - TestCaseGroup concept to be removed in M6B
			showTestGroupList: function(groups, name)
			{
				dojox.data.dom.removeChildren(this._planBody);
				this._currentView = name;
				var listArgs = {
					parentController: this.controller, 
					maxRows: 20,
					rangeStart: 1,
					isFilterable: true, 
					showQuery: true, 
					queryTitle: this._currentView, 
					runQueryHref: "#", 
					isQueryEditable: false, 
					editQueryHref: "#",
					showFooter: true,
					sortColumn: 4, // last modified
					sortDirection: SortableFilterableTable.SORT_ASC,
					isDeleteColumn: true,
					isRowSelectable: true };
								
				this._groupTable = new com.ibm.rqm.planning.web.ui.internal.view.common.SortableFilterableTable();
				this._groupTable.initialize(listArgs);

				this._groupTable.addColumn( {title: Constants.getMessage("labelTypePlanningBody"), isSortable: false, includeInFilter: false, width: "8%" });				
				this._groupTable.addColumn( {title: Constants.getMessage("labelIDPlanningBody"), isSortable: true, includeInFilter: true, width: "5%"  });				
				this._groupTable.addColumn( {title: Constants.getMessage("labelNamePlannningBody"), isSortable: false, includeInFilter: true, width: "52%"  });				
				this._groupTable.addColumn( {title: Constants.getMessage("labelStatusPlanningBody"), isSortable: true, includeInFilter: false, width: "15%"  });
				this._groupTable.addColumn( {title: Constants.getMessage("labelLastModified"), isSortable: true, includeInFilter: false, width: "20%"  });				
				
				if (groups != null) {
					for (var i=0; i<groups.length; i++)
					{
						var id = new Number(groups[i].id).valueOf();
						this._groupTable.addRow( 
							{	
								href: Utility.getTestGroupURI(groups[i].id), 
								removeParms: {obj: this, parm: id},
								removeMethod: this.removeTestGroup, 								
								elements: [
						  			 {type: SortableFilterableTable.TYPE_ICON, data: "", image: ImageCache.TEST_GROUP, tooltip: "Test Group", isLink: false}, 
			                   {type: SortableFilterableTable.TYPE_NUM, data: id, image: "", tooltip: "", isLink: true}, 
							       {type: SortableFilterableTable.TYPE_STRING, data: groups[i].name, image: "", tooltip: "", isLink: true}, 
									 {type: SortableFilterableTable.TYPE_STRING, data: groups[i].state, image: "", tooltip: "", isLink: false},
									 {type: SortableFilterableTable.TYPE_DATE, data: groups[i].modified, image: "", tooltip: "", isLink: false} 
									]
							});
					}				
				}
				
				this._planBody.appendChild(this._groupTable.domNode);
				this._groupTable.displayTable();	
			},
			
			removeTestGroup: function(self, id)
			{
				var serviceObject = 
				{
					testGroupRemoved: function(args) {
						// remove element with ID = id, which is in column 1
						self._groupTable.removeElement(1, id);
					},
					error: function(error) { 
						self._error(error, Constants.getMessage("labelErrorRemivingTestGroup", id));
					}
				};
		
				var responseHandler = new ServiceResponseHandler(serviceObject, "testGroupRemoved", "error");
				TestGroupClient.removeTestGroup(responseHandler, {id: id});
			},			
			
			/*
			showTestCaseList: function(cases, name)
			{
				dojox.data.dom.removeChildren(this._planBody);
				this._currentView = name;
				var listArgs = { 
					parentController: this.controller, 
					maxRows: 10,
					rangeStart: 1,
					isFilterable: true, 
					showQuery: true, 
					queryTitle: this._currentView, 
					runQueryHref: "#", 
					isQueryEditable: false, 
					editQueryHref: "#",
					showFooter: true,
					sortColumn: 4, // last modified
					sortDirection: SortableFilterableTable.SORT_ASC,
//					isMultiselect: true,
					isDeleteColumn: true,
					isRowSelectable: true };
																				 
				this._caseTable = new com.ibm.rqm.planning.web.ui.internal.view.common.SortableFilterableTable();
				this._caseTable.initialize(listArgs);
				
//				this._caseTable.addColumn( {title: "Select", isSortable: false, includeInFilter: false, width: "8%" });				
				this._caseTable.addColumn( {title: "Type", isSortable: false, includeInFilter: false, width: "8%" });				
				this._caseTable.addColumn( {title: "Id", isSortable: true, includeInFilter: true, width: "5%"  });				
				this._caseTable.addColumn( {title: "Name", isSortable: false, includeInFilter: true, width: "52%"  });				
				this._caseTable.addColumn( {title: "Status", isSortable: true, includeInFilter: false, width: "10%"  });
				this._caseTable.addColumn( {title: "Weight", isSortable: true, includeInFilter: false, width: "10%"  });
				this._caseTable.addColumn( {title: "Last Modified", isSortable: true, includeInFilter: false, width: "15%"  });				
				
				if (cases != null)
				{
					for (var i=0; i<cases.length; i++)
					{
						var id = new Number(cases[i].id).valueOf();
//						var select = [{id: 1, displayName: "One"}, {id: 2, displayName: "Two"}];
						var elementHref = Utility.getTestCaseURI(cases[i].id);
						this._caseTable.addRow( {href: elementHref, 
									  removeParms: {obj: this, parm: id},
									  removeMethod: this.removeTestCase, 						
									  elements: [
//									  			 {type: SortableFilterableTable.TYPE_SELECT, data: select, image: "", tooltip: "", isLink: false},
									  			 {type: SortableFilterableTable.TYPE_ICON, data: "", image: ImageCache.TEST_CASE, tooltip: "Test Case", isLink: false}, 
						                   {type: SortableFilterableTable.TYPE_NUM, data: id, image: "", tooltip: "", isLink: true, href: elementHref}, 
										       {type: SortableFilterableTable.TYPE_STRING, data: cases[i].name, image: "", tooltip: "", isLink: true, href: elementHref}, 
												 {type: SortableFilterableTable.TYPE_STRING, data: cases[i].state, image: "", tooltip: "", isLink: false},
												 {type: SortableFilterableTable.TYPE_NUM, data: cases[i].weight, image: "", tooltip: "", isLink: false},
												 {type: SortableFilterableTable.TYPE_DATE, data: cases[i].modified, image: "", tooltip: "", isLink: false} 
									   ]});
					}				
				}
				
				this._planBody.appendChild(this._caseTable.domNode);
				this._caseTable.displayTable();
			},
			*/
         showTestCaseList: function(cases, name)
         {
            dojox.data.dom.removeChildren(this._planBody);
            this._currentView = name;
            this._caseTableViewer = new TestCaseTableView({testCases: cases, queryName: this._currentView});
            this._planBody.appendChild(this._caseTableViewer.domNode);            
         },       
			
			removeTestCase: function(self, id)
			{
				var serviceObject = 
				{
					testCaseRemoved: function(args) {
						// remove element with ID = id, which is in column 1
						self._caseTable.removeElement(1, id);
					},
					error: function(error) { 
						self._error(error, Constants.getMessage("labelErrorRemovingTestCase", id));
					}
				};
		
				var responseHandler = new ServiceResponseHandler(serviceObject, "testCaseRemoved", "error");
				TestCaseClient.removeTestCase(responseHandler, {id: id});
			},		
			
			/*
			showTestScriptList: function(scripts, name)
			{	
				dojox.data.dom.removeChildren(this._planBody);							
				this._currentView = name;
				var listArgs = {
					parentController: this.controller, 
					maxRows: 20,
					rangeStart: 1,
					isFilterable: true, 
					showQuery: true, 
					queryTitle: this._currentView, 
					runQueryHref: "#", 
					isQueryEditable: false, 
					editQueryHref: "#",
					showFooter: true,
					sortColumn: 4, // last modified
					sortDirection: SortableFilterableTable.SORT_ASC,
					isDeleteColumn: true,
					isRowSelectable: true};
					
				this._scriptTable = new com.ibm.rqm.planning.web.ui.internal.view.common.SortableFilterableTable();
				this._scriptTable.initialize(listArgs);
				
				this._scriptTable.addColumn( {title: "Type", isSortable: false, includeInFilter: false, width: "5%" });				
				this._scriptTable.addColumn( {title: "Id", isSortable: true, includeInFilter: true, width: "5%"  });				
				this._scriptTable.addColumn( {title: "Name", isSortable: false, includeInFilter: true, width: "40%"  });				
				this._scriptTable.addColumn( {title: "Description", isSortable: true, includeInFilter: false, width: "30%"  });
				this._scriptTable.addColumn( {title: "Last Modified", isSortable: true, includeInFilter: false, width: "20%"  });				
				
				//add a row for each script				
				if (scripts != null)
				{					
					for (var i = 0; i < scripts.length; i++)
					{
						var s = scripts[i];
						var id = new Number(s.id).valueOf();
						
						this._scriptTable.addRow( 
							{ href: Utility.getTestScriptURI(s.id), 
							  removeParms: {obj: this, parm: id},
							  removeMethod: this.removeTestScript,						
							  elements: [
					  			 {type: SortableFilterableTable.TYPE_ICON, data: "", image: ImageCache.TEST_SCRIPT, tooltip: "Test Script", isLink: false}, 
		                         {type: SortableFilterableTable.TYPE_NUM, data: id, image: "", tooltip: "", isLink: true}, 
						         {type: SortableFilterableTable.TYPE_STRING, data: s.name, image: "", tooltip: "", isLink: true}, 
								 {type: SortableFilterableTable.TYPE_STRING, data: s.description, image: "", tooltip: "", isLink: false},
								 {type: SortableFilterableTable.TYPE_DATE, data: s.modified, image: "", tooltip: "", isLink: false} 
							  ]
							}
						);
					}				
				}
				
//				this._planBody.className = "";		
				this._planBody.appendChild(this._scriptTable.domNode);
				this._scriptTable.displayTable();
			},
			*/
         showTestScriptList: function(scripts, name)
         {
            dojox.data.dom.removeChildren(this._planBody);
            this._currentView = name;
            this._scriptTableViewer = new TestScriptTableView({scripts: scripts, queryName: this._currentView});
            this._planBody.appendChild(this._scriptTableViewer.domNode);            
         },			
			
			removeTestScript: function(self, id)
			{
				var serviceObject = 
				{
					testScriptRemoved: function(args) {
						// remove element with ID = id, which is in column 1
						self._scriptTable.removeElement(1, id);
					},
					error: function(error) { 
						self._error(error, "Error removing Test Script #" + id);
					}
				};
		
				var responseHandler = new ServiceResponseHandler(serviceObject, "testScriptRemoved", "error");
				TestScriptClient.removeTestScript(responseHandler, {id: id});
			},
        
			/*
			 * TEST PLAN GLOBAL SAVE
			 */
			saveTestPlan: function(){
				this.editor.onSave();
			},
			
			_error: function(errorObj) 
			{
				alert("Error getting data (message: '" + errorObj.message + "') in PlanningBody#_error");
			}
		}
	);
}
)();
