/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading com.ibm.rqm.requirement.web.ui.internal.view.requirement.RequirementSelectionDialog");
dojo.provide("com.ibm.rqm.requirement.web.ui.internal.view.requirement.RequirementSelectionDialog");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

dojo.require("com.ibm.rqm.requirement.web.client.internal.requirement.RequirementWorkItemClient");
dojo.require("com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableView");

(function(){
	var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
	var requirementWorkItemClient = com.ibm.rqm.requirement.web.client.internal.requirement.RequirementWorkItemClient;
	var RequirementTableView = com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableView;
    var AlertDialog = com.ibm.asq.common.web.ui.internal.widgets.AlertDialog;
	var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
	var ImageCache     = com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
	/**
     *
     */
    dojo.declare("com.ibm.rqm.requirement.web.ui.internal.view.requirement.RequirementSelectionDialog", [dijit._Widget, dijit._Templated], {
        templatePath: dojo.moduleUrl("com.ibm.rqm.requirement.web", "ui/internal/view/templates/requirement/RequirementDialog.html"),
        
		okLabel: Constants.getMessage("labelOk"),
		cancelLabel: Constants.getMessage("labelCancel"),
		labelLoading: Constants.getMessage("labelLoading"),
		
        constructor: function(args){
            this._object = args.object;
            this.onOK = args.onOK;
            this.artifactId = args.artifactId;
			this.type = args.type;    
			this.requirements = args.requirements;        
        },
		  
		postCreate: function() {
        	this.loadRequirement();		  	
		},
        
        loadRequirement: function(){
			this._progressIndicator.style.display = "inline";
			var img = document.createElement("img");
			img.src = ImageCache.VIEW_PROGRESS;
			dojox.data.dom.removeChildren(this._image);
			this._image.appendChild(img);
			
			if (!this._reqTableViewer) {
                dojox.data.dom.removeChildren(this._requirementList);
                var args = {
                    requirements: this.requirements
                };
                this._reqTableViewer = new RequirementTableView(args);
                this._requirementList.appendChild(this._reqTableViewer.domNode);
            }
        },
        
		initialize: function() {
			this._fillRequirementTable = function(items){
                var leftrequirements = [];
				
				var existrq = this.requirements ? this.requirements: [];
				var i = 0 , j = 0 , flag;
				if (items && items.length > 0) {
					while (i < items.length) {
						flag = true;
						for (j = 0; j < existrq.length; j = j + 1) {
							if (existrq[j].id === items[i].id) {
								flag = false;
								break;
							}
						}
						if (flag) {
							leftrequirements.push(items[i]);
						}
						i = i + 1;
					}
				}
				this._progressIndicator.style.display = "none";
				this._reqTableViewer.refresh(leftrequirements);
            };
			var responseHandler = new ServiceResponseHandler(this, "_fillRequirementTable", "_error");
			var args = {};
			if (this.type == Constants.TYPE_CASE && this.artifactId) {
				args.relatedTestCaseItemId = this.artifactId;
			}
            requirementWorkItemClient.getRequirementWorkItemDTOs(responseHandler, args);
		},
		
        _onOK: function(){
			var items = this._reqTableViewer.getSelectedRows();
            this.onOK(items);
        },
		
		 _error: function(e){
			var alertDialog = new AlertDialog({'message': e.message});
    	    alertDialog.setSecondaryTitle(Constants.getMessage("labelError"));
        	alertDialog.open();
        }
    });
})();
