/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.table.BlockingPopUpDefectTableView");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

 dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.properties.DefectView");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rqm.defects.web.client.DefectsManager");
dojo.require("com.ibm.rqm.defects.web.ui.workitems.WorkItemSelectionDialog");
dojo.require("com.ibm.team.repository.web.foundation.NullProgressMonitor");
dojo.require("com.ibm.rqm.defects.web.ui.view.common.ProgressDialog");
dojo.require("com.ibm.rqm.defects.web.ui.utils.WindowUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");

(function() {

var TableConstants 	= com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var AlertDialog 	= com.ibm.asq.common.web.ui.internal.widgets.AlertDialog;
var Utility        	= com.ibm.rqm.execution.web.ui.internal.util.Utility;
var Constants      	= com.ibm.rqm.planning.web.client.internal.Constants;
var ImageCache		= com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var DEFECT_URL		= "#action=com.ibm.team.workitem.viewWorkItem&id=";
var DefectView		= com.ibm.rqm.planning.web.ui.internal.view.construction.properties.DefectView;//Need DV here since same table used in EWIListing
var getDefectsManager 				= com.ibm.rqm.defects.web.client.DefectsManager.getInstance;
var WorkItemSelectionDialog			= com.ibm.rqm.defects.web.ui.workitems.WorkItemSelectionDialog;
var NullProgressMonitor				= com.ibm.team.repository.web.foundation.NullProgressMonitor;
var ProgressDialog					= com.ibm.rqm.defects.web.ui.view.common.ProgressDialog;
var WindowUtil						= com.ibm.rqm.defects.web.ui.utils.WindowUtil;

dojo.declare("PopUpDefectTableView.TableListener", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
{
	constructor: function(view){
		this.parentView = view;
	},
    rowCheckStateChanged: function(tableViewer, rowObject, state){
		 var selectionCount = tableViewer.getCheckedRows().length;
        if (this.parentView.changeStatusActionNode){
			if(selectionCount != 1 || rowObject.statusId == 5)
            	this.parentView.changeStatusActionNode.setDisabled(true);
			else
				this.parentView.changeStatusActionNode.setDisabled(false);
		}
    },
    groupRowsCheckStateChanged: function(tableViewer, rowObjects, state){
        this.rowCheckStateChanged(tableViewer, rowObjects, state);
    },
    tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback){
		if (callback != null && dojo.isFunction(callback)) {
            if (callbackData != null) {
                callback(callbackData);
            } else {
                callback();
            }
        } 
    } 
});

dojo.declare("PopUpDefectTableView.TableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider,
{
    getNumColumns: function(content){
        return 4;
    },
    getColumnHeading: function(content, index){
        var headings = [
            Constants.getMessage("labelBlockingStatus"),
            Constants.getMessage("labelId"),
            Constants.getMessage("labelSummary"),
			Constants.getMessage("labelState")
        ];
        return headings[index];
    },
    getColumnHeadingImage: function(content, atColumnIndex){
        return null;
    },
    getColumnHeadingAlignment: function(atColumnIndex){
        return this.getCellAlignment(null, atColumnIndex);
    },
    getIsColumnGroupable: function(content, atColumnIndex){
        return false;
    },
    getIsColumnSortable: function(content, atColumnIndex){
        return false;   
    },
    getColumnWidth: function(content, atColumnIndex){
        switch(atColumnIndex) {
            case 0: 
                return 20;
            case 1: 
                return 15;
            case 2: 
                return 40;
            case 3: 
                return 25;		 
        }
        return 0;
    },
    getContentObjects: function(content){
        return content;
    },    
    getRowDataId: function(rowData){
        return "_table_row_for_defect_" + (rowData.reference ? rowData.reference : rowData.id);
    },
    getCellDisplayType: function(rowData, atColumnIndex){
        var type = TableConstants.RENDER_TYPE_TEXT;
        switch(atColumnIndex) {
            case 0: 
                type = TableConstants.RENDER_TYPE_IMAGE;
                break;
			case 1: 
                type = TableConstants.RENDER_TYPE_LINK;
                break;						 
        }
        return type;
    },
    getCellAlignment: function(rowData, atColumnIndex){
        if(atColumnIndex == 0)
            return TableConstants.ALIGN_CENTER;
        return TableConstants.ALIGN_LEFT;
    },
    getCellDisplayData: function(rowData, atColumnIndex){
        var val = "";
        switch(atColumnIndex) {
            case 0: 
                val = rowData.isBlocking;
                break;
            case 1: 
                val = rowData.id;
                break;
            case 2: 
                val = Utility._restoreTags(rowData.summary);
                break;   
            case 3: 
				val = rowData.status;
                break;  
        }
        return val;
    },
    getCellDisplayExtendedInfo: function(rowData, atColumnIndex){
        var val = null;  
        if (atColumnIndex == 0) {
           val = {};
			  val.image = rowData.isBlocking ? ImageCache.BLOCKING_DEFECT: ImageCache.NON_BLOCKING_DEFECT; 
			  val.tooltip = "";
		  }
		 if (atColumnIndex == 1) {
           val = {};
		   if(rowData.reference){
		   		val.onclick = dojo.hitch(this, function(){
					WindowUtil.openArtifactInNewWindow(rowData.reference);
				});
		   }
		   else if(this.popup && dojo.isFunction(this.popup._closePopupDialog)){
		   		val.onclick = dojo.hitch(this, function(){
					this.popup._closePopupDialog();					
					window.location.href = DEFECT_URL + rowData.id;
				});
		   }
		   else{
		   		val.href = DEFECT_URL + rowData.id; 
		   }
		  } 		  
        return val;
    }
});

dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.table.BlockingPopUpDefectTableView", 
    [dijit._Widget, dijit._Templated],
{    
    templateString: '<div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1">' +
						  '</div>',

    widgetsInTemplate: true,
    constructor: function() {
	 },

    postCreate: function() {
        this.inherited("postCreate", arguments);
        var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer();        
        this._tableViewerNode.appendChild(tableViewer.domNode);
		          
        var content = this.defects ? this.defects : [];
        tableViewer.setContentPageSize(5);
        tableViewer.setContent(content);
		var tableProvider = new PopUpDefectTableView.TableProvider();
		tableProvider.popup = this.parentEditor;
        tableViewer.setContentProvider(tableProvider);
        tableViewer.setTableListener(new PopUpDefectTableView.TableListener(this));
          
		tableViewer.setTableRowsCheckable(true, /* isSingleSelect */false);
		tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", Constants.getMessage("labelDefects")));
        tableViewer.show();
		this.actions = this.getTableActions();
		for (var i = 0; i < (this.actions ? this.actions.length : 0); i++) {
            var action = this.actions[i];
            var actionButton = tableViewer.addAction(action.actionId, action.label, null, action.iconClass, action.actionHandler);
            if (action.disabled && action.disabled == true)
                actionButton.setDisabled(true);
			if(action.actionId == "newdefect"){
				this.addNewActionNode = actionButton;
			}
			if(action.actionId == "adddefect"){
				this.addExistingActionNode = actionButton;
			}
			if(action.actionId == "changestatus"){
				this.changeStatusActionNode = actionButton;
			}	
        }
		this.tableViewer = tableViewer;
    },
	
	setContent: function(content){
		var newContent = content ? content : [];
		this.tableViewer.setContent(newContent);
		this.tableViewer.refresh();
		if(this._defectView){
			this._defectView.defectList = [];
		}
	},
	
	getContent: function(){
		return this.tableViewer.getContent();
	},
	
	getTableActions: function(){
		var actions = [];       
            actions.push({
                actionId: "newdefect",
                label: Constants.getMessage("labelAddNewDefect"),
                actionHandler: dojo.hitch(this, "onCreateNewDefect"),
                iconClass: "new-defect-icon-image",
				disabled: false                  
            });
            actions.push({
                actionId: "adddefect",
                label: Constants.getMessage("labelAddExistingDefect"),
                actionHandler: dojo.hitch(this, "onAddDefect"),
                iconClass: "add-defect-icon-image",
                disabled: false              
            });
			actions.push({
                actionId: "changestatus",
                label: Constants.getMessage("labelChangeStatus"),
                actionHandler: dojo.hitch(this, "onChangeStatus"),
                iconClass: "change-blocked-defect-status-icon-image",
                disabled: true              
            });
			return actions;
	},
	
	onCreateNewDefect: function(){
		this._defectIconClicked("new",Constants.getMessage("labelAddNewDefect"));
	},
	
	onAddDefect: function(){
		this._defectIconClicked("existing",Constants.getMessage("labelAddExistingDefect"));
	},
	
	_defectIconClicked: function(contextMenuSelection, title){
		var defectsManager= getDefectsManager();
		defectsManager.ensureInitialized(new NullProgressMonitor(), dojo.hitch(this, function(status) {
			var defectsProviders = defectsManager.getDefectsProviders();
			var currentProviderInstance = defectsManager.getDefectsProvider(defectsManager.getCurrentDefectsProviderId());
			if (currentProviderInstance != null && currentProviderInstance != undefined && currentProviderInstance.isConfigured()) {
				this._dispatchDefectActionViaProvider(contextMenuSelection);
			} else {
				this._defectIconClicked2(contextMenuSelection,title);
			}
		})); 
	},
	
	_dispatchDefectActionViaProvider: function(contextMenuSelection) {
		if (!contextMenuSelection || contextMenuSelection == "new") {
			this._addNewDefectViaProvider();
		} else if (contextMenuSelection == "existing") { 
			this._addExistingDefectViaProvider();
		} 
	},
	
	_addExistingDefectViaProvider: function() {
		var selectionDialog= WorkItemSelectionDialog.create(getDefectsManager(), "queryExistingDefects");

		this.connect(selectionDialog, "onOk", dojo.hitch(this, function(selection) { 
			var workItem= selection[0];
			
			var ewis = this.ewis;
			var counter = 0;
			var run = dojo.hitch(this, function(){
				if(counter == ewis.length){
					this.parentEditor.showDefects();
					return;
				}else{
					var addLinkParams= {
						ewiUri: this._getEwiUri(ewis[counter]) + "?runScript=" + ewis[counter].defaultScript.id,
						linkType: "com.ibm.team.workitem.linktype.relatedartifact",
						workItemId: workItem.id,
						workItemUri: workItem.reference,
						comment: (ewis[counter].name && ewis[counter].name != ewis[counter].testCase.name) ? Constants.getMessage("labelFailingTestCaseWithEWI", ewis[counter].testCase.name, ewis[counter].name) : Constants.getMessage("labelFailingTestCaseWithoutEWI", ewis[counter].testCase.name),
						label: workItem.label,
						isExecResultRelated: false
					};
					
					ProgressDialog.doRunWithProgress(Constants.getMessage("labelAssociateDefect"), dojo.hitch(this, function(monitor) {
						getDefectsManager().associateDefect("com.ibm.rqm.execution.linktype.ewiblockingdefect", addLinkParams, monitor, dojo.hitch(this, function(status, draftLinkParams){
							monitor.done();
							counter++;
							run();
						}));
					}));
				}
			});
			run();
		}));
	},
	
	_addNewDefectViaProvider: function() {
		var ewi = this.ewis[0];
		var ewis = this.ewis;
        var defectDescription = {
            summary: "",
            description: "",
            links: [],
			defectOriginItemId: "",
			isExecResultRelated: false
        };
        
        defectDescription["defectOriginItemId"] = ewi.itemId;
        
        // create the defect's draft summary, ...
        defectDescription["summary"] = Constants.getMessage("labelFailingRQMTestcase");
        
		var itemIdOrUriArray = [];
		for(var item in ewis){
			// ... and add a link to the EWI
	        defectDescription["links"].push({
	            type: "com.ibm.team.workitem.linktype.relatedartifact",
				uri:  this._getEwiUri(ewis[item]) + "?runScript=" + ewis[item].defaultScript.id,
	            comment: (ewis[item].name && ewis[item].name != ewis[item].testCase.name) ? Constants.getMessage("labelFailingTestCaseWithEWI", ewis[item].testCase.name, ewis[item].name) : Constants.getMessage("labelFailingTestCaseWithoutEWI", ewis[item].testCase.name)
	        });
			itemIdOrUriArray.push(ewis[item].itemId);
		}
		
		
        ProgressDialog.doRunWithProgress(Constants.getMessage("labelCreatedefect"), dojo.hitch(this, function(monitor){
            getDefectsManager().createDefect("com.ibm.rqm.execution.linktype.ewiblockingdefect", itemIdOrUriArray, defectDescription, monitor, dojo.hitch(this, function(status, draftItemUri, draftLinkParams){
                monitor.done();
                if (status.isOK()) {
                    WindowUtil.openArtifactInNewWindow(draftItemUri);
					this.parentEditor.showDefects();
                }
                else 
                    if (status.getSeverity() != Status.CANCEL) {
                        status.log();
                        this._displayAlertDialog(Constants.getMessage("labelUnableCreateWorkItem", status.getMessage()));
                    }
            }));
        }));
	},
	
	_getEwiUri: function(ewi) {
		var result= window.location.protocol + "//" + window.location.hostname + ":" + window.location.port;
		result+= window.location.pathname.match(/(.*)\/web\/console\/[^\/]*$/)[1];
		result+= "/resource/itemOid/com.ibm.rqm.execution.ExecutionWorkItem/" + ewi.itemId;
		return result;
	},
	
	_defectIconClicked2: function(contextMenuSelection, title){
		if(!this._defectView)
			this._defectView = new DefectView();
		this.addNewActionNode.setDisabled(true);
		this.addExistingActionNode.setDisabled(true);
		var dialogArgs = {
			primaryTitle: title,
            isClosable: true,
			showActions:false,
			style: "z-index: 999;",
			zIndex: 999,//keep below 1000 for datepicker to show
			onClose: dojo.hitch(this, function(){
				this.addNewActionNode.setDisabled(false);
				this.addExistingActionNode.setDisabled(false);
				//ELB
				if(dojo.isFunction(this.parentEditor._appendInDefectList)){
					this.parentEditor._appendInDefectList(this._defectView.defectList,contextMenuSelection);
				}
			})
		}
		this._defectView.setViewType(contextMenuSelection);
        this._defectsViewer = new com.ibm.asq.common.web.ui.internal.widgets._CommonDialog(dialogArgs);
		this._defectsViewer.blockerDiv.style.zIndex = 998;
		this._defectView.setParentDialog(this._defectsViewer);
		this._defectsViewer.contentContainer.appendChild(this._defectView.domNode);
		var self = this;
		this._defectsViewer._onClose = function(){
			if(dojo.isIE)
				self._defectsViewer.contentContainer.removeChild(self._defectView.domNode);
			this.destroy();
		}
		this._defectsViewer.open();
		this._defectsViewer.setWidth('800px');
	},
	
	onChangeStatus: function(){
		var defectsManager= getDefectsManager();
		defectsManager.ensureInitialized(new NullProgressMonitor(), dojo.hitch(this, function(status) {
			var defectsProviders = defectsManager.getDefectsProviders();
			var currentProviderInstance = defectsManager.getDefectsProvider(defectsManager.getCurrentDefectsProviderId());
			if (currentProviderInstance != null && currentProviderInstance != undefined && currentProviderInstance.isConfigured()) {
				this._unBlockDefectViaProvider();
			} else {
				this.onChangeStatus2();
			}
		})); 
	},
	
	_unBlockDefectViaProvider: function(){
		var defects = this.tableViewer.getCheckedRows();
		
		var ewis = this.ewis;
		var counter = 0;
		var run = dojo.hitch(this, function(){
			if(counter == ewis.length){
				this.parentEditor.showDefects();
				return;
			}else{
				ProgressDialog.doRunWithProgress(Constants.getMessage("labelUnBlockDefect"), dojo.hitch(this, function(monitor){
		            getDefectsManager().deleteDefect(defects[0].reference, ewis[counter].itemId, monitor, dojo.hitch(this, function(status, draftItemUri, draftLinkParams){
		                monitor.done();
		                if (status.isOK()) {
							counter++;
							run();
		                }
		                else 
		                    if (status.getSeverity() != Status.CANCEL) {
		                        status.log();
		                        this._displayAlertDialog(Constants.getMessage("labelUnableCreateWorkItem", status.getMessage()));
		                    }
		            }));
		        }));
			}
		});
		run();
	},
	
	onChangeStatus2: function(){
		var defects = this.tableViewer.getCheckedRows();
		var defect = defects[0];
		var blocking = true;
		if(defect.isBlocking)
			blocking = false;
		if(dojo.isFunction(this.parentEditor._updateDefectStatus)){
			this.parentEditor._updateDefectStatus(defect.id,blocking);
		}
	},
	
	getSelectedRows: function() {
	     return this.tableViewer.getCheckedRows();
 	},
	
	_displayAlertDialog: function(message){
        var alertDialog = new AlertDialog({
            'message': message
        });
        alertDialog.open();
    }
});
})();
