/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.table.cellrenderers.ProgressBarCellRenderer");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");

dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.progressbar.ProgressBar");

(function() {
var ProgressBar = com.ibm.rqm.execution.web.ui.internal.view.common.progressbar.ProgressBar;

dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.table.cellrenderers.ProgressBarCellRenderer", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellRenderer,
{    
    // Summary:
    //    Renders the ProgressBar,
    //  
	  
    renderCell: function(viewer, cellData, extendedDisplayInfo, /*table.CellModifier*/cellModifier, rowObject, columnIndex, cellWidthHint)
    {
        var node = document.createElement("div");
        var widthStyle = (cellWidthHint) ? cellWidthHint + "px" : "80%";
        
		if(viewer.getContentProvider().getIsConsoleNode() || (typeof extendedDisplayInfo['initialText'] == "undefined")){
			this.progressBar = new ProgressBar({width: widthStyle});
			node.appendChild(this.progressBar.domNode);
			if(!isNaN(parseInt(cellData, 10)))
				this.progressBar.update(cellData);
		}else {
			if(cellData && !isNaN(parseInt(cellData, 10)) && (parseInt(cellData, 10) > 0)){
				this.progressBar = new ProgressBar({width: widthStyle});
				node.appendChild(this.progressBar.domNode);
				if(!isNaN(parseInt(cellData, 10)))
					this.progressBar.update(cellData);
			}else{
				var	initialText = extendedDisplayInfo['initialText'];
				this.displayLabel = document.createTextNode(initialText);
				node.appendChild(this.displayLabel);
			}
		}	
		var anchor = document.createElement('a');
		anchor.href = "#";
		if (extendedDisplayInfo) {			
            if (typeof extendedDisplayInfo['href'] != "undefined") {
                anchor.href = extendedDisplayInfo['href'];
			} else if (dojo.isFunction(extendedDisplayInfo['onclick'])) {
				anchor.onclick = extendedDisplayInfo['onclick'];
			}
		}
		if(anchor.onclick || anchor.href != "#"){
			anchor.appendChild(node);
			return anchor;
		}else	
        	return node;
    },
	
	//Not useful right now, useful after we have async updates in place
	updateProgress: function(cellData){
		if(cellData){
			if(!isNaN(parseInt(cellData, 10)))
				this.progressBar.update(cellData);
		}
	}
});

})();
