/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.viewlets.TestScriptViewlet");

dojo.require("dojox.data.dom");

dojo.require("com.ibm.team.dashboard.web.ui.Viewlet");
dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ImageCache");
//xojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.TestScriptEditor");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorFactory");
dojo.require("com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.model.ArtifactModel");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function()
{
//var Utility					= com.ibm.rqm.planning.web.ui.internal.util.Utility;
var ImageCache				= com.ibm.rqm.planning.web.ui.internal.view.common.ImageCache;
var EditorFactory 			= com.ibm.rqm.planning.web.ui.internal.util.EditorFactory;
var Viewlet 				= com.ibm.team.dashboard.web.ui.Viewlet;
var TestScriptClient       	= com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient;
var ServiceResponseHandler	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var ArtifactModel           = com.ibm.rqm.planning.web.ui.internal.model.ArtifactModel;	
var Constants               = com.ibm.rqm.planning.web.client.internal.Constants;

var getAuthenticatedContributor = com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
	
dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.viewlets.TestScriptViewlet",	Viewlet,
{
	templateString: "<div class=\"\" dojoAttachPoint=\"_contentArea\"></div>", //dojo.moduleUrl("com.ibm.team.dashboard.viewlets.web", "ui/internal/templates/MembersViewlet.html"),
	
	refresh: function()
	{
		this._contentArea.innerHTML = "";
		this._hasZoomableContent = true;
		this.getSite().setLoading(true);

		var loading = document.createElement("div");
		loading.innerHTML = Constants.getMessage("labelLoading");
		loading.className = "loadingText";
		this._contentArea.appendChild(loading);

		this._update();
		//Need to set the isRefreshing on the container so that refreshing of the viewlet can occur,
		//otherwise it can only happen once.
		this.container.isRefreshing = 0;
	},

	getEditorFactory: function() {
		return EditorFactory;
	},

	_update: function()
	{
		dojox.data.dom.removeChildren(this._contentArea);

		var artifactModel = new ArtifactModel(Constants.TYPE_SCRIPT);
		this.editor = new com.ibm.rqm.planning.web.ui.internal.view.construction.TestScriptEditor();
		this.editor.setArtifactModel(artifactModel);
		this._contentArea.appendChild(this.editor.domNode);
		this.editor.initialize({ parentController: this, testScript: this._testScript });

		this.getSite().setLoading(false);
	},

	artifactSelected: function(obj)
	{
		dojox.data.dom.removeChildren(this._contentArea);
		this.getSite().setLoading(true);

		var loading = document.createElement("div");
		loading.innerHTML = Constants.getMessage("labelLoading");
		loading.className = "loadingText";
		this._contentArea.appendChild(loading);

		var responseHandler = new ServiceResponseHandler(this, "_doViewTestScript", "_error");			
		TestScriptClient.getTestScript(responseHandler, obj.id);
	},
			
	_doViewTestScript: function(result) 
	{
		if ( dojo.isArray(result) ) 
		{
			result = result[0];	
		}
		this._testScript = result;
		this._update();				
	},
	
	_error: function(errorObj)
	{
		alert("Error getting data (message: '" + errorObj.message + "') in TestScriptViewlet#_error");
	},
	
	hasZoomableContent: function() {
//		if (this._count && this._count > 10)
			return true;
//		return false;
	},
	
	settingsChanged: function(oldSettings, newSettings) {
		alert("in settingsChanged function");
/*		if (newSettings.scope != oldSettings.scope || newSettings.scopeItemId != oldSettings.scopeItemId ||
			(newSettings.scope == DashboardConstants.SCOPE_TEAM_AREA && newSettings.scopeSubteams != oldSettings.scopeSubteams))
			this.refresh();
		else
			this._update();
*/
	}
});

})();
