/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
//

//
//
// Author: P. Chu
//
// Summary:
//    
//
dojo.provide("com.ibm.rational.test.lm.web.ui.internal.views.machines.ManageGroupsView");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.form.Button");

dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility")
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.team.repository.web.client.init.InitializationData");
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");

dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ListRowRenderer");

dojo.require("com.ibm.rational.test.lm.web.client.internal.group");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.pages.AssetUriUtil");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.pages.GroupUtil");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil");

dojo.require("com.ibm.rational.test.lm.web.ui.internal.pages.InventoryUriUtil");
dojo.require("com.ibm.rational.test.lm.web.client.internal.inventory");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");

(function() {

var RtlmUiUtil = com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil;
var InitializationData = com.ibm.team.repository.web.client.init.InitializationData;
var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var TableConstants = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var AssetUriUtil = com.ibm.rational.test.lm.web.ui.internal.pages.AssetUriUtil;
var InventoryUriUtil = com.ibm.rational.test.lm.web.ui.internal.pages.InventoryUriUtil;
var GlobalEvents = com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
var LOADING = RtlmUiUtil.getMessage("appWorking");
var PermissionsClient = com.ibm.asq.common.web.client.internal.PermissionsClient;
var ImageCache = com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var ViewHeaderLayout = com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;

dojo.declare("com.ibm.rational.test.lm.web.ui.internal.views.machines.ManageGroupsView", 
    [dijit._Widget, dijit._Templated],
{    
    templateString: '<div class="manage-groups-view" dojoAttachPoint="domNode" tabindex="-1">' +
                    '  <div dojoType="com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout" dojoAttachPoint="viewHeaderNode" noline="true">' +
                    '    <div class="groups-area-container">' +
                    '      <div dojoAttachPoint="groupsArea" class="groups-area"></div>' +
                    '    </div>' +
                    '  </div>' +
                    '</div>',

    widgetsInTemplate: true,
	newButtonLabel: RtlmUiUtil.getMessage("labelCreateButton"),
	refreshButtonLabel: RtlmUiUtil.getMessage("labelRefreshButton"),
	deleteButtonLabel: RtlmUiUtil.getMessage("labelDeleteButton"),
	automateButtonLabel: RtlmUiUtil.getMessage("Automate"),
	
    refreshActionNode: null,
    deleteActionNode: null,
    automateActionNode: null,

    groupService: null,
    
    // the groups displayed in this view
    groups: null,
    
    showAll: false,
            
    // the table to display the groups
    groupsTable: null,
    
    groupTableArgs: null,
    
    postCreate: function() {
        // set title and subtitle
        this.inherited("postCreate", arguments);
        this.viewHeaderNode.setTitle(RtlmUiUtil.getMessage("labelGroupType"));
        this.viewHeaderNode.setCSHelpId("rtlm_groups.html", com.ibm.rational.test.lm.web.CSHelpID);
        this.viewHeaderNode.setCSHelpButtonLabel(RtlmUiUtil.getMessage("labelHelp", "", RtlmUiUtil.getMessage("labelGroupType")));
		        
        this.groupService = new com.ibm.rational.test.lm.web.client.internal.group();
        
        // create the table to display the groups
        this.tableViewer = this.createTableViewer(this);
        
        var query = [
            {'name': RtlmUiUtil.getMessage("labelMyGroups"), 'value': 0},
            {'name': RtlmUiUtil.getMessage("labelAllGroups"), 'value': 1}
        ];
        if (this._hasGroupEditPermission()) {
            // lab manager will show a disabled selector but we want to show "All Groups"
            query = [ {'name': RtlmUiUtil.getMessage("labelAllGroups"), 'value': 1} ];
        }
        this.tableViewer.setTableContentSelectors(query);
        
        this.refreshActionNode = this.tableViewer.addAction(
                this.refreshButtonLabel,       // action id
                this.refreshButtonLabel,       // label
                null,                          // callback data
                "refresh-icon-image",          // icon class
                dojo.hitch(this, "refresh"));  // callback

        this.automateActionNode = this.tableViewer.addAction(
                this.automateButtonLabel,                    // action id
                this.automateButtonLabel,                    // label
                null,                                        // callback data
                "configure-automation-icon-image",           // icon class
                dojo.hitch(this, "_onAutomateActionClick")); // callback
        this.automateActionNode.setDisabled(true);

        if (this._hasGroupCreatePermission()) {
            this.deleteActionNode = this.tableViewer.addAction(
                    this.deleteButtonLabel,                    // action id
                    this.deleteButtonLabel,                    // label
                    null,                                      // callback data
                    "delete-property",                         // icon class
                    dojo.hitch(this, "_onDeleteActionClick")); // callback
            this.deleteActionNode.setDisabled(true);
            
            // don't need to use show selector for "My Groups" or "All Groups" for lab manager
            this.tableViewer.contentSelect.disabled = true;
        }
        this.groupsArea.appendChild(this.tableViewer.domNode);
        
        // load group data into table
        this._loadGroups();
    },
    
	createTableViewer: function(view) {
        var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
            allowAdjustSettings: true,
            autoSaveSettings: true,
            tableId: "RQM-LM-GROUP-TABLEVIEWER"                         
        });
        tableViewer.setContentProvider(new GroupsTable.TableProvider());
        tableViewer.setCellModifier(new GroupsTable.CellModifier(view));
        tableViewer.setContentPageSize(15);
        tableViewer.setTableRowsCheckable(true);
		tableViewer.setTableListener(new GroupsTable.TableListener(view));
		tableViewer.registerCellRenderer(TableConstants.RENDER_TYPE_DATE, new GroupsTable.DateCellRenderer());
		tableViewer.setTableSummary(RtlmUiUtil.getMessage("labelTableSummary", RtlmUiUtil.getMessage("labelGroupType")));
		return tableViewer;
	},
	
	setStatus: function(message, state) {
		if (message) {
            this.viewHeaderNode.setStatus(message, state ? state : ViewHeaderLayout.INFO);
		}
	},
	
	clearStatus: function() {
        this.viewHeaderNode.clearStatus();
	},

	refresh: function() {
        this._loadGroups();
        this.clearStatus();
		GroupUtil.setGroupsListValid(true);
	},
	
    _loadGroups: function() {
        if (this.deleteActionNode) {
            // delete action is not available for non-lab manager
            this.deleteActionNode.setDisabled(true);
        }
		this.automateActionNode.setDisabled( true );
        var responseHandler = new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_loadSuccess", "_loadFailure");
        this.viewHeaderNode.setProgressStart(LOADING);
        GroupUtil.refresh(responseHandler);
    },
    
    _loadSuccess: function(response) {
        this.viewHeaderNode.setProgressEnd();
        this.groups = this.showAll ? GroupUtil.getAllGroups() : GroupUtil.getGroups();
        this._displayGroups();
    },
    
    _loadFailure: function(response) {
        this.viewHeaderNode.setProgressEnd();
        this.viewHeaderNode.setStatus(RtlmUiUtil.getMessage("errLoadGroupInfo"), ViewHeaderLayout.ERROR);    
    },
    
    _displayGroups: function() {
        this.tableViewer.setContent(this.groups);
        this.tableViewer.show();
    },
        
	_deleteGroupCount: 0,
	
	_onDeleteActionClick: function() {
        var args = {
            'message': RtlmUiUtil.getMessage("confirmRemoveGroup"),
            'yesCallback': 
                function(view) {
                    view._deleteAction();
                },
            'yesCallbackData': this,
            'noCallback': null,
            'noCallbackData': null
        };
        var confirmDialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog(args);
        confirmDialog.setSecondaryTitle(RtlmUiUtil.getMessage("msgConfirmTitle"));
        confirmDialog.open();
    },
    
    _deleteAction: function() {			
		var selectedGroups = this.tableViewer.getCheckedRows();
        this.deleteActionNode.setDisabled(true);
        this._selectedGroupCount = selectedGroups.length;
        this._errorGroupCount = 0;
		this._deleteGroupCount = 0;
		if (selectedGroups.length > 0) {
			for (var i = 0; i < selectedGroups.length; i++) {
				this.deleteGroup(selectedGroups[i]);
			}
		}
	},
	
    deleteGroup: function(group) {
        var responseHandler = new ServiceResponseHandler(this, "_deleteSuccess", "_deleteFailure");
        this.groupService.deleteGroup(responseHandler, group.itemId);
        this.viewHeaderNode.setProgressStart(RtlmUiUtil.getMessage("msgRemovingGroups", group.name));
    },

    _deleteSuccess: function(response) {
        this.viewHeaderNode.setStatus(RtlmUiUtil.getMessage("msgRemoveOneGroupSuccess"), ViewHeaderLayout.SUCCESS);
		this._deleteGroupCount++;
        this._setDeleteStatus();
    },
    
    _deleteFailure: function(err) {
        if(err && err.message && err.message.toLowerCase().indexOf('license') > -1) {
            RtlmUiUtil.showServerErrorMessage(MessageUtil.getMessage(MessageBundle.COMMON, "serverLicenseErrMsg"));                  
        }
        this.viewHeaderNode.setStatus(RtlmUiUtil.getMessage("errRemoveGroup"), ViewHeaderLayout.ERROR);
        this._errorGroupCount++;
        this._setDeleteStatus();
    },

    _setDeleteStatus: function() {
        if ((this._deleteGroupCount + this._errorGroupCount) == this._selectedGroupCount) {
            if (this._selectedGroupCount > 1) {
                this.viewHeaderNode.setStatus(
                    RtlmUiUtil.getMessage("msgRemoveGroupsSuccess", this._deleteGroupCount, this._selectedGroupCount),
                    (this._errorGroupCount == 0) ? ViewHeaderLayout.SUCCESS : ((this._selectedGroupCount == 1) ? ViewHeaderLayout.ERROR : ViewHeaderLayout.INFO)
                );
            }
            if (this._deleteGroupCount > 0) {
                // notify all tabs (including itself) that groups are deleted
                dojo.publish(GlobalEvents.ArtifactsDeleted, [RtlmUiUtil.TYPE_GROUP, this.tableViewer.getCheckedRows()]);
            }
        }
    },
    
	_mapTeamAreaName: function(teamAreaId) {
		return teamAreaId;
	},
	
	_onAutomateActionClick: function()
	{
		var selectedGroups = this.tableViewer.getCheckedRows();
		var groupsvc = new com.ibm.rational.test.lm.web.client.internal.group();
		var results = { "Data": [], "Header": ["machine.id", "machine.name"] };
		var numresults = 0;
		
		for( var iGroup = 0; iGroup < selectedGroups.length; iGroup++ )
		{
				var innerHandler = new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper
				(
					{
						parent: this,
						_success: function( response )
						{
							
							for( var iData = 0; iData < response[ "Data" ].length; iData++ )
							{		
								var id = response[ "Data" ][ iData ][ 0 ];
								var name = response[ "Data" ][ iData ][ 1 ];
								if( this.parent.automatable && 
									this.parent.automatable[ id ] )
								{							
									results.Data.push( [ id , name ]);
										
								}
							}
							
							numresults++;
														
							if( numresults == selectedGroups.length )
							{
								dojo.setObject( "com.ibm.rational.test.lm.web.machines", results );
								window.location.href = InventoryUriUtil.getAutomationsURI();
							}
						},
						_failure: function( errObj )
						{
							this.parent.automatable = {};
						}
					},
					"_success",
					"_failure"
				);
				// Only search machines
				var _catalog = new com.ibm.asq.common.web.client.internal.Catalog();
				var config = _catalog.createConfiguration("Machine");
				
			groupsvc.searchForAssetsInGroup( innerHandler, selectedGroups[ iGroup ].itemId, "machine.id, machine.name", config);
		}
	},

    _hasGroupCreatePermission: function()
    {
        var perm = PermissionsClient.getStoredPermission(PermissionsClient.OP_LM_RESOURCE_GROUP);
        return (!perm || perm[PermissionsClient.ACTION_CREATE]);           
    },
	
    _hasGroupEditPermission: function()
    {
        var perm = PermissionsClient.getStoredPermission(PermissionsClient.OP_LM_RESOURCE_GROUP);
        return (!perm || perm[PermissionsClient.ACTION_EDIT]);           
    },
    
    // handler on artifacts changed
    onArtifactChanged: function(changeType, artifactType, artifactArray) {
        // only care about groups
        if (artifactType == RtlmUiUtil.TYPE_GROUP) {
            // there is local cache in GroupUtil so not just update the table content
            this.refresh();
        }
    }
});

dojo.declare("com.ibm.rational.test.lm.web.ui.internal.views.machines.ManageGroupsView.selectGroupDialog", null,
{
    _selectGroupDialog: null,
    _selectGroupDialogViewer: null,

    constructor: function() {
    },
    
    selectGroup: function(callbackHandler, callbackData) {
        
        // create dialog content
        this._selectGroupDialogViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer();
        // use table provider with disabled links
        this._selectGroupDialogViewer.setContentProvider(new GroupsTable.TableProvider(true));
        // set checkable to single selection only
        this._selectGroupDialogViewer.setTableRowsCheckable(true, true);
        this._selectGroupDialogViewer.setContentPageSize(15);
        this._selectGroupDialogViewer.registerCellRenderer(TableConstants.RENDER_TYPE_DATE, new GroupsTable.DateCellRenderer());

        var args = {
                       okCallback: callbackHandler,
                       okCallbackData: callbackData,
                       selectionHandler: dojo.hitch(this, "_getSelectGroup")
                   };
        this._selectGroupDialog = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(args);
        this._selectGroupDialog.contentContainer.appendChild(this._selectGroupDialogViewer.domNode);
        this._selectGroupDialog.setTitle("Select Group");
        this._selectGroupDialogViewer.setContent(GroupUtil.getGroups());
        this._selectGroupDialogViewer.setTableListener(new SelectGroupDialogViewer.TableListener(this._selectGroupDialog));
        this._selectGroupDialogViewer.show();
        
        this._selectGroupDialog.open();
    },

    _getSelectGroup: function() {
        var groupId = null;
        if (this._selectGroupDialogViewer.getCheckedRows().length > 0) {
            groupId = this._selectGroupDialogViewer.getCheckedRows()[0].id;
        }
        return groupId;
    }
    
});

dojo.declare("GroupsTable.TableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider,
{
    _disableLinks: true,
	
	constructor: function(disableLinks) {
        this._disableLinks = disableLinks;
	},
	
    getNumColumns: function(content) {
        return 6;
    },
	
    getColumnHeading: function(content, atColumnIndex) {
        var headings = [
			"",
            RtlmUiUtil.getMessage("labelHeaderGroupName"),
            RtlmUiUtil.getMessage("labelHeaderDescription"),
            RtlmUiUtil.getMessage("labelHeaderStartDate"),
            RtlmUiUtil.getMessage("labelHeaderExpirationDate"),
			RtlmUiUtil.getMessage("labelHeaderTeamArea")
        ];
        return headings[atColumnIndex];
    },

    getColumnHeadingImage: function(content, atColumnIndex) {
        return null;
    },
    
    getIsColumnGroupable: function(content, atColumnIndex) {
		// groupable by column 6, team area
        return atColumnIndex == 5;     
    },

    getIsColumnSortable: function(content, atColumnIndex) {
		return true;
    },
    
    getColumnWidth: function(content, atColumnIndex) {
        var columnWidth = [
			4,
            20, // "Group Name",
            34, // "Description",
            12, // "Starting Date",
            12, // "Expiration Date",
			18  // "Team"
        ];
        return columnWidth[atColumnIndex];
    },
    
    getContentObjects: function(content) {
        // the groups data is already an array
        return content;
    },
    
    getRowDataId: function(rowData) {
        return rowData.itemId;
    },

    getCellDisplayType: function(rowData, atColumnIndex) {
        var types = [
            TableConstants.RENDER_TYPE_IMAGE,  // Group Image
            TableConstants.RENDER_TYPE_LINK, // "Group Name",
            TableConstants.RENDER_TYPE_TEXT,   // "Description",
            TableConstants.RENDER_TYPE_DATE,   // "Starting",
            TableConstants.RENDER_TYPE_DATE,   // "Expiration",
			TableConstants.RENDER_TYPE_TEXT    // "Team Area"
        ];
        if ((atColumnIndex == 1) && this._disableLinks) {
            return TableConstants.RENDER_TYPE_TEXT;
        }
		return types[atColumnIndex];
    },
    
    getCellDisplayData: function(rowData, atColumnIndex) {
        switch(atColumnIndex) {
            case 0: // Group Name
                return "";
            case 1: // Group Name
                return rowData.name;
            case 2: // "Description"
                return rowData.description;
            case 3: // "Starting Date"
                return rowData.startDate;
            case 4: // "Expiration Date"
                return rowData.expirable ? rowData.expirationDate : -1;
            case 5: // "TeamArea"
                return GroupUtil.getTeamAreaName(rowData.teamArea);
        }
		return "";
    },
	
	getCellDisplayExtendedInfo: function(rowData, atColumnIndex)
    {  
        var val = null;
        if(atColumnIndex == 0 || atColumnIndex == 1) {
            val = {};
			val.image = ImageCache.MACHINEGROUP;
			val.href = AssetUriUtil.getGroupDetailURI(rowData.itemId);
        }
        return val;
    }       
});

dojo.declare("GroupsTable.CellModifier", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier,
{
	_groupView: null,
	
	constructor: function(groupView) {
		this._groupView = groupView;
	},
	
    cellValueChanged: function(oldValue, newValue, rowObject, columnIndex) {
    },
    
    cellActionInvoked: function(rowObject, columnIndex) {
        if (columnIndex == 0 || columnIndex == 1) { // Group Name
            window.location.href = AssetUriUtil.getGroupDetailURI(rowObject.itemId);
		}
    }
});

dojo.declare("GroupsTable.ListRowRenderer",
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ListRowRenderer,
{    
    renderRow: function(viewer, rowObject, trNode)
    {
        var provider = viewer.getContentProvider();
        var td = trNode.insertCell(trNode.cells.length);
        var listWidget = this._createListWidget(viewer, rowObject);
        
        td.colspan = provider.getNumColumns();
		td.width="100%";
        td.appendChild(listWidget.domNode);
    },
	
    _createListWidget: function(viewer, rowObject) {
        var provider = viewer.getContentProvider();
        var isOpen = this._getRowDisplayState(provider, rowObject);
        var node = new com.ibm.asq.common.web.ui.internal.view.common.SimpleCollapsibleArea();
        
        // create the contents in the list widget.
        this._createListContents(viewer, rowObject, node);
        
        node.data = rowObject;
        node.provider = provider;
        node.onToggle = dojo.hitch(this, "_rowWidgetToggled");
        return node;
    },

    _createListContents: function(viewer, rowObject, listWidget)
    {
        var provider = viewer.getContentProvider();
        var isOpen = this._getRowDisplayState(provider, rowObject);

		listWidget.setTitle("Simple");
//		listWidget.headerRightNode.innerHTML = "Right!?";
        var innerContent = document.createElement("div");
        innerContent.innerHTML = "Content here";
        listWidget.containerNode.appendChild(innerContent);
    }
});

dojo.declare("GroupsTable.TableListener",
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
{    
	_groupView: null,
	
	constructor: function(groupView) {
		this._groupView = groupView;
	},
	
    _checkGroupMachinesAutomatePermission: function(machines)
    {
        var autoPermCol = -1;
        
        if(machines.Header) {
            for(var i = 0; i < machines.Header.length; i++) {
                if(machines.Header[i] == "canAutomate") {
                    autoPermCol = i;
                    break;
                }
            }
        }  
        if(autoPermCol > -1) {
            for(var i = 0; i < machines.Data.length; i++) {
                var row = machines.Data[i];
                if(row.length > autoPermCol && row[autoPermCol] == false) {
                    return false;
                }
            }
        }
        return true;
    },
    
    rowCheckStateChanged: function(tableViewer, rowObject, state) {
		this._groupView.deleteActionNode.setDisabled( tableViewer.getCheckedRows().length == 0 );
		
		var rows = tableViewer.getCheckedRows();
		if( rows.length > 0 )
		{
			this._groupView.automatable = {};
			var groupsvc = new com.ibm.rational.test.lm.web.client.internal.group();
			for( var iGroup = 0; iGroup < rows.length; iGroup++ )
			{
					var innerHandler = new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper
					(
						{
							parent: this,
							_success: function( response )
							{
								var automation = new com.ibm.rational.test.lm.web.client.internal.inventory();
								
                                // if the current user doesn't even have permission to run
                                // automation, don't even have to bother to check whether
                                // the machines are automatable.
                                //
                                if(!this.parent._checkGroupMachinesAutomatePermission(response)) {
                                    this.parent._groupView.automateActionNode.setDisabled( false );
                                    return;
                                }
                                
								for( var iData = 0; iData < response[ "Data" ].length; iData++ )
								{
                                    var machineId = response[ "Data" ][ iData ][ 0 ];
									var automationHandler = new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper
									(
										{
											id: machineId,
											parent: this.parent,
											_success: function( autoresult )
											{
												if( autoresult && ( autoresult.length > 0 ) )
												{
													this.parent._groupView.automatable[ this.id ] = true;
													this.parent._groupView.automateActionNode.setDisabled( false );
												}													
											},
											_failure: function( errObj )
											{
												this.parent._groupView.automatable = {};
											}
										},
										"_success",
										"_failure"
									);
                                    
									automation.getAutomationsForAsset(  automationHandler, machineId );								
								}
							},
							_failure: function( errObj )
							{
								this.parent._groupView.automatable = {};
							}
						},
						"_success",
						"_failure"
					);
				groupsvc.searchForAllAssetsInGroup( innerHandler, rows[ iGroup ].itemId, "machine.id" );
			}
		}
		else
		{
			this._groupView.automateActionNode.setDisabled( true );
		}
	},

    tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback) {
        callback(callbackData);
    },

    tableContentSelectionChanged: function(tableViewer, contentSelectionValue) {
        this._groupView.showAll = parseInt(contentSelectionValue) == 1;
        this.groups = this._groupView.showAll ? GroupUtil.getAllGroups() : GroupUtil.getGroups();
        tableViewer.setContent(this.groups);
        tableViewer.show();
    }
});

dojo.declare("SelectGroupDialogViewer.TableListener",
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
{    
    _dialog: null,
    
    constructor: function(dialog) {
        this._dialog = dialog;
    },
    
    rowCheckStateChanged: function(tableViewer, rowObject, state) {
        this._dialog.getOkButton().disabled = tableViewer.getCheckedRows().length == 0;
    }
});

dojo.declare("GroupsTable.DateCellRenderer",
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellRenderer,
{
    renderCell: function(viewer, cellData, extendedDisplayInfo, cellModifier, rowObject, columnIndex, cellWidthHint) {
        var span = document.createElement("span");
        var text;
        
        if (!cellData)
            text = "";
		else if (cellData == -1)
			text = "n/a";
        else if (cellData instanceof Date)
			text = com.ibm.asq.common.web.ui.internal.util.Utility.formatDate(cellData);
		else
			text = cellData;
        
        this._renderCellText(viewer, text, extendedDisplayInfo, span, cellWidthHint);
        return span;
    }
});

})();
