/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rational.test.lm.web.ui.internal.views.viewlets.OfflineMachinesViewlet");

dojo.require("com.ibm.team.dashboard.web.ui.Viewlet");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil");
dojo.require("com.ibm.asq.common.web.client.internal.Catalog");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.providers.MachineTableProvider");

(function() 
{
var RtlmUiUtil = com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil;
	
dojo.declare("com.ibm.rational.test.lm.web.ui.internal.views.viewlets.OfflineMachinesViewlet", 
      com.ibm.team.dashboard.web.ui.Viewlet, 
{	
    templateString: '<div id="${id}" dojoAttachPoint="domNode">' +
            '   <table width="100%" cellpadding="12"> '+
            '       <tr> '+
            '           <td> '+
            '               <!-- table resultarea --> '+
            '               <div dojoAttachPoint="offlineMachinesViewletContent" '+
            '               </div> '+
            '           </td> '+
            '       </tr> '+
            '   </table> '+
            '</div>',		
	
	assetType: "Machine",
	
	/*
     * Called by the framework after the viewlet is instantiated, but before the
     * first refresh. Viewlets that need to initialize themselves shoudl override.
     */
    init: function() {
        this._createTable();
    },
    
    /*
     * Public Method
     * 
     * Refreshes the viewlet content.
     * 
     * @param <none>
     * @return <none>
     */ 
    refresh: function() {
        this.runQuery();
		//Need to set the isRefreshing on the container so that refreshing of the viewlet can occur,
		//otherwise it can only happen once.
		this.container.isRefreshing = 0;
    },
    
    /*
     * Repopulates the viewlet. New content should not be retrieved from the server.
     * Called when presentation of the viewlet is changed in some way, but new information
     * is not required.
     * 
     * Viewlets should override.
     */
    _update: function() {
        this.runQuery();
    },
	
	_createTable: function() {
		this.resultTable = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
            allowAdjustSettings: true,
            autoSaveSettings: true,
            tableId: "RQM-LM-OFFLINE-ASSET-TABLEVIEWLET"                          
        });
		this.resultTable.setContentProvider( new com.ibm.rational.test.lm.web.ui.internal.views.providers.MachineTableProvider(	this.assetType ) );
		this.resultTable.setTableSummary(RtlmUiUtil.getMessage("labelTableSummary", RtlmUiUtil.getMessage("labelOfflineMachines")));
			
		this.resultTable.setContentPageSize( 20 );
																																		
		this.offlineMachinesViewletContent.appendChild( this.resultTable.domNode );
																																		
		this.resultTable.setContent( { 'Data': [], 'Header' : [] } );
        this.resultTable.show();        
	},
	
	runQuery: function() 
    {	        
        var catalog = new com.ibm.asq.common.web.client.internal.Catalog();
        this.config = catalog.createConfiguration(this.assetType); 
		this.config.getRoot().setAttributeValue("Operational Status", "Unavailable");
                
        var responseHandler = new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_searchSuccess", "_searchError");                
        var searchParam = { configuration: this.config,
                            columns: ( com.ibm.rational.test.lm.web.ui.internal.views.providers.MachineInfo.getSearchAttributeCriteria()[ this.assetType ] ) };
		catalog.search(responseHandler, searchParam);
    },
	
	_searchSuccess: function( response )
    {
		this.resultTable.setContent( response );
        this.resultTable.show();        
    },
    
    _searchError: function( message, error )
    {
    }
});

})();
