/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.LinkCellRenderer");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");

(function() {

dojo.declare("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.LinkCellRenderer", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellRenderer,
{    
    // Summary:
    //    Renders the cell content. 
    //    
    renderCell: function(viewer, cellData, extendedDisplayInfo, cellModifier, rowObject, columnIndex, cellWidthHint)
    {
		var linkExtHTML = null;
        
		//Fix wi 7584, add link type info
		if (extendedDisplayInfo) {			
            if (typeof extendedDisplayInfo['linkType'] != "undefined") {
				linkExtHTML = "<span style='left:-3000px; position:absolute; display:inline;'>" + extendedDisplayInfo['linkType'] + "</span>";
			} 
		}
		
        // empty link. Cannot be clicked. Just create a text node.
        if(cellData == null || dojo.isString(cellData) && cellData.length == 0) {
            return document.createTextNode(" ");
        }
        
        var node = document.createElement("a");
        var text = cellData;

        if (viewer.isCompactMode && typeof cellWidthHint != "undefined" && dojo.isString(cellData)) {
            text = this._handleCompactCellText(viewer, text, extendedDisplayInfo, node, cellWidthHint);
        }
        else if (extendedDisplayInfo && dojo.isObject(extendedDisplayInfo)) {
            this._attachTooltipToCell(node, extendedDisplayInfo['tooltip']);
        }    
        var textNode = document.createTextNode(text);
        
        if(linkExtHTML)
            node.innerHTML = linkExtHTML; 

        node.appendChild(textNode);
        
        if (extendedDisplayInfo) {			
            if (typeof extendedDisplayInfo['href'] != "undefined") {
                node.href = extendedDisplayInfo['href'];
			} 
            else if (dojo.isFunction(extendedDisplayInfo['onclick'])) {
				node.onclick = extendedDisplayInfo['onclick'];
			}
		}
        return node;
    }
});

})();
