/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
 // Summary:
 //    A TableListener is a client implement interface that receives event notification
 //    from the TableViewer. The TableViewer reports back events to its client when certain
 //    events occurred in the table through this interface class's methods.
 //
dojo.provide("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener");

(function() {

dojo.declare("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener", null,
{
    // Summary:
    //   If the table's rows are checkable, when a row is checked, or unchecked, this method is
    //   called.
    //
    rowCheckStateChanged: function(tableViewer, rowObject, state)
    {
        
    },
    
    // Summary:
    //    A group check box is shown when the tables rows are checkable and the in multi-select mode.
    //    This method is called when the group's check box is checked/unchecked. The affected rows and 
    //    their states are passed.
    //
    groupRowsCheckStateChanged: function(tableViewer, rowObjects, state) 
    {
        
    },
    
    // Summary:
    //    If the client registered content selectors with the table viewer, this message will be fired
    //    when the user changed the content selection.
    //
    tableContentSelectionChanged: function(tableViewer, contentSelectionValue)
    {
        
    },
    
    // Summary:
    //    If the client have registered table actions, this message will be fired when an action (button)
    //    is invoked by the user. Additionally, when the action is registered, the client can optionally
    //    provide a callbackData and a callback to be passed. These two additional pieces of data is also
    //    passed.
    //
    tableContentActionInvoked: function(tableViewer, actionId, /*optional*/callbackData, /*optional*/callback)
    {
        
    },
    
    // Summary:
    //    If the client have specified a header image and specified that it's an action (see TableContentProvider 
    //    for details), when the column's image is clicked, this message is invoked.
    //
    tableHeaderColumnActionInvoked: function(tableViewer, columnIndex, /*optional*/actionId)
    {
        
    },
    
    // Summary:
    //    If the client have registered a TableContentFilterProvider and has created actions, this message 
    //    will be fired when a filter area action is invoked by the user. Additionally, when the action is 
    //    registered, the client can optionally provide a callbackData and a callback to be passed. These two 
    //    additional pieces of data is also passed.
    //
    tableContentFilterActionInvoked: function(tableViewer, actionId, filters, /*optional*/callback, /*optional*/callbackData)
    {
        
    }
    
});

})();
