/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rqm.defects.web.ui.view.common.ProgressDialog");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.ProgressBar")

dojo.require("com.ibm.team.repository.web.foundation.ProgressMonitor");

dojo.require("dojox.data.dom");

dojo.require("net.jazz.ajax.ui.internal.Dialog");

dojo.require("com.ibm.rqm.defects.web.ui.utils.DefectsUIUtil");

(function() {
	
var DefectsUIUtil = com.ibm.rqm.defects.web.ui.utils.DefectsUIUtil;

dojo.declare("com.ibm.rqm.defects.web.ui.view.common.ProgressDialog",
			 [dijit._Widget, dijit._Templated], {
	labelCancel: DefectsUIUtil.getMessage("labelCancel"),

	// ---- constructor mixed-in properties --------------------------------------------------------------------------------	

	_dialogRoot: null,
	_progressBar: null,
	_progressMessage: null,
	_cancelButton: null,

	_progressBarWidget: null,

	_monitor: null,
	
	_width: "30em",
	_height: "10em",
	_title: "Progress",
	
	constructor: function() {
	},
	
	// ---- api ------------------------------------------------------------------------------------------------------------	

	runWithProgress: function(progressMonitoredCode) {
		this._monitor= new com.ibm.rqm.defects.web.ui.view.common.ProgressDialog._ProgressMonitor(this);
		progressMonitoredCode(this._monitor);
	},

	// ---- widget implementation ------------------------------------------------------------------------------------------

	templatePath: dojo.moduleUrl("com.ibm.rqm.defects.web", "ui/view/common/templates/ProgressDialog.html"),

	postCreate: function() {
		this._progressBarWidget= new dijit.ProgressBar({}, this._progressBar);
		this._progressBarWidget.update({indeterminate: true});
		
		this._dialog = new net.jazz.ajax.ui.internal.Dialog({
			contentNode: this._dialogRoot,
			primaryTitle: this._title,
			width: this._width,
			isClosable: false
		});
		
		this.connect(this._cancelButton, "onclick", "_onCancel");
	},

	// ---- implementation -------------------------------------------------------------------------------------------------

	_onCancel: function() {
		this._monitor.setCancelled();
		this._dialog.close();
	},

	_notifyBeginTask: function(name) {
		dojox.data.dom.replaceChildren(this._progressMessage, document.createTextNode(name));
	},

	_notifyDone: function() {
		this._dialog.close()
	},

	__sentinel: null // terminates this class definition
});

com.ibm.rqm.defects.web.ui.view.common.ProgressDialog.create= function(title) {
	var args= {};
	if (title)
		args["_title"]= title;
	
	return new com.ibm.rqm.defects.web.ui.view.common.ProgressDialog(args, null);
};

com.ibm.rqm.defects.web.ui.view.common.ProgressDialog.doRunWithProgress= function(title, progressMonitoredCode) {
	com.ibm.rqm.defects.web.ui.view.common.ProgressDialog.create(title).runWithProgress(progressMonitoredCode);
};

dojo.declare("com.ibm.rqm.defects.web.ui.view.common.ProgressDialog._ProgressMonitor",
			 [com.ibm.team.repository.web.foundation.ProgressMonitor], {

	constructor: function(progressDialog) {
		this._progressDialog= progressDialog;
	},

	// ---- ProgressMonitor implementation ---------------------------------------------------------------------------------

	beginTask: function(name) {
		this._progressDialog._notifyBeginTask(name);
	},

	done: function() {
		this._progressDialog._notifyDone();
	},

	__sentinel: null // terminates this class definition
});

})();
