/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
//-*- tab-width: 4 -*-
//

//

package com.ibm.rational.test.lm.spi.util.topology;

import java.io.IOException;
import java.util.HashMap;

import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.URIConverter;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.emf.ecore.xmi.XMLResource;

import com.ibm.ccl.soa.deploy.core.DeployCoreRoot;
import com.ibm.ccl.soa.deploy.core.Topology;

public class TopologyParser {
	
	private static TopologyParser instance = null;
	
	private TopologyParser() {
	}
	
	public static TopologyParser getInstance() {
		if(instance == null)
			instance = new TopologyParser();
		return instance;
	}
	
    public Topology getTopologyFromXml(String xmlContent) {
    	Topology topology = null;
    	try {
            ResourceSet resourceSet = new ResourceSetImpl();
            Resource resource = resourceSet.createResource(URI.createURI("resource.extension"));
            HashMap<String, Boolean> options = new HashMap<String, Boolean>();
            
            options.put(XMLResource.OPTION_EXTENDED_META_DATA, Boolean.TRUE);
            resource.load(new URIConverter.ReadableInputStream(xmlContent), options);
            
            DeployCoreRoot root = (DeployCoreRoot) resource.getContents().get(0);
            topology = root.getTopology();
        }
        catch(IOException ex) {
            // needs logging...
           ex.printStackTrace();            
        }
        return topology;
    }

}
